#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define len(v) (int)v.size()
#define ft first
#define sc second
#define pb push_back
//#define int ll

typedef long long ll;
typedef long double ld;

using namespace std;

const int B = 1e4;

map<int, vector<ll>> precalc;

void init() {
    precalc[2] = {2};
    precalc[6] = {2, 3, 6};
    precalc[5] = {2, 5};
    precalc[14] = {2, 7, 14};
    precalc[13] = {2, 13};
    precalc[11] = {2, 3, 11};
    precalc[23] = {2, 23};
    precalc[62] = {2, 3, 31, 62};
    precalc[61] = {2, 3, 61};
    precalc[59] = {2, 3, 59};
    precalc[47] = {2, 3, 47};
    precalc[123] = {2, 3, 11, 41, 123};
    precalc[119] = {2, 3, 7, 17, 119};
    precalc[95] = {2, 3, 5, 19, 95};
    precalc[239] = {2, 6, 15, 239};
    precalc[223] = {2, 3, 6, 223};
    precalc[479] = {2, 3, 5, 479};
    precalc[447] = {2, 3, 6, 7, 21, 149, 447};
    precalc[383] = {2, 3, 5, 7, 383};
    precalc[1022] = {2, 3, 5, 7, 10, 13, 14, 73, 146, 511, 1022};
    precalc[1021] = {2, 3, 5, 10, 13, 1021};
    precalc[959] = {2, 3, 7, 137, 959};
    precalc[2039] = {2, 3, 10, 13, 15, 17, 26, 45, 2039};
    precalc[4094] = {2, 6, 10, 11, 23, 45, 46, 89, 178, 2047, 4094};
    precalc[4093] = {2, 6, 10, 11, 45, 4093};
    precalc[4091] = {2, 6, 10, 11, 45, 4091};
    precalc[4087] = {2, 3, 6, 10, 11, 45, 61, 67, 4087};
    precalc[4063] = {2, 3, 6, 10, 11, 13, 15, 17, 26, 45, 239, 4063};
    precalc[4031] = {2, 3, 6, 10, 11, 29, 63, 139, 4031};
    precalc[3967] = {2, 3, 6, 3967};
    precalc[6143] = {2, 3, 5, 18, 19, 35, 78, 6143};
    precalc[14335] = {2, 3, 5, 6, 24, 47, 61, 69, 235, 305, 2867, 14335};
    precalc[262111] = {2, 3, 12, 19, 181, 209, 362, 262111};
    precalc[262079] = {2, 3, 5, 7, 10, 12, 19, 262079};
    precalc[524285] = {2, 3, 5, 14, 19, 23, 47, 71, 79, 97, 115, 142, 158, 181, 209, 235, 362, 418, 485, 724, 1081, 2231, 4559, 5405, 11155, 22795, 104857, 524285};
    precalc[524031] = {2, 3, 6, 10, 15, 19, 37, 111, 119, 126, 4721, 14163, 174677, 524031};
    precalc[16760831] = {2, 3, 10, 11, 19, 31, 33, 91, 123, 137, 182, 203, 239, 692, 3691, 4541, 70129, 882149, 16760831};
}

int get_null(ll n, ll x) {
    ll nc = n;
    int ans = 0;
    while (nc > 0) {
        if (nc % x == 0)
            ans++;
        nc /= x;
    }

    return ans;
}

pair<int, vector<ll>> small(ll n) {
    int cur_ans = 0;
    vector<ll> cur_el;
    for (int i = 2; i <= B; i++) {
        int cur_i = get_null(n, i);
        if (cur_i > cur_ans) {
            cur_ans = cur_i;
            cur_el = {i};
        } else if (cur_i == cur_ans) {
            cur_el.push_back(i);
        }
    }

    return {cur_ans, cur_el};
}

pair<int, vector<ll>> cub(ll n) {
    int cur_ans = 0;
    vector<ll> cur_el;

    for (ll a = 1; a * a * a * a <= n; a++) {
        ll l = a + 1, r = min((ll)1e6, n);
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (mid * mid * mid > n / a)
                r = mid;
            else
                l = mid;
        }

        if (l < B)
            continue;

        int cur_i = get_null(n, l);
        if (cur_ans < cur_i) {
            cur_ans = cur_i;
            cur_el.push_back(l);
        } else if (cur_ans == cur_i) {
            cur_el.push_back(l);
        }
    }

    return {cur_ans, cur_el};
}

vector<ll> two(ll n) {
    vector<ll> ans;
    for (ll i = 1; i * i * i <= n; i++) {
        if (n % i != 0)
            continue;
        ll b = sqrtl(n / i);
        if (b * b * i == n && b > B && b > i)
            ans.push_back(b);
    }
    return ans;
}

pair<int, vector<ll>> solve(ll n) {
    if (precalc.count(n)) {
        return {1, precalc[n]};
    }

    auto res1 = small(n);
    auto res2 = cub(n);
    auto cur_ans = res1;

    if (res1.ft < res2.ft) {
        cur_ans = res2;
    } else if (res1.ft == res2.ft) {
        for (auto x : res2.sc)
            cur_ans.sc.push_back(x);
    }

    if (cur_ans.ft == 2) {
        auto res3 = two(n);
        for (auto x : res3)
            cur_ans.sc.push_back(x);
    }

    sort(cur_ans.sc.begin(), cur_ans.sc.end());
    cur_ans.sc.resize(unique(cur_ans.sc.begin(), cur_ans.sc.end()) - cur_ans.sc.begin());
    return cur_ans;
}

signed main() {
#ifdef LOCAL
    freopen("in/in_D.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        auto ans = solve(n);
        cout << ans.ft << " " << len(ans.sc) << '\n';
        for (auto x : ans.sc)
            cout << x << " ";
        cout << '\n';
    }

//    int cnt = 0;
//    for (int i = 0; i < 61; i++) {
//        for (int j = 0; j < i; j++) {
//            ll x = ((1LL << (i + 1)) - 1) - (1LL << (j));
//            if (small(x).ft == 1) {
////                cout << "Possible " << x << endl;
//
//                bool flag = true;
//                vector<ll> kek;
//                for (ll k = 2; k <= x; k++) {
//                    if (get_null(x, k) == 1) {
//                        kek.push_back(k);
//                    }
//                    if (get_null(x, k) > 1)
//                        flag = false;
//                }
//
//                if (!flag)
//                    continue;
//
//                cout << "precalc[" << x << "] = " << "{";
//                for (int ii = 0; ii < len(kek); ii++) {
//                    if (ii == len(kek) - 1)
//                        cout << kek[ii];
//                    else
//                        cout << kek[ii] << ", ";
//                }
//                cout << "};" << endl;
//                cnt++;
//            }
//        }
//    }
//    cout << cnt << endl;
}