#include <bits/stdc++.h>

#define len(v) (int)v.size()
#define ft first
#define sc second
#define pb push_back
#define int ll

typedef long long ll;
typedef long double ld;

using namespace std;

unordered_map<int, int> d1c;
unordered_map<int, int> d2c;
unordered_map<int, int> xc;
unordered_map<int, int> yc;
set<pair<int, int>> kek;
int n;

pair<int, int> per_d1_d2(int d1, int d2) {
    int x = (d1 + d2) / 2;
    int y = d2 - x;
    return {x, y};
}

bool check_d1_d2(int d1, int d2) {
    auto [x, y] = per_d1_d2(d1, d2);

    int bound = n;
    if (kek.count({x, y}))
        bound += 3;
    if (d1c[d1] + d2c[d2] + xc[x] + yc[y] == bound) {
        return true;
    }

    return false;
}

bool check_x_y(int x, int y) {
    int d1 = x - y;
    int d2 = x + y;

    int bound = n;
    if (kek.count({x, y}))
        bound += 3;

    if (d1c[d1] + d2c[d2] + xc[x] + yc[y] == bound)
        return true;
    return false;
}

signed main() {
#ifdef LOCAL
    freopen("in/in_D.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    while (t--) {
        d1c = unordered_map<int, int>();
        d2c = unordered_map<int, int>();
        xc = unordered_map<int, int>();
        yc = unordered_map<int, int>();
        kek = set<pair<int, int>>();

        cin >> n;
        for (int i = 0; i < n; i++) {
            int x, y;
            cin >> x >> y;
            d1c[x - y] += 1;
            d2c[x + y] += 1;
            xc[x] += 1;
            yc[y] += 1;
            kek.insert({x, y});
        }

        bool flag = false;
        pair<int, int> ans;

        for (auto [d1, cnt]: d1c) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto [d2, cnt2]: d2c) {
                    if ((d1 + d2) % 2 == 1)
                        continue;
                    if (check_d1_d2(d1, d2)) {
                        flag = true;
                        ans = per_d1_d2(d1, d2);
                        break;
                    }
                }
            }
        }

        for (auto& [d2, cnt]: d2c) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto& [d1, cnt2]: d1c) {
                    if ((d1 + d2) % 2 == 1)
                        continue;
                    if (check_d1_d2(d1, d2)) {
                        flag = true;
                        ans = per_d1_d2(d1, d2);
                        break;
                    }
                }
            }
        }

        for (auto [x, cnt]: xc) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto [y, cnt2]: yc) {
                    if (check_x_y(x, y)) {
                        flag = true;
                        ans = {x, y};
                        break;
                    }
                }
            }
        }

        for (auto [y, cnt]: yc) {
            if (flag)
                break;
            if (cnt >= n / 4) {
                for (auto [x, cnt2]: xc) {
                    if (check_x_y(x, y)) {
                        flag = true;
                        ans = {x, y};
                        break;
                    }
                }
            }
        }

        if (flag) {
            cout << "YES" << '\n';
            cout << ans.ft << " " << ans.sc << '\n';
        } else {
            cout << "NO" << '\n';
        }
    }
}