// KTO PROCHITAL TOMU LUCHI DOBRA
#include <bits/stdc++.h>

using namespace std;

int n;
int last_ans;
int cnt = 0;

vector <int> gray_codes(int k) {
    if (k == 1) {
        return {0, 1};
    }
    vector <int> v = gray_codes(k - 1);
    int s = v.size();
    for (int i = s - 1; i >= 0; i--) {
        v.push_back(v[i] | (1 << (k - 1)));
    }
    return v;
}

void ask(int i, int j) {
    assert(1 <= i && i <= j && j <= n);
    assert(++cnt <= 2500);
    cout << i << ' ' << j << endl;
    cin >> last_ans;
    if (last_ans == n) {
        exit(0);
    }
}

void solve(int l, int r) {
    if (l > r) {
        return;
    }
    int k = r - l + 1;
    auto codes = gray_codes(k);
    int i = 0;
    while (true) {
        int nxt = (i + 1) % codes.size();
        int pos = __builtin_ctz(codes[nxt] ^ codes[i]);
        int prev_ans = last_ans;
        ask(l, l + pos);
        if (last_ans > prev_ans) {
            for (int j = 0; j <= pos; j++) {
                prev_ans = last_ans;
                ask(l + j, l + j);
                if (last_ans < prev_ans) {
                    ask(l + j, l + j);
                    solve(l, l + j - 1);
                    solve(l + j + 1, r);
                    return;
                }
            }
        }
        i = nxt;
    }
}

int main() {
#ifdef LOCAL
//    freopen("in/in_V.txt", "r", stdin);
#endif
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
    cin >> n;
    cin >> last_ans;
    solve(1, n);
    return 0;
}