#include <bits/stdc++.h>

#define len(v) (int)v.size()
#define ft first
#define sc second
#define pb push_back

typedef long long ll;
typedef long double ld;

using namespace std;

int main() {
#ifdef LOCAL
    freopen("in/in_D.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    string s, f;
    getline(cin, s);
    getline(cin, f);

    int n = len(s), m = len(f);

    for (int i = 0; i < n; i++) {
        if ('A' <= s[i] && s[i] <= 'Z')
            s[i] = 'a' + (s[i] - 'A');
    }

    for (int i = 0; i < m; i++) {
        if ('A' <= f[i] && f[i] <= 'Z')
            f[i] = 'a' + (f[i] - 'A');
    }

    vector<vector<bool>> dp(n + 1, vector<bool> (m + 1, false));
    dp[0][0] = 1;

    set<char> k = {'a', 'e', 'i', 'o', 'u', 'y'};
    for (int i = 0; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (i > 0 && s[i - 1] == f[j - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1]);
            if (k.count(f[j - 1]))
                dp[i][j] = max(dp[i][j], dp[i][j - 1]);
        }
    }

    bool flag = false;

    for (int j = 0; j <= m; j++)
        if (dp[n][j])
            flag = true;

    if (flag)
        cout << "Same" << endl;
    else
        cout << "Different" << endl;
}