#include <bits/stdc++.h>

using namespace std;

// #define int long long

struct node {
    int l, r, mn = 0, add = 0;
};

const int N = 2e5 + 10;

node st[4 * N];
bool pref[N], suff[N];

void push(int v) {
    if (st[v].add == 0) {
        return;
    }
    st[v].mn += st[v].add;
    if (st[v].l == st[v].r) {
        st[v].add = 0;
        return;
    }
    st[2 * v + 1].add += st[v].add;
    st[2 * v + 2].add += st[v].add;
    st[v].add = 0;
}

void build(int v, int l, int r) {
    st[v].l = l;
    st[v].r = r;
    st[v].add = 0;
    st[v].mn = 0;
    if (l == r) {
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m + 1, r);
}

void upd(int v, int l, int r, int val) {
    push(v);
    if (st[v].l > r || st[v].r < l) {
        return;
    }
    if (st[v].l >= l && st[v].r <= r) {
        st[v].add += val;
        push(v);
        return;
    }
    upd(2 * v + 1, l, r, val);
    upd(2 * v + 2, l, r, val);
    st[v].mn = min(st[2 * v + 1].mn, st[2 * v + 2].mn);
}

void solve() {
    int n;
    cin >> n;
    map<int, int> id;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        id[a[i]] = 0;
    }
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        id[b[i]] = 0;
    }
    int m = 0;
    for (auto & x : id) {
        x.second = m++;
    }
    for (auto & x : a) {
        x = id[x];
    }
    for (auto & x : b) {
        x = id[x];
    }
    build(0, 0, m - 1);
    for (int i = 0; i < n; ++i) {
        upd(0, 0, a[i], -1);
        upd(0, 0, b[n - 1 - i], 1);
        if (st[0].mn >= 0) {
            pref[i] = true;
        }
    }
    build(0, 0, m - 1);
    for (int i = n - 1; i > -1; --i) {
        upd(0, 0, a[i], 1);
        upd(0, 0, b[n - 1 - i], -1);
        if (st[0].mn >= 0) {
            suff[i] = true;
        }
    }
    vector<int> ans;
    if (pref[n - 1]) {
        ans.push_back(0);
    }
    for (int k = 1; k < n; ++k) {
        if (pref[n - 1 - k] && suff[n - k]) {
            ans.push_back(k);
        }
    }
    if (suff[0]) {
        ans.push_back(n);
    }
    cout << ans.size() << "\n";
    for (auto x : ans) {
        cout << x << ' ';
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
}