#include <bits/stdc++.h>

using namespace std;

#define int long long

bool canHit(int x, int y, int qx, int qy) {
    return qx == x || qy == y || (x - y == qx - qy) || (x + y == qx + qy);
}

void intersect(int x, int y, int x1, int y1, set <pair <int, int> > *p) {
    *p = {{x1, y}, {x1 + y1 - y, y}, {x1 + y - x1, y},
          {x, y1}, {x, y1 + x - x1}, {x, y1 + x1 - x},
          {x1, x1 - x + y}, {y1 + x - y, y1},
          {x1, x + y - x1}, {x + y - y1, y1}};
    if ((x1 - y1 - x + y) % 2 == 0) {
        (*p).insert({x + (x1 - y1 - x + y) / 2, y - (x1 - y1 - x + y) / 2});
    }
    if ((x - y - x1 + y1) % 2 == 0) {
        (*p).insert({x1 + (x - y - x1 + y1) / 2, y1 - (x - y - x1 + y1) / 2});
    }
}

void intersectP(int x, int y, set <pair <int, int> > *p) {
    set <pair <int, int> > buffer;
    for (auto q : *p) {
        if (canHit(q.first, q.second, x, y)) {
            buffer.insert(q);
        }
    }
    *p = buffer;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n; cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    int l = 0, r = 0;
    int ans1 = 0, ans2 = 0;
    while (l < a.size() && r < b.size()) {
        if (a[l] < b[r]) {
            l++;
        }
        else {
            l++; r++; ans1++;
        }
    }
    l = n - 1; r = n - 1;
    while (l >= 0 && r >= 0) {
        if (a[l] > b[r]) {
            l--;
        }
        else {
            r--; l--; ans2++;
        }
    }
    ans2 = n - ans2;
    cout << ans1 - ans2 + 1 << endl;
    for (int i = ans2; i <= ans1; i++) {
        cout << i << " ";
    } cout << endl;
}