#include <iostream>
#include <cassert>
#include <vector>

using namespace std;

int n, l;
int cnt;

int query(int i, int j) {
    ++cnt;
    assert(i <= j);
    assert(1 <= i && i <= n);
    assert(1 <= j && j <= n);
    assert(cnt <= 2500);
    while (cnt > 2500) {}
    cout << i << " " << j << endl;
    int k;
    cin >> k;
    if (k == n) {
        exit(0);
    }
    return k;
}

int state[200];

int get_bit(int m, int k) {
    return ((m >> k) & 1);
}

int main() {
    cin >> n >> l;
    if (l == n) {
        assert(false);
    }

    auto check = [&] (int i) {
        int was = l;
        l = query(i, i);
        if (l == was - 1) {
            query(i, i);
            return true;
        }
        return false;
    };

    for (;;) {
        for (int i = 1; i <= n; ++i) {
            if (check(i)) continue;

            vector<int> history = {i};
            // иначе она не горела
            int num = n - i + 1;

            for (int mask = 0; mask < (1 << num); ++mask) {
                for (int j = i, b = 0; j <= n; ++j, ++b) {
                    state[j] = get_bit(mask, b);
                }
                for (int h: history) {
                    state[h] ^= 1;
                }
                for (int j = i; j <= n; ++j) {
                    if (state[j]) {
                        l = query(i, j);
                        history.push_back(j);
                    }
                }
                if (check(i)) {
                    break;
                }
                history.push_back(i);
            }
        }
    }
    assert(false);

    return 0;
}