#include <bits/stdc++.h>

using namespace std;
#define int long long

using vi = vector<int>;
using pii = pair<int, int>;
using vpi = vector<pii>;

const int INF = (int)1e18;

char get(char c) {
    if ('A' <= c && c <= 'Z') {
        c -= 'A';
        c += 'a';
    }
    return c;
}

bool v(char c) {
    c = get(c);
    return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u' || c == 'y';
}

bool check(const pii p1,const pii p2) {
    int d1 = abs(p1.first - p2.first);
    int d2 = abs(p1.second - p2.second);
    return p1.first == p2.first || (p1.second == p2.second) || d1 == d2;
}

bool good(const vpi& points, pii point) {
    for (const auto & p : points) {
        if (!check(p, point)) {
            return false;
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vpi v(n);
    for (auto & [x, y] : v) {
        cin >> x >> y;
    }

    int x1 = v[0].first;
    int y1 = v[0].second;
    if (good(v, v[0])) {
        cout << "YES" << endl;
        cout << v[0].first << " " << v[0].second << endl;
        return;
    }
    int x2 = -INF, y2 = -INF;
    for (int i = 1; i < n; i++) {
        if (!check(v[0], v[i])) {
            x2 = v[i].first;
            y2 = v[i].second;
            break;
        }
    }
    vector<pair<int, int>> candidates;
    candidates.emplace_back(x1, y2);
    candidates.emplace_back(x2, y1);

    candidates.emplace_back(x2, y1 + (x2 - x1));
    candidates.emplace_back(x2, y1 - (x2 - x1));

    candidates.emplace_back(x1, y2 + (x1- x2));
    candidates.emplace_back(x1, y2 - (x1- x2));

    candidates.emplace_back(x1 + (y2 - y1), y2);
    candidates.emplace_back(x1 - (y2 - y1), y2);

    candidates.emplace_back(x2 - (y1 - y2), y1);
    candidates.emplace_back(x2 + (y1 - y2), y1);

    if ((x1 + x2 + y2 - y1) % 2 == 0 && (x2-x1 + y1+y2) % 2 == 0) {
        int d1 = (x1 + x2 + y2 - y1);
        int d2 = (x2-x1 + y1+y2);
        candidates.emplace_back(d1 / 2, d2 / 2);
    }
    if ((x1 + x2 + y1 - y2) % 2 == 0 && (x1 - x2 + y1 + y2) % 2 == 0) {
        int d1 = (x1 + x2 + y1 - y2);
        int d2 = (x1 - x2 + y1 + y2);
        candidates.emplace_back(d1/2, d2/2);
    }

//    cout << "check" << endl;
//    cout << check({1, 1}, {4, 2}) << endl;
    for (auto & p : candidates) {
        if (good(v, p)) {
            for (int i = 0; i < n; i++) {
                assert(check(v[i], p));
            }

            cout << "YES" << endl;
            cout << p.first << " " << p.second << endl;
            return;
        }
    }
    cout << "NO" << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int nt;
    cin >> nt;
    while (nt--) {
        solve();
    }

}
