#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}


void solve() {
    int n;
    cin >> n;
    vector<int> ca(n), cb(n);
    for (auto &i: ca) cin >> i, i--;
    for (auto &i: cb) cin >> i, i--;
    vector<vector<int>> pos_by_c(n);
    for (int i = 0; i < n; i++) {
        pos_by_c[ca[i]].emplace_back(i);
    }
    string res = string(n, 'S');
    vector<int> pos(n);
    iota(pos.begin(), pos.end(), 0);
    int left = 0;
    for (auto &b: cb) {
        left++;
        bool apply = false;
        if (pos_by_c[b].empty()) {
            cout << "NO\n";
            return;
        }
        int uk = 0;
        do {
            auto s = res;
            s.insert(s.begin() + left, 'C');
            while (uk + 1 < pos_by_c[b].size() && pos[pos_by_c[b][uk + 1]] < left) {
                uk++;
            }
//            cout << "TRY: " << left << ' ' << pos[pos_by_c[b][uk]] << ' ' << s.substr(pos[pos_by_c[b][uk]]) << '\n';
            if (pos[pos_by_c[b][uk]] >= left) {
                left++;
                continue;
            }
            int cnt = 0;
            for (int i = pos[pos_by_c[b][uk]]; i <= left; i++) {
                if(s[i] == 'S') cnt++;
                else cnt--;
                if (cnt < 0) break;
            }
            if (cnt == 0) {
                pos_by_c[b].erase(pos_by_c[b].begin() + uk);
                res = s;
                apply = true;
                break;
            }
            left++;
        } while (left <= res.size());
//        cout << b << " | " << res << '\n';
        if (!apply) {
            cout << "NO\n";
            return;
        }
        for (auto &i: pos) {
            if (i >= left)
                i++;
        }
    }
    cout << "YES\n";
    cout << res << '\n';
}

signed main() {
    solve();
}