#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

void solve() {
    int last_x, n;
    cin >> n >> last_x;
    if (last_x == n) { return; }
    for (int i = 0; i < n; ++i) {
        int gray = 0;
        for (int j = 1; j <= (1 << (n - i)); ++j) {
            int s = (j - (j & (j - 1)));
            gray ^= s;
            int cb = __builtin_ctz(s);
            cout << (i + 1) << " " << (i + 1 + cb) << endl;
            int x;
            cin >> x;
            if (x == n) { return; }
            if (cb == 0 && x != last_x) {
                if (x > last_x) {
                    last_x = x;
                    break;
                } else {
                    cout << i + 1 << " " << i + 1 << endl;
                    cin >> x;
                    if (x == n) { return; }
                    assert(x == last_x);
                    break;
                }
            }
            last_x = x;
        }
    }
}

signed main() {
    solve();
}