#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

char get(char c) {
    if ('A' <= c && c <= 'Z') return c - 'A' + 'a';
    return c;
}

void solve() {
   int n;
   cin >> n;
   vector<int> a(n);
   for (auto &e : a) cin >> e;
   vector<int> b(n);
   for (auto &e : b) cin >> e;
   int tmax = 0, tmin = n;
   set<int> as;
   for (auto &e : a) as.insert(e);
   for (auto &e : b) if (as.lower_bound(e) != as.end()) {
       tmax += 1;
       as.erase(as.lower_bound(e));
   }
   as.clear();
   for (auto &e : a) as.insert(-e);
   reverse(b.begin(), b.end());
   for (auto &e : b) if (as.lower_bound(-e) != as.end()) {
       tmin -= 1;
       as.erase(as.lower_bound((-e)));
   }
   cout << tmax - tmin + 1 << endl;
   for (int i = tmin; i <= tmax; ++i) {
       cout << i << ' ';
   }
   cout << endl;
}

signed main() {
    solve();
}