// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <string>
#include <set>

using namespace std;

bool isLowerCase(char a) {
	return (a >= 'a' && a <= 'z');
}

bool isUpperCase(char a) {
	return (a >= 'A' && a <= 'Z');
}

char toLowerCase(char a) {
	if (isUpperCase(a)) {
		return a - ('A' - 'a');
	}
	return a;
}

bool isEqual(char a, char b) {
	int diff = 'A' - 'a';
	if (isUpperCase(a)) {
		a = toLowerCase(a);
	}
	if (isUpperCase(b)) {
		b = toLowerCase(b);
	}

	return a == b;
}


int main()
{
	string str1;
	string str2;
	set<char> vowels = { 'a', 'e', 'i', 'o', 'u', 'y' };

	cin >> str1;
	cin >> str2;
		
	for (int i = 0, j = 0; j < str2.size();) {
		if (!isEqual(str1[i], str2[j])) {
			if (vowels.find(toLowerCase(str1[i])) != vowels.end() && vowels.find(toLowerCase(str2[j])) != vowels.end()) {
				while (vowels.find(toLowerCase(str2[j])) != vowels.end() && !isEqual(str1[i], str2[j])) {
					j++;
				}
				if (isEqual(str1[i], str2[j])) {
					continue;
				}
				cout << "Different";
				return 0;
			}
			else if (vowels.find(toLowerCase(str1[i])) == vowels.end() && vowels.find(toLowerCase(str2[j])) == vowels.end()) {
				cout << "Different";
				return 0;
			}
			else if (vowels.find(toLowerCase(str2[j])) != vowels.end()) {
				j++;
			}
		}
		else {
			i++;
			j++;
		}
	}

	cout << "Same";
}




/*
int main()
{
	string str1;
	string str2;
	set<char> vowels = { 'a', 'e', 'i', 'o', 'u', 'y' };

	cin >> str1;
	cin >> str2;

	for (int i = 0, j = 0; j < str2.size();) {
		if (str1[i] != str2[j]) {
			if (vowels.find(str1[i]) != vowels.end() && vowels.find(str2[j]) != vowels.end()) {
				while (vowels.find(str2[j]) != vowels.end() && str2[j] != str1[i]) {
					j++;
				}
				if (str2[j] == str1[i]) {
					continue;
				}
				cout << "Different";
				return 0;
			}
			else if (vowels.find(str1[i]) == vowels.end() && vowels.find(str2[j]) == vowels.end()) {
				cout << "Different";
				return 0;
			}
			else if (vowels.find(str2[j]) != vowels.end()) {
				j++;
			}
		}
		else {
			i++;
			j++;
		}
	}

	cout << "Same";
}*/