#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

void solve() {
    int n; cin >> n;
    vector<pair<int, int>> cords(n);
    for (int i = 0; i < n; i++) {
        cin >> cords[i].first >> cords[i].second;
    }
    int vert = cords[0].first;
    int hor = cords[0].second;
    int diag1 = cords[0].first - cords[0].second;
    int diag2 = cords[0].first + cords[1].second;
    set<pair<int, int>> st;
    for (int i = 1; i < n; i++) {
        set<pair<int, int>> nst;
        for (auto p : st) {
            if (p.first == cords[i].first || p.second == cords[i].second || abs(p.first - cords[i].first) == abs(p.second - cords[i].second)) {
                nst.insert(p);
            }
        }
        st = nst;
        if (vert != INF && vert != cords[i].first) {
            st.insert({cords[0].first, cords[i].second});
            st.insert({cords[0].first, cords[i].second + (cords[i].first - cords[0].first)});
            st.insert({cords[0].first, cords[i].second - (cords[i].first - cords[0].first)});
            vert = INF;
        }

        if (hor != INF && hor != cords[i].second) {
            st.insert({cords[i].first, cords[0].second});
            st.insert({cords[i].first + (cords[i].second - cords[0].second), cords[0].second});
            st.insert({cords[i].first - (cords[i].second - cords[0].second), cords[0].second});
            hor = INF;
        }

        if (diag1 != INF && diag1 != cords[i].first - cords[i].second) {
            st.insert({cords[i].first, cords[0].second + (cords[i].first - cords[0].first)});
            st.insert({cords[0].first + (cords[i].second - cords[0].second), cords[i].second});
            if ((cords[0].first + cords[0].second) % 2 == (cords[i].first + cords[i].second) % 2) {
                int dx = cords[i].first - cords[0].first;
                int dy = cords[i].second - cords[0].second;
                st.insert({(cords[0].first + dx + dy) / 2, cords[0].second + ((cords[0].first + dx + dy) / 2 - cords[0].first)});
            }
            diag1 = INF;
        }

        if (diag2 != INF && diag2 != cords[i].first + cords[i].second) {
            st.insert({cords[i].first, cords[0].second - (cords[i].first - cords[0].first)});
            st.insert({cords[0].first - (cords[i].second - cords[0].second), cords[i].second});
            if ((cords[0].first + cords[0].second) % 2 == (cords[i].first + cords[i].second) % 2) {
                int dx = cords[i].first - cords[0].first;
                int dy = cords[i].second - cords[0].second;
                st.insert({(cords[0].first + dx - dy) / 2, cords[0].second - (cords[0].first + dx - dy) / 2 - cords[0].first});
            }
            diag2 = INF;
        }

    }

    if (vert != INF) {
        cout << "YES\n";
        cout << vert << ' ' << 0 << '\n';
    } else if (hor != INF) {
        cout << "YES\n";
        cout << 0 << ' ' << hor << '\n';
    } else if (diag1 != INF) {
        cout << "YES\n";
        cout << diag1 << ' ' << 0 << '\n';
    } else if (diag2 != INF) {
        cout << "YES\n";
        cout << diag2 << ' ' << 0 << '\n';
    } else {
        if (st.empty()) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
            cout << st.begin()->first << ' ' << st.begin()->second << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int t; cin >> t; while (t--)
    solve();
    return 0;
}
