#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

void solve() {
    int n; cin >> n;
    vector<pair<int, int>> cords(n);
    for (int i = 0; i < n; i++) {
        cin >> cords[i].first >> cords[i].second;
    }
    int vert = cords[0].first;
    int hor = cords[0].second;
    int diag1 = cords[0].first - cords[0].second;
    int diag2 = cords[0].first + cords[0].second;
    set<pair<int, int>> dots;
    for (int i = 1; i < n; i++) {
        if (cords[i].first != cords[0].first) {
            vert = INF;
        }
        if (cords[i].second != cords[0].second) {
            hor = INF;
        }
        if (cords[i].first - cords[i].second != diag1) {
            diag1 = INF;
        }
        if (cords[i].first + cords[i].second != diag2) {
            diag2 = INF;
        }
        if (cords[i].first != cords[0].first && cords[i].second != cords[0].second && abs(cords[i].first - cords[0].first) != abs(cords[i].second - cords[0].second)) {
            dots.insert({cords[0].first, cords[i].second});
            dots.insert({cords[i].first, cords[0].second});

            dots.insert({cords[0].first, cords[i].second + (cords[i].first - cords[0].first)});
            dots.insert({cords[0].first, cords[i].second - (cords[i].first - cords[0].first)});
            dots.insert({cords[i].first, cords[0].second + (cords[i].first - cords[0].first)});
            dots.insert({cords[i].first, cords[0].second - (cords[i].first - cords[0].first)});

            dots.insert({cords[i].first + (cords[0].second - cords[i].second), cords[0].second});
            dots.insert({cords[i].first - (cords[0].second - cords[i].second), cords[0].second});
            dots.insert({cords[0].first + (cords[i].second - cords[0].second), cords[i].second});
            dots.insert({cords[0].first - (cords[i].second - cords[0].second), cords[i].second});

            if ((cords[i].first + cords[i].second) % 2 == (cords[0].first + cords[0].second) % 2) {
                int dy = cords[i].second - cords[i].second;
                dots.insert({(cords[0].first + cords[i].first + dy) / 2, cords[0].second + ((cords[0].first + cords[i].first + dy) / 2 - cords[0].first)});
                dots.insert({(cords[0].first + cords[i].first - dy) / 2, cords[0].second - ((cords[0].first + cords[i].first - dy) / 2 - cords[0].first)});
            }
            break;
        }
    }
    if (vert != INF) {
        cout << "YES\n";
        cout << vert << ' ' << 0 << '\n';
    } else if (hor != INF) {
        cout << "YES\n";
        cout << 0 << ' ' << hor << '\n';
    } else if (diag1 != INF) {
        cout << "YES\n";
        cout << diag1 << ' ' << 0 << '\n';
    } else if (diag2 != INF) {
        cout << "YES\n";
        cout << diag2 << ' ' << 0 << '\n';
    } else {
        for (auto p : dots) {
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                if (p.first == cords[i].first || p.second == cords[i].second || abs(p.first - cords[i].first) == abs(p.second - cords[i].second)) {
                    cnt++;
                }
            }
            if (cnt == n) {
                cout << "YES\n";
                cout << p.first << ' ' << p.second << '\n';
                return;
            }
        }
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int t; cin >> t; while (t--)
    solve();
    return 0;
}
