#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

#define int long long

int qp(int a, int k, int mod) {
  int res = 1;
  while (k) {
    if (k & 1) {
      res = res * a % mod;
    }
    a = a * a % mod;
    k >>= 1;
  }
  return res;
}

signed main() {
  int d;
  cin >> d;
  while (d % 2 == 0) {
    d /= 2;
  }
  while (d % 5 == 0) {
    d /= 5;
  }
  int t = 1;
  int x = 0;
  for (int i = 0; i < d; ++i) {
    x = (x * 10 % d + 1) % d;
  }
  int r = x;
  while (r != 0) {
    r = (r * qp(10, d, d) % d + x) % d;
    ++t;
  }
  for (int i = 0; i < d * t; ++i) {
    cout << "1";
  }
  cout << "000";
  cout << '\n';
  return 0;
}
/*
Shrm-el-Shikh
Sharm-el-Sheikh
*/