#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

const int N = 100;

int n;
int a[N];
int b[N];

vector<int> st;
string ans;

void solve(int i, int j) {
  if (j == n) {
    cout << "YES\n";
    cout << ans << '\n';
    exit(0);
  }
  if (true) {
    if (!st.empty() && st.back() == b[j]) {
      ans.push_back('C');
      st.pop_back();
      solve(i, j + 1);
      st.push_back(b[j]);
      ans.pop_back();
    }
    if (i < n) {
      ans.push_back('S');
      st.push_back(a[i]);
      solve(i + 1, j);
      st.pop_back();
      ans.pop_back();
    }
  } else {
    if (i < n) {
      ans.push_back('S');
      st.push_back(a[i]);
      solve(i + 1, j);
      st.pop_back();
      ans.pop_back();
    }
    if (!st.empty() && st.back() == b[j]) {
      ans.push_back('C');
      st.pop_back();
      solve(i, j + 1);
      st.push_back(b[j]);
      ans.pop_back();
    }
  }
}

signed main() {
  srand(777);
  cin >> n;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }
  for (int i = 0; i < n; ++i) {
    cin >> b[i];
  }
  solve(0, 0);
  cout << "NO\n";
  return 0;
}
/*
4
4 1 2 2
1 2 4 2
*/