#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

const int N = 512;

int n, p, m;
int dp[N][N][N];

int sum(int x, int y) {
  return x + y < m ? x + y : x + y - m;
}

signed main() {
  cin >> n >> p >> m;
  for (int s = 0; s < N; ++s) {
    dp[0][0][s] = 1;
  }
  for (int i = 1; i < N; ++i) {
    for (int x = 0; x < N; ++x) {
      for (int s = 1; s < N; ++s) {
        if (i >= s) {
          dp[i][x][s] = sum(dp[i][x][s - 1], dp[i - s][x ^ s][s]);
        } else {
          dp[i][x][s] = dp[i][x][s - 1];
        }
      }
    }
  }
  cout << dp[n - p][p][N - 1] << '\n';
  return 0;
}