#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

int main() {
  string s, t;
  cin >> s >> t;
  for (int i = 0; i < SZ(s); ++i) {
    if (s[i] != '-') {
      s[i] = tolower(s[i]);
    }
  }
  for (int i = 0; i < SZ(t); ++i) {
    if (t[i] != '-') {
      t[i] = tolower(t[i]);
    }
  }
  set<char> v = {'a', 'e', 'i', 'o', 'u', 'y'};
  int a = 0, b = 0;
  for (int i = 0; i < SZ(s); ++i) {
    a += !v.count(s[i]);
  }
  for (int i = 0; i < SZ(t); ++i) {
    b += !v.count(t[i]);
  }
  if (a != b) {
    cout << "Different\n";
    return 0;
  }
  int i = 0, j = 0;
  for (; i < SZ(s); ++i) {
    while (j < SZ(t) && s[i] != t[j]) {
      if (!v.count(t[j]) || j >= SZ(t) - 1) {
        cout << "Different\n";
        return 0;
      }
      ++j;
    }
    ++j;
  }
  cout << "Same\n";
  return 0;
}
/*
Shrm-el-Shikh
Sharm-el-Sheikh
*/