#include <bits/stdc++.h>

#define endl "\n"

#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<int> s(n), c(n), h;
    for(int i = 0; i < n; ++i) {cin >> s[i];}
    for(int i = 0; i < n; ++i) {cin >> c[i];}
    string res;
    int p = 0;
    for(int i = 0; i < n; ++i) {
        h.push_back(s[i]);
        res += 'S';
        while(!h.empty() && h.back() == c[p]) {
            ++p; h.pop_back();
            res += 'C';
        }
    }
    if(p == n) {
        cout << "YES\n" << res;
    }
    else {
        cout << "NO";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}