#pragma GCC optimize("Ofast", "inine", "no-stack-protector")
 
#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
 
// #define endl "\n"
 
// #define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;
 
template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }
 
    return false;
}
 
template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }
 
    return false;
}
 
template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
 
    return in;
}
 
template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
 
    return out;
}
 
void solve() {
    int n;
    cin >> n;
 
    vector<int> a(n);
    cin >> a;
 
    vector<int> b(n);
    cin >> b;
 
    vector<pair<int, std::vector<int>>> checker;
    set<pair<int, std::vector<int>>> used;
    vector<pair<int, char>> parent;
 
    int i = 0;
    vector<int> good(n + 1, -1);
    vector<int> st;
    checker.push_back({0, st});
    parent.push_back({-1, '0'});
 
    while (i < checker.size()) {
        auto v = checker[i++];
        good[v.first] = i - 1;

        if (good[n] != -1) {
            break;
        }
 
        used.insert(v);
 
        int ind = v.first + v.second.size();
        if (ind < n) {
            v.second.push_back(a[ind]);
            checker.push_back({v.first, v.second});
 
            if (used.count(checker.back()) != 0) {
                checker.pop_back();
            } else {
                parent.push_back({i - 1, 'S'});
            }
 
            v.second.pop_back();
        }
 
        if (v.second.size() != 0) {
            if (v.second.back() == b[v.first]) {
                v.second.pop_back();
                checker.push_back({v.first + 1, v.second});
 
                if (used.count(checker.back()) != 0) {
                    checker.pop_back();
                } else {
                    parent.push_back({i - 1, 'C'});
                }
 
            }
        }
    }
 
    string ans = "";
    int ind = good[n];
    // cout << ind << endl;
    // return;
 
 
    if (good[n] != -1) {
        cout << "YES\n";
    } else {
        cout << "NO\n";
        return;
    }
 
    while (ind != 0) {
        ans += parent[ind].Y;
        ind = parent[ind].X;
    }
 
    reverse(all(ans));
    cout << ans << endl;
}
 
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
 
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
 
    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }
 
    return 0;
}