#pragma GCC optimize("Ofast", "inine", "no-stack-protector")

#include <bits/stdc++.h>

#define endl "\n"

// #define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

vector<int> count_for_suffix(const vector<int> &a, const vector<int> &b) {
    int n = a.size();

    vector<int> position_of_lower(n, 0);

    for (int i = 0; i < n; i++) {
        int it = a[i];
        position_of_lower[i] = lower_bound(all(b), it) - b.begin() - 1;
    }

    vector<int> can_be_suffix(n + 1, 0);
    can_be_suffix[0] = 1;
    int max_size = n;
    for (int len = 1; len <= n; ++len) {
        rmin(max_size, position_of_lower[n - len] + len);
        
        if (max_size >= len) {
            can_be_suffix[len] = 1;
        } else {
            break;
        }
    }

    return can_be_suffix;
}

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    cin >> a;

    vector<int> b(n);
    cin >> b;

    auto left = count_for_suffix(a, b);

    for (auto &it : a) {
        it *= -1;
    }

    for (auto &it : b) {
        it *= -1;
    }

    reverse(all(a));
    reverse(all(b));

    auto right = count_for_suffix(a, b);
    // cout << left << endl;
    // cout << right << endl;
    // return;
    vector<int> answers;

    for (int cnt = 0; cnt <= n; ++cnt) {
        if (left[cnt] && right[n - cnt]) {
            answers.push_back(cnt);
        }
    }

    cout << answers.size() << endl;
    cout << answers << endl; 
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}