#include <bits/stdc++.h>

#define endl "\n"

#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

void solve() {
    set<char> vowels = {'a', 'e', 'i', 'o', 'y', 'u'};

    string bad;
    cin >> bad;

    string good;
    cin >> good;

    for (auto &it : bad) {
        it = tolower(it);
    }

    for (auto &it : good) {
        it = tolower(it);
    }

    int l = 0;
    int r = 0;

    while (l < bad.size() && r < good.size()) {
        if (good[r] == bad[l]) {
            ++l, ++r;
        } else {
            if (vowels.count(good[r]) != 0) {
                ++r;
            } else {
                cout << "Different\n";
                return;
            }
        }
    }
    if (l == bad.size() && r == good.size()) {
        cout << "Same\n";
        return;
    }

    if (l != bad.size()) {
        cout << "Different\n";
        return;
    }

    for (int i = r; i < good.size(); i++) {
        if (vowels.count(good[i]) == 0) {
            cout << "Different\n";
            return;
        }
    }


    cout << "Same\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}