#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

using vert = pair<int, int>;

vector<vert> q;

vector<vert> check(vert a)
{
  vector<vert> res;
  for (auto i : q)
  {
    if (a.first != i.first && a.second != i.second && abs(a.first - i.first) != abs(a.second - i.second))
    {
      res.push_back(i);
    }
  }
  return res;
}

int main()
{
  int N;
  cin >> N;
  for (int it = 0; it < N; it++)
  {
    int n;
    cin >> n;
    q.resize(n);
    for (int i = 0; i < n; i++)
    {
      cin >> q[i].first >> q[i].second;
    }
    vector<vert> unused = check(q[0]);
    if (unused.size() == 0)
    {
      cout << "YES" << endl
           << q[0].first << " " << q[0].second << endl;
      continue;
    }

    vert a1 = q[0];
    vert a2 = unused[0];
    int x1 = a1.first, x2 = a2.first, y1 = a1.second, y2 = a2.second;
    vector<vert> av;
    av.push_back({x1, y2});
    av.push_back({x2, y1});

    av.push_back({x1, y2 - (x2 - x1)});
    av.push_back({x1, y2 + (x2 - x1)});
    av.push_back({x2, y1 - (x2 - x1)});
    av.push_back({x2, y1 + (x2 - x1)});
    av.push_back({x1 - (y2 - y1), y2});
    av.push_back({x1 + (y2 - y1), y2});
    av.push_back({x2 - (y2 - y1), y1});
    av.push_back({x2 + (y2 - y1), y1});

    string ANS = "NO";
    for (auto a : av)
    { 
      ANS = "YES";
      for (auto i : q)
      {
        if (a.first != i.first && a.second != i.second && abs(a.first - i.first) != abs(a.second - i.second))
        {
          ANS = "NO";
        }
      }
      if(ANS == "YES"){
        cout <<ANS<<endl<< a.first << " " << a.second << endl;
        break;
      }
    }
    if(ANS == "NO")
    cout << "NO" <<endl;
  }
}