#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
 
using vert = pair<int, int>;
 
vector<vert> q;
 
vector<vert> check(vert a)
{
  vector<vert> res;
  for (auto i : q)
  {
    if (a.first != i.first && a.second != i.second && abs(a.first - i.first) != abs(a.second - i.second))
    {
      res.push_back(i);
    }
  }
  return res;
}
 
int main()
{
  int N;
  cin >> N;
  for (int it = 0; it < N; it++)
  {
    int n;
    cin >> n;
    q.resize(n);
    for (int i = 0; i < n; i++)
    {
      cin >> q[i].first >> q[i].second;
    }
    if(n==1){
      cout<<"YES"<<endl<<q[0].first<<" "<<q[0].second<<endl;
      continue;
    }
 
    vert a1 = q[0];
    vert a2 = q[1];
    int x1 = a1.first, x2 = a2.first, y1 = a1.second, y2 = a2.second;
    vector<vert> av;
    av.push_back({x1, y2});
    av.push_back({x2, y1});
    av.push_back({x1, y1});
    av.push_back({x2, y2});
 
    av.push_back({x1, y2 - (x2 - x1)});
    av.push_back({x1, y2 + (x2 - x1)});
    av.push_back({x2, y1 - (x2 - x1)});
    av.push_back({x2, y1 + (x2 - x1)});
    av.push_back({x1 - (y2 - y1), y2});
    av.push_back({x1 + (y2 - y1), y2});
    av.push_back({x2 - (y2 - y1), y1});
    av.push_back({x2 + (y2 - y1), y1});
 
    if((x1 + y1)%2 == (x2+y2)%2){
      if(x1%2 == x2%2){
        int xc = (x1+x2)/2;
        int yc = (y1+y2)/2;
        int x3 = xc + (yc - y1);
        int y3 = yc + (xc - x1);
        int x4 = xc - (yc - y1);
        int y4 = yc - (xc - x1); 
        av.push_back({x3, y3});
        av.push_back({x4, y4});
      } else {
         
        int xc = (x1+x2);
        int yc = (y1+y2);
        int x3 = xc + (yc - y1*2);
        int y3 = yc + (xc - x1*2);
        int x4 = xc - (yc - y1*2);
        int y4 = yc - (xc - x1*2); 
        av.push_back({x3/2, y3/2});
        av.push_back({x4/2, y4/2});
      }
    }
    string ANS = "NO";
    for (auto a : av)
    { 
      ANS = "YES";
      for (auto i : q)
      {
        if (a.first != i.first && a.second != i.second && abs(a.first - i.first) != abs(a.second - i.second))
        {
          ANS = "NO";
        }
      }
      if(ANS == "YES"){
        cout <<ANS<<endl<< a.first << " " << a.second << endl;
        break;
      }
    }
    if(ANS == "NO")
    cout << "NO" <<endl;
  }
}