#include <bits/stdc++.h>
#define int long long
using namespace std;
const int N = 100005;
int x[N], y[N];
int n;
void cross(vector<pair<int, int>>& v, int i, int j, int k)
{
    if(x[i] == x[j])
    {
        v.push_back({x[i], x[k] + y[k] - x[i]});
        v.push_back({-x[i], y[k] - x[k] - x[i]});
        v.push_back({-x[i], x[k] + y[k] + x[i]});
        v.push_back({x[i], y[k] - x[k] + x[i]});
        v.push_back({x[i], y[k]});
    }
    else
    {
        v.push_back({x[i], y[j]});
        v.push_back({x[j], y[i]});
    }
    if(y[i] == y[j])
    {
        v.push_back({x[k] + y[k] - y[i], y[i]});
        v.push_back({y[k] - x[k] - y[i], -y[i]});
        v.push_back({x[k] + y[k] + y[i], -y[i]});
        v.push_back({y[k] - x[k] + y[i], +y[i]});
        v.push_back({x[k], y[i]});
    }
    else
    {
        v.push_back({x[i], y[j]});
        v.push_back({x[j], y[i]});
    }
    if(x[i] + y[i] == x[j] + y[j])
    {
        v.push_back({x[k], x[i] + y[i] - x[k]});
        v.push_back({x[i] + y[i] - y[k], y[k]});
        v.push_back({x[i] + y[i] - (x[i] + y[i] + y[k] - x[k]) / 2, (x[i] + y[i] + y[k] - x[k]) / 2});
        v.push_back({-x[k], x[i] + y[i] + x[k]});
        v.push_back({x[i] + y[i] + y[k], -y[k]});
        v.push_back({x[i] + y[i] + (x[i] + y[i] + y[k] - x[k]) / 2, -(x[i] + y[i] + y[k] - x[k]) / 2});    
    }
    if(y[i] - x[i] == y[j] - x[j])
    {
        v.push_back({-x[k], y[j] - x[j] - x[k]});
        v.push_back({y[j] - x[j] - y[k], -y[k]});
        v.push_back({y[j] - x[j] - (x[k] + y[k] + y[i] - x[i]) / 2, -(x[k] + y[k] + y[i] - x[i]) / 2});
        v.push_back({x[k], y[j] - x[j] + x[k]});
        v.push_back({y[j] - x[j] + y[k], y[k]});
        v.push_back({y[j] - x[j] + (x[k] + y[k] + y[i] - x[i]) / 2, (x[k] + y[k] + y[i] - x[i]) / 2});
    }
}
int check(pair<int, int> p)
{
    for(int i = 0; i < n; i++)
    {
        auto [f, s] = p;
        if(p == make_pair(x[i], y[i])) return 0;
        if(f != x[i] && s != y[i] && f + s != x[i] + y[i] && s - f != y[i] - x[i]) return 0;
    }
    return 1;
}
void solve()
{
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> x[i] >> y[i];
    }
    int ok = 0;
    for(int i = 1; i < n; i++)
    {
        if(x[i] != x[i - 1]) ok = 1;
    }
    if(!ok)
    {
        cout << "YES" << endl;
        cout << x[0] << " " << 1000000000 << endl;
        return;
    }
    ok = 0;
    for(int i = 1; i < n; i++)
    {
        if(y[i] != y[i - 1]) ok = 1;
    }
    if(!ok)
    {
        cout << "YES" << endl;
        cout << 1000000000 << " " << y[0] << endl;
        return;
    }
    ok = 0;
    for(int i = 1; i < n; i++)
    {
        if(x[i]+y[i] != x[i - 1] + y[i - 1]) ok = 1;
    }
    if(!ok)
    {
        cout << "YES" << endl;
        if(x[0] + y[0] >= 0)
        cout << x[0] + y[0] - 1000000000<< " " << 1000000000 << endl;
    else cout << x[0] + y[0] + 1000000000 << " " << -1000000000 << endl;
        return;
    }
    ok = 0;
    for(int i = 1; i < n; i++)
    {
        if(y[i]-x[i] != y[i - 1] - x[i - 1]) ok = 1;
    }
    if(!ok)
    {
        cout << "YES" << endl;
        if(y[0] - x[0] >= 0)
        cout << y[0] - x[0] - 1000000000<< " " << -1000000000 << endl;
    else cout << y[0] - x[0] + 1000000000 << " " << 1000000000 << endl;
        return;
    }

    if(n < 3)
    {
        cout << "NO" << endl;
        return;
    }
    vector<pair<int, int>> v;
    cross(v, 0, 1, 2);
    cross(v, 1, 2, 0);
    cross(v, 2, 0, 1);
    cross(v, 0, 2, 1);
    cross(v, 1, 0, 2);
    cross(v, 2, 1, 0);

    for(auto to: v)
        if(check(to))
        {
            cout << "YES" << endl;
            cout << to.first << " " <<  to.second << endl;
            return;
        }
    cout << "NO" << endl;
}

main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--)
        solve();    
}