#include <bits/stdc++.h>
#include <iostream>

using namespace std;
using ll = long long;

unordered_set<char> vowels = {
        'a', 'e', 'i', 'o', 'u', 'y'
};

bool isVowel(char c) {
    return vowels.find(c) != vowels.end();
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    string s1, s2;
    cin >> s1 >> s2;

    for (auto &c: s1) {
        c = tolower(c);
    }
    for (auto &c: s2) {
        c = tolower(c);
    }

    ll c1 = 0, c2 = 0;


    bool good = true;
    while (c1 < s1.size() && c2 < s2.size()) {
        if (s1[c1] == s2[c2]) {
            ++c1, ++c2;
            continue;
        }

        while (c2 < s2.size() && s1[c1] != s2[c2] && isVowel(s2[c2])) {
            c2++;
        }

        if (c2 == s2.size() - 1) {
            good = false;
            break;
        }

        if (s1[c1] == s2[c2]) {
            ++c1, ++c2;
            continue;
        }

        good = false;
        break;
    }

    if (c1 != s1.size()) {
        good = false;
    } else {
        if (c2 != s2.size()) {
            for (int i = c2; i < s2.size(); i++) {
                good &= isVowel(s2[i]);
            }
        }
    }

    if (good) {
        cout << "Same";
    } else {
        cout << "Different";
    }

    return 0;
}
