#include <bits/stdc++.h>

using namespace std;

#define ll long long

#define all(v) begin(v), end(v)

/*
 * 0 - point
 * 1 - v line
 * 2 - h line
 * 3 - diag + - -
 *          - + -
 *          - - +
 * 4 - inverse diag
 */


void insert(vector<pair<int, pair<int, int>>> &st, pair<int, pair<int, int>> g, pair<int, int> p) {
    int x = g.second.first, y = g.second.second;
    if (g.first == 0) {
        if (x == p.first || y == p.second ||
            abs(x - p.first) == abs(y - p.second)) {
            st.push_back(g);
            return;
        } else return;
    } else if (g.first == 1) {
        if (p.first == x) {
            st.push_back(g);
            return;
        }
        else {
            st.push_back({0, {x, p.second}});
            st.push_back({0, {x, p.second - abs(x - p.first)}});
            st.push_back({0, {x, p.second + abs(x - p.first)}});
        }
    } else if (g.first == 2) {
        if (p.second == y) {
            st.push_back(g);
            return;
        }
        else {
            st.push_back({0, {p.first, y}});
            st.push_back({0, {p.first - abs(y - p.second), y}});
            st.push_back({0, {p.first + abs(y - p.second), y}});
        }
    } else if (g.first == 3) {
        if (p.first - x == y - p.second) {
            st.push_back(g);
            return;
        }
        else {
            st.push_back({0, {p.first, y - (p.first - x)}});
            st.push_back({0, {x + (y - p.second), p.second}});
            if ((x + y) % 2 == (p.first + p.second) % 2) {
                int k = (x + y - p.first - p.second) / 2;
                st.push_back({0, {p.first + k, p.second + k}});
            }
        }
    } else {
        if (p.first - x == p.second - y) {
            st.push_back(g);
            return;
        } else {
            st.push_back({0, {p.first, y + (p.first - x)}});
            st.push_back({0, {x + (p.second - y), p.second}});
            if ((x + y) % 2 == (p.first + p.second) % 2) {
                int k = (x - y - p.first + p.second) / 2;
                st.push_back({0, {p.first + k, p.second - k}});
            }
        }
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<int, pair<int, int>>> st;
        int x, y;
        cin >> x >> y;
        st.push_back({1, {x, y}});
        st.push_back({2, {x, y}});
        st.push_back({3, {x, y}});
        st.push_back({4, {x, y}});
        n--;
        while (n--) {
            cin >> x >> y;
            vector<pair<int, pair<int, int>>> new_st;
            pair<int, pair<int, int>> g;
            while (!st.empty()) {
                g = st.back();
                st.pop_back();

                insert(new_st, g, {x, y});
            }
            swap(st, new_st);
//            cout << st.size() << '\n';
            sort(all(st));
            st.resize(unique(all(st)) - st.begin());
//            cout << st.size() << '\n';

        }
//        cout << st.size() << '\n';
        if (st.empty()) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
//            cout << st[0].first;
            cout << ' ' << st[0].second.first << ' ' << st[0].second.second << '\n';
        }
    }
}
