#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma target("avx,avx2,bmi2,sse4")

#define all(x) begin(x), end(x)
#define frl(i, x) for(auto& i : x)
#define rep(i, k, n) for(int i = k; i < n; i++)
#define F first
#define S second
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define int ll

int rh = 1093742754947;

pair<int, int> diff_diag(vector<pair<int, int>> &v) {
    rep(i, 1, v.size()) {
        if (abs(v[i].F - v[i - 1].F) != abs(v[i].S - v[i - 1].S)) return {i - 1, i};
        if (i > 1 && abs(v[i].F - v[i - 2].F) != abs(v[i].S - v[i - 2].S)) return {i - 2, i};
    }
    return {-1, -1};
}

pair<int, int> diff_x(vector<pair<int, int>> &v) {
    rep(i, 1, v.size()) {
        if (v[i].F != v[i-1].F) return {i - 1, i};
    }
    return {-1, -1};
}

pair<int, int> diff_y(vector<pair<int, int>> &v) {
    rep(i, 1, v.size()) {
        if (v[i].S != v[i-1].S) return {i - 1, i};
    }
    return {-1, -1};
}

bool check(pair<int, int> p, vector<pair<int, int>>& v){
    frl(i, v){
        if(p.F == i.F || p.S == i.S || abs(i.F - p.F) == abs(i.S - p.S)) continue;
        else return false;
    }
    return true;
}

pair<int, int> vert_up(int x, int x0, int y0){
    return {x, y0 + (x - x0)};
}
pair<int, int> vert_down(int x, int x0, int y0){
    return {x, y0 + (x0 - x)};
}
pair<int, int> gor_up(int y, int x0, int y0){
    return {x0 + (y - y0), y};
}
pair<int, int> gor_down(int y, int x0, int y0){
    return {x0 + (y0 - y), y};
}
pair<int, int> down_up(int x1, int y1, int x2, int y2){
    if((abs(x1 - x2)%2 + abs(y1 - y2)%2)% 2 == 1) return {rh, rh};
    return {(x1+y1+x2-y2) / 2, (x1+y1-x2+y2)/2};
}
pair<int, int> otl_y(int y, vector<pair<int, int>>& v){
    frl(i, v) if(i.S != y) return i;
    assert(false);
}
pair<int, int> otl_x(int x, vector<pair<int, int>>& v){
    frl(i, v) if(i.F != x) return i;
    assert(false);
}

void ans(vector<pair<int, int>>& v){
    auto p = diff_diag(v);
    if(p == make_pair(-1ll, -1ll)){
        cout << "YES\n";
        cout << v[0].F << ' ' << v[0].S << '\n';
        return;
    }
    auto xx = diff_x(v);
    if(xx == make_pair(-1ll, -1ll)){
        cout << "YES\n";
        cout << v[0].F << ' ' << v[0].S << '\n';
        return;
    }
    auto yy = diff_y(v);
    if(yy == make_pair(-1ll, -1ll)){
        cout << "YES\n";
        cout << v[0].F << ' ' << v[0].S << '\n';
        return;
    }

    auto a = v[p.F], b = v[p.S];
    if(a.S == b.S){ // gorizontal
        vector<pair<int, int>> coords;
        coords.push_back(vert_down(a.F, b.F, b.S));
        coords.push_back(vert_up(a.F, b.F, b.S));
        coords.push_back(vert_up(b.F, a.F, a.S));
        coords.push_back(vert_down(b.F, a.F, a.S));
        coords.push_back(down_up(a.F, a.S, b.F, b.S));
        if(coords.back() == make_pair(rh, rh)) coords.pop_back();
        coords.push_back(down_up(b.F, b.S, a.F, a.S));
        if(coords.back() == make_pair(rh, rh)) coords.pop_back();
        auto c = otl_y(a.S, v);
        coords.push_back(gor_up(a.S, c.F, c.S));
        coords.push_back(gor_down(a.S, c.F, c.S));
        coords.emplace_back(c.F, a.S);
        frl(i, coords){
            if(check(i, v)){
                cout << "YES\n";
                cout << i.F << ' ' << i.S << '\n';
                return;
            }
        }
    } else if(a.F == b.F) {
        vector<pair<int, int>> coords;
        coords.push_back(gor_down(a.S, b.F, b.S));
        coords.push_back(gor_up(a.S, b.F, b.S));
        coords.push_back(gor_up(b.S, a.F, a.S));
        coords.push_back(gor_down(b.S, a.F, a.S));
        coords.push_back(down_up(a.F, a.S, b.F, b.S));
        if(coords.back() == make_pair(rh, rh)) coords.pop_back();
        coords.push_back(down_up(b.F, b.S, a.F, a.S));
        if(coords.back() == make_pair(rh, rh)) coords.pop_back();
        auto c = otl_x(a.F, v);
        coords.push_back(vert_up(a.F, c.F, c.S));
        coords.push_back(vert_down(a.F, c.F, c.S));
        coords.emplace_back(a.F, c.S);
        frl(i, coords){
            if(check(i, v)){
                cout << "YES\n";
                cout << i.F << ' ' << i.S << '\n';
                return;
            }
        }
    } else {
        vector<pair<int, int>> coords;
        coords.push_back(gor_down(a.S, b.F, b.S));
        coords.push_back(gor_up(a.S, b.F, b.S));
        coords.push_back(gor_up(b.S, a.F, a.S));
        coords.push_back(gor_down(b.S, a.F, a.S));
        coords.push_back(down_up(a.F, a.S, b.F, b.S));


        if(coords.back() == make_pair(rh, rh)) coords.pop_back();
        coords.push_back(down_up(b.F, b.S, a.F, a.S));
        if(coords.back() == make_pair(rh, rh)) coords.pop_back();

        coords.push_back(vert_down(a.F, b.F, b.S));
        coords.push_back(vert_up(a.F, b.F, b.S));
        coords.push_back(vert_up(b.F, a.F, a.S));
        coords.push_back(vert_down(b.F, a.F, a.S));
        coords.push_back(down_up(a.F, a.S, b.F, b.S));

        coords.emplace_back(a.F, b.S);
        coords.emplace_back(b.F, a.S);
        frl(i, coords){
            if(check(i, v)){
                cout << "YES\n";
                cout << i.F << ' ' << i.S << '\n';
                return;
            }
        }
    }
    cout << "NO\n";
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    frl(i, v) cin >> i.F >> i.S;
    ans(v);
}

int32_t main() {
    cin.tie(0)->ios_base::sync_with_stdio(0);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
    return 0;
}