#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma target("avx,avx2,bmi2,sse4")

#define all(x) begin(x), end(x)
#define frl(i, x) for(auto& i : x)
#define rep(i, k, n) for(int i = k; i < n; i++)
#define F first
#define S second
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

//#define int ll

int rh = 1093742947;

const int maxn = 120;

int dp[maxn][maxn][maxn];
pair<int, int> p[maxn][maxn][maxn];
int isr[maxn][maxn][maxn];

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    vector<int> b(n);

    for(int i=0; i < n; i++) {
        cin >> a[i];
    }

    for(int i=0; i <n ; i++) {
        cin >> b[i];
    }

    for(int i=0; i <= n; i++) {
        for(int j=0; j <= n; j++) {
            isr[i][j][0] = 1;
        }
    }

    for(int len=1; len <= n; len++) {
        for(int l1=0; l1 < n; l1++) {
            for(int l2=0; l2 < n; l2++) {
                int r1 = l1 + len - 1;
                int r2 = l2 + len - 1;

                if(r1 >= n || r2 >= n)
                    continue;

                if(a[l1] == b[r2] && isr[l1 + 1][l2][len-1]) {
                    isr[l1][l2][len] = 1;
                }
            }
        }
    }

    /*for (int len = 0; len <= n; len++){
        cout << "len = " << len << "\n\n";
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++){
                cout << isr[i][j][len] << ' ';
            }
            cout << "\n";
        }
    }*/

    for(int i=0; i < n + 10; i++) {
        for(int j=0; j < n  + 10; j++) {
            dp[i][j][0] = 1;
        }
    }
    dp[0][0][0] = 1;

    for(int len=1; len <= n; len++) {
        for(int l1=0; l1 < n; l1++) {
            for(int l2=0; l2 < n; l2++) {
                int r1 = l1 + len-1;
                int r2 = l2 + len-1;
                if(r1 >= n || r2 >= n) {
                    continue;
                }

                for(int k=1 ; k <= len; k++) {
                    if(dp[l1][l2][len-k] && isr[l1 + len - k][l2 + len - k][k]) {
                        p[l1][l2][len] = {1, k};
                        dp[l1][l2][len] = 1;
                    } else if(dp[l1 + k][l2][len-k] && isr[l1][l2 + len-k][k]) {
                        p[l1][l2][len] = {0, k};
                        dp[l1][l2][len] = 1;
                    }
                }
            }
        }
    }
    if(!dp[0][0][n]) { cout << "NO"; return; }

    vector<pair<int, int>> r;
    int l1=0;
    int l2=0;
    int len=n;
    while(len != 0) {
        r.push_back(p[l1][l2][len]);
        int k = p[l1][l2][len].second;
        if(p[l1][l2][len].first == 0) {
            l1 += k;
        }
        len -= k;
    }

    /*for (int len = 0; len <= n; len++){
        cout << "len = " << len << "\n\n";
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++){
                cout << dp[i][j][len] << ' ';
            }
            cout << "\n";
        }
    }*/
    reverse(all(r));

    cout << "YES\n";
    string s = "";
    string t = "";
    frl(i, r){
        if(i.F == 1){
            rep(j, 0, i.S) s.push_back('S');
            rep(j, 0, i.S) s.push_back('C');
        }
        else {
            rep(j, 0, i.S) s.push_back('S');
            rep(j, 0, i.S) s.push_back('C');
        }
    }
    reverse(all(t));
    cout << t+s;
}

int32_t main() {
    cin.tie(0)->ios_base::sync_with_stdio(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}