#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define sz(x) ((int) x.size())
#define all(x) x.begin(), x.end()
//#define int long long

using namespace std;

//#pragma gcc optimize ("O3")
//#pragma gcc target ("avx, sse4")

using ld = long double;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

const int MAXN = 1e5 + 10;

struct Queen {
    int x, y;

    Queen(int x = 0, int y = 0): x(x), y(y) {}

    bool check(pii p) {
        if (x == p.f || y == p.s) return 1;
        if (abs(x - p.f) == abs(y - p.s)) return 1;
        return 0;
    }
}q[MAXN];

struct Line{
    Queen q1, q2;

    Line(Queen q1 = Queen(), Queen q2 = Queen()): q1(q1), q2(q2) {};

    bool check(Queen q) {
        ll dx1 = q.x - q1.x, dy1 = q.y - q1.y;
        ll dx2 = q.x - q2.x, dy2 = q.y - q2.y;
        return dx1 * dy2 == dx2 * dy1;
    }

    bool isNotDefault() {
        return (q1.x != 0 || q1.y != 0 || q2.x != 0 || q2.y != 0);
    }
};

set<pii> getPoints(Queen q1, Queen q2) {
    set<pii> ans;
    int xi = q1.x, yi = q1.y, xj = q2.x, yj = q2.y;
    ans.insert({xi, yj});
    ans.insert({xi, yj - xi + xj});
    ans.insert({xi, xi - xj + yj});
    ans.insert({xj, yi});
    ans.insert({yi - yj + xj, yi});
    ans.insert({yj - yi + xj, yi});
    ans.insert({xj, xj - xi + yi});
    ans.insert({yj - yi + xi, yj});
    if ((xj + yj - yi + xi) % 2 == 0)
        ans.insert({(xj + yj - yi + xi) / 2, (xj + yj + yi - xi) / 2});
    ans.insert({xj, yi - xj + xi});
    ans.insert({yi - yj + xi, yj});
    if ((xi + yi + xj - yi) % 2 == 0)
        ans.insert({(xi + yi + xj - yj) / 2, (xi + yi - xj + yj) / 2});
    return ans;
}

void solve() {
    int n;
    cin >> n;
    int x, y;
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        q[i] = Queen(x, y);
    }
    if (n == 1) {
        cout << "YES\n";
        cout << q[0].x _ q[0].y << '\n';
        return;
    }
    set<pii> points = getPoints(q[0], q[1]);
    Line l = (q[0].check({q[1].x, q[1].y}) ? Line(q[0], q[1]) : Line());
    for (int i = 2; i < n; i++) {
        set<pii> newPoints;
        for (auto el : points) {
            if (q[i].check(el)) newPoints.insert(el);
        }
        if (l.isNotDefault()) {
            if (!l.check(q[i])) {
                for (auto p : getPoints(l.q1, q[i])) {
                    if (l.check(Queen(p.f, p.s))) newPoints.insert(p);
                }
                l = Line();
            }
        }
        points.swap(newPoints);
    }
    if (sz(points) > 0) {
        cout << "YES\n";
        pii p = *points.begin();
        cout << p.f _ p.s << '\n';
        return;
    }
    if (l.isNotDefault()) {
        cout << "YES\n";
        cout << l.q1.x _ l.q1.y << '\n';
        return;
    }
    cout << "NO\n";
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}

