#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define sz(x) ((int) x.size())
#define all(x) x.begin(), x.end()
//#define int long long

using namespace std;

//#pragma gcc optimize ("O3")
//#pragma gcc target ("avx, sse4")

using ld = long double;
using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

const int MAX_N = 105;

int n, a[MAX_N], b[MAX_N];
bool dp[2 * MAX_N][2 * MAX_N][2 * MAX_N];
int from[2 * MAX_N][2 * MAX_N][2 * MAX_N];

void get(int L, int R, int open) {
    if (L + 1 == R) {
        cout << "SC";
        return;
    }
    if (!from[L][R][open]) {
        cout << "S";
        get(L + 1, R - 1, open + 1);
        cout << "C";
        return;
    }
    int M = from[L][R][open];
    get(L, M, open);
    get(M + 1, R, open + (M - L + 1) / 2);
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for (int j = 1; j <= n; ++j) {
        cin >> b[j];
    }
    for (int L = 1; L + 1 <= 2 * n; ++L) {
        int R = L + 1;
        for (int open = 0; open <= L - 1; ++open) {
            int close = L - 1 - open;
            if (close > open) continue;
            dp[L][R][open] = (a[open + 1] == b[close + 1]);
            from[L][R][open] = 0;
        }
    }
    for (int len = 4; len <= 2 * n; len += 2) {
        for (int L = 1; L + len - 1 <= 2 * n; ++L) {
            int R = L + len - 1;
            for (int open = 0; open <= L - 1; ++open) {
                int close = L - 1 - open;
                if (close > open) continue;
                int i = open + 1, j = close + ((len - 2) / 2) + 1;
                if (a[i] == b[j] && dp[L + 1][R - 1][open + 1]) {
                    dp[L][R][open] = true;
                    from[L][R][open] = 0;
                }
                for (int M = L + 1; M < R; M += 2) {
                    if (dp[L][M][open] && dp[M + 1][R][open + (M - L + 1) / 2]) {
                        dp[L][R][open] = true;
                        from[L][R][open] = M;
                    }
                }
            }
        }
    }
    if (!dp[1][2 * n][0]) {
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    get(1, 2 * n, 0);
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}

