#include <bits/stdc++.h>
#define forn(i, n) for (int i=0; i<n; i++)
#define fore(collection) for (auto& it: collection)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
using namespace ::std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;



int n;
vector<pii> queens;

bool testDote(pii p)
{
    fore (queens)
    {
        if (it.first == p.first || it.second == p.second)
            continue;
        if (it.second - it.first == p.second - p.first)
            continue;

        if (it.second + it.first == p.second + p.first)
            continue;


        return false;
    }
    return true;
}


bool testForOneLine(pii a, pii b)
{
    if (a.first == b.first || a.second == b.second)
        return true;
    if (a.first + a.second == b.first + b.second)
        return true;
    if (a.first - a.second == b.first - b.second)
        return true;
    return false;
}

void doWork()
{
    cin >> n;
    queens = vector<pii>(n);
    fore(queens) cin >> it.first >> it.second;

    for (int i = 1; i < n; i++)
    {
        if (testForOneLine(queens[0], queens[i]))
            continue;
        int x0 = queens[0].first;
        int y0 = queens[0].second;
        int xi = queens[i].first;
        int yi = queens[i].second;
        vector<pii> toTest;

        toTest.push_back(pii(xi+yi-y0, y0));
        toTest.push_back(pii(xi-yi+y0, y0));
        toTest.push_back(pii(x0, xi+yi-x0));
        toTest.push_back(pii(x0,-xi+yi+x0));


        toTest.push_back(pii(x0+y0-yi, yi));
        toTest.push_back(pii(x0-y0+yi, yi));
        toTest.push_back(pii(xi, x0+y0-xi));
        toTest.push_back(pii(xi,-x0+y0+xi));


        toTest.push_back(pii(xi, y0));
        toTest.push_back(pii(x0, yi));

        int x2, y2;

        x2 = xi-x0+yi+y0, y2 = xi+x0+yi-y0;
        if (x2 % 2 == 0 && y2 % 2 == 0)
            toTest.push_back(pii(x2/2, y2/2));

        x2 = x0-xi+y0+yi, y2 = x0+xi+y0-yi;
        if (x2 % 2 == 0 && y2 % 2 == 0)
            toTest.push_back(pii(x2/2, y2/2));


        fore(toTest)
        {
            if (testDote(it))
            {
                cout << "YES\n";
                cout << it.first << " " << it.second << "\n";
                return;
            }
        }
        cout << "NO\n";
        return;
    }
    cout << "YES\n";
    cout << queens[0].first << " " << queens[0].second << "\n";

}

int main()
{
    cin.tie(0); cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--)
    {
        try
        {
            doWork();
        }
        catch(exception &e)
        {
            cout << e.what() << "\n";
        }

    }

    return 0;
}
