#include <bits/stdc++.h>
#define forn(i, n) for (int i=0; i<n; i++)
#define fore(collection) for (auto& it: collection)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
using namespace ::std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;


void doWork()
{
    int n;
    cin >> n;
    vi a(n), b(n);
    for (int i=0; i<n; i++) {
        cin >> a[i];
    }
    for (int i=0; i<n; i++) {
        cin >> b[i];
    }
    vi stack, operations;
    int ida=0, idb = 0;
    while (ida < n && idb < n) {
	if (stack.size() == 0) {
	    stack.push_back(a[ida]);
	    ida++;
	    operations.push_back(1);
	} else if (stack.back() == b[idb]) {
	    idb++;
	    stack.pop_back();
	    operations.push_back(0);
	} else {
	    stack.push_back(a[ida]);
	    ida++;
	    operations.push_back(1);
	}
    }
    while (!stack.empty() && idb < n) {
    	if (stack.back() != b[idb])
	    break;
	operations.push_back(0);
	stack.pop_back();
	idb++;
    }
    if (idb < n || ida < n) {
        cout << "NO\n";
    } else {
    	cout << "YES\n";
	for (auto it: operations) {
	   if (it)
		cout << "S";
	   else
		cout << "C";
	}
    }
}

int main()
{
    cin.tie(0); cout.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        try
        {
            doWork();
        }
        catch(exception &e)
        {
            cout << e.what() << "\n";
        }

    }

    return 0;
}
