#include <bits/stdc++.h>
using namespace std;

#define sz(a) (int)a.size()
#define ll long long
#define ull unsigned long long
#define ld long double

#define int ll

const int inf = (int)15e8;
const ll linf = (ll)1e18;

const ll mod = (ll)1e9 + 7ll;

bool bis(vector<int> &c, vector<int> &q){
    return (c[0] == q[0]) || (c[1] == q[1]) || (abs(c[0] - q[0]) == abs(c[1] - q[1]));
}

vector<int> greycode(int n) {
    if (n == 1) return {0, 1};

    vector<int> ans = greycode(n - 1);
    ans.resize(1 << n);

    for (int i = (1 << (n - 1)); i < (1 << n); ++i) {
        ans[i] = ans[(1 << (n - 1)) - i - 1];
    }
    return ans;
}

void solve() {
    int n; cin>> n;
    vector <vector<int>> q(n, vector<int>(2));
    for (int i = 0; i < n; i++) {
        cin >> q[i][0] >> q[i][1];
    }
    vector<int> my = q[0];
    vector <int> nmy = q[0];
    int x = my[0];
    vector<vector<int>> p;
    int ind = -1;
    for (int i = 0; i < n; i++){
        if (!bis(my, q[i])){
            nmy = q[i];
            ind = i;
            break;
        }
    }
    if (ind == -1){
        cout << "YES" << '\n';
        cout << my[0] << ' ' << my[1] << '\n';
        return;
    }
    set<vector<int>> inters;
    inters.insert({my[0], nmy[1]});
    inters.insert({nmy[0], my[1]});
    inters.insert({nmy[0] + nmy[1] - my[1], my[1]});
    inters.insert({nmy[0] - nmy[1] + my[1], my[1]});
    inters.insert({my[0] + my[1] - nmy[1], nmy[1]});
    inters.insert({my[0] - my[1] + nmy[1], nmy[1]});
    inters.insert({my[0], nmy[1] + nmy[0] - my[0]});
    inters.insert({my[0], nmy[1] - nmy[0] + my[0]});
    inters.insert({nmy[0], my[1] + my[0] - nmy[0]});
    inters.insert({nmy[0], my[1] - my[0] + nmy[0]});


    if ((my[0] + my[1] + nmy[0] + nmy[1]) % 2 == 0){
        int x = (nmy[1] + nmy[0] + my[0] - my[1]) / 2;
        int y = (nmy[1] + nmy[0] - my[0] + my[1]) / 2;

        inters.insert({x, y});
        inters.insert({my[0] + nmy[0] - x, my[1] + nmy[1] - y});
    }

    for (int i = 1; i < n; i++){
        if (i == ind)
            continue;
        set<vector<int>> todel;

        for (auto c: inters){
            if (!bis(c, q[i])){
                todel.insert(c);
            }
        }
        for (auto c: todel){
            inters.erase(c);
        }
    }
    if (sz(inters) == 0){
        cout << "NO\n";
    } else {
        cout << "YES\n";
        auto ans = *inters.begin();
        cout << ans[0] << ' ' << ans[1] << '\n';
    }

//    ll p, n; cin >> n >> p;
//    n -= p;
//    ll m; cin >> m;
//    vector<vector<vector<ll>>> dp(n + 1, vector<vector<ll>> (p + 1, vector<ll> (n + 1, 0)));
//    dp[0][0][0] = 1;
//    dp[1][0][1] = 1ll;
//    for (int i = 2; i <= n; ++i) {
//        for (int j = 0; j <= min((int)p, i); ++j) {
//            for (int r = 1; r <= i; ++r) {
//                if ((j ^ r) <= p) dp[i][j][r] = dp[i - r][j ^ r][r];
//            }
//        }
//    }
//    ll ans = 0;


//    int n; cin >> n;


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //cout << fixed << setprecision(15);

    int tet = 1;
    cin >> tet;
    while (tet--) {
        solve();
    }
}
