#include <bits/stdc++.h>
using namespace std;

#define sz(a) (int)a.size()
#define ll long long
#define ull unsigned long long
#define ld long double

#define int ll

const int inf = (int)15e8;
const ll linf = (ll)1e18;

const ll mod = (ll)1e9 + 7ll;

vector<int> greycode(int n) {
    if (n == 1) return {0, 1};

    vector<int> ans = greycode(n - 1);
    ans.resize(1 << n);

    for (int i = (1 << (n - 1)); i < (1 << n); ++i) {
        ans[i] = ans[(1 << n) - i - 1] ^ (1 << (n - 1));
    }
    return ans;
}

void solve() {
    int n; cin >> n;

    vector<int> color(n);
    int cnt; cin >> cnt;
    if (cnt == n) return;

    for (int i = 0; i < n; ++i) {
        cout << i + 1 << " " << i + 1 << endl;

        int k; cin >> k;
        if (k == n) return;
        if (k >= cnt) color[i] = 0;
        else color[i] = 1;

        cout << i + 1 << " " << i + 1 << endl;

        cin >> k;
        if (k == n) return;
    }

    //cout << color[0] << "\n";
    //cout << color[1] << " " << color[2] << "\n";

    for (int i = 0; i < n; ++i) {
        while (color[i] == 0) {
            int j = i;
            for (j; j < n && color[j] == 0; ++j);
            --j;

            vector<int> q = greycode(j - i + 1);

            for (int t = 1; t < sz(q); ++t) {
                int el = q[t] ^ q[t - 1];

                int bit = 0;
                while (el > 1) {
                    el /= 2;
                    ++bit;
                }

                cout << i + 1 << " " << i + 1 + bit << endl;
                int k; cin >> k;
                if (k == n) return;
                if (k > cnt) {
                    cnt = k;
                    for (int w = i; w <= j; ++w) {
                        cout << w + 1 << " " << w + 1 << endl;
                        cin >> k;
                        if (k == n) return;
                        if (k < cnt) {
                            cout << w + 1 << " " << w + 1 << endl;
                            cin >> k;
                            color[w] = 1;
                        }
                        else {
                            cout << w + 1 << " " << w + 1 << endl;
                            cin >> k;
                            if (k == n) return;
                        }
                    }
                    break;
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //cout << fixed << setprecision(15);

    int tet = 1;
    //cin >> tet;
    while (tet--) {
        solve();
    }
}
