#include <bits/stdc++.h>
using namespace std;

#define sz(a) (int)a.size()
#define ll long long
#define ull unsigned long long
#define ld long double

const int inf = (int)15e8;
const ll linf = (ll)1e18;

const ll mod = (ll)1e9 + 7ll;

void solve() {
    int n; cin >> n;

    vector<int> a(n);
    vector<int> b(n);

    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];

    vector<int> l(n, n);
    vector<int> r(n, -1);

    for (int i = 0; i < n; ++i) {
        int lo = -1;
        int hi = n;

        while (hi - lo > 1) {
            int mid = hi + lo >> 1;

            if (b[mid] < a[i]) lo = mid;
            else hi = mid;
        }

        l[i] = hi;
        r[i] = lo;
    }

    multiset<int> mini = {inf};
    multiset<int> maxi = {-inf};

    for (int i = 0; i < n; ++i) maxi.insert(l[i] - i);

    vector<int> ans;
    for (int k = 0; k < n; ++k) {
        if (*(--maxi.end()) <= k && *mini.begin() >= k) ans.push_back(k);

        int ind = n - k - 1;

        maxi.erase(maxi.find(l[ind] - ind));
        mini.insert(r[ind] - ind + n);
    }
    if (*(--maxi.end()) <= n && *mini.begin() >= n) ans.push_back(n);

    cout << sz(ans) << "\n";

    for (int el: ans) cout << el << " ";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //cout << fixed << setprecision(15);

    int tet = 1;
    //cin >> tet;
    while (tet--) {
        solve();
    }
}
