#include <iostream>
#include <bits/stdc++.h>
#include "stack"
using namespace std;
typedef long long ll;

void config_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _deb
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}




int main() {
    config_io();

    int n;
    std::cin >> n;

    vector<int> s(n), c(n);

    int tmp;

    for (int i = 0; i < n; ++i){
        cin >> tmp;
        s[i] = tmp;
    }

    for (int i = 0; i < n; ++i){
        cin >> tmp;
        c[i] = tmp;
    }


    int sp = 0, cp = 0;
    string ans;
    stack<int> t;
    for(int i = 0; i < 2 * n; i++){
        if(t.empty() || t.top() != c[cp]){
            t.push(s[sp]);
            sp++;
            ans += 'S';
        }
        else{
            ans += 'C';
            t.pop();
            cp++;
        }
        if(cp > n || sp > n){
            break;
        }
    }

    if(ans.size() != 2 * n){
        cout << "NO";
    }
    else{
        cout << "YES\n";
        cout << ans;
    }

}
