#include <iostream>
#include <bits/stdc++.h>
#include "stack"
using namespace std;
typedef long long ll;

void config_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _deb
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}



vector<ll> s, c;

void tree(ll i, ll cp, ll sp, stack<ll> table, ll n, map<ll, bool>& g){
   //  cout << i << '\n';
    g[i] = true;
    if(sp < n) {
        table.push(s[sp]);
        tree(2*i+1, cp, sp+1, table, n, g);
        table.pop();
    }
    if(cp < n && !table.empty()){
        if(table.top() == c[cp]){
            table.pop();
            tree(2*i+2, cp+1, sp, table, n, g);
        }
    }
}


int main() {
    config_io();

    ll n;
    std::cin >> n;
    s.resize(n);
    c.resize(n);


    ll tmp;

    for (ll i = 0; i < n; ++i){
        cin >> tmp;
        s[i] = tmp;
    }

    for (ll i = 0; i < n; ++i){
        cin >> tmp;
        c[i] = tmp;
    }

    map<ll, bool> graph;
    tree(0, 0, 0, {}, n, graph);
    list<ll> q, new_v;
    q = {0};
    ll depth = 0;
    ll last;

    while (!q.empty()){
        new_v.clear();
        for(ll x: q){
            last = x;
            if(graph[2*x+1]){
                new_v.push_back(2*x+1);
            }
            if(graph[2*x+2]){
                new_v.push_back(2*x+2);
            }
        }
        swap(q, new_v);
        depth++;
    }

    if(depth != 2*n+1){
        cout << "NO";
    }
    else{
        cout << "YES\n";
        string ans;
        while(last != 0) {
            if (last % 2 == 0) {
                ans = 'C' + ans;
                last -= 2;
                last /= 2;
            } else {
                ans = 'S' + ans;
                last -= 1;
                last /= 2;
            }
        }
        cout << ans;
    }
}
