#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
#include<stack>
using namespace std;
//#define int long long

int curr_r = 0;

vector<int> restore(vector<vector<vector<int>>>& dp, vector<vector<vector<bool>>> &rev, int i1, int i2, int i3) {
	if (i1 == i2) {
		return { i1 };
	}
	int i4 = dp[i1][i2][i3];
	int k1 = 0, k2 = 0;
	int l1 = i4 - i1 + 1, l2 = i2 - i4;
	if (rev[i1][i2][i3]) {
		k1 = l1;
	}
	else {
		k2 = l2;
	}
	if (rev[i1][i2][i3]) {
		vector<int> res;
		res.push_back(i1);
		for (int x : restore(dp, rev, i1 + 1, i2, i3)) {
			res.push_back(x);
		}
		return res;
	}
	vector<int> res1 = restore(dp, rev, i1, i4, i3 + k1);
	vector<int> res2 = restore(dp, rev, i4 + 1, i2, i3 + k2);
	vector<vector<int>> order = { res1, res2 };
	vector<int> res;
	for (auto v : order) {
		for (int x : v) {
			res.push_back(x);
		}
	}
	return res;
}
string restore2(vector<vector<vector<int>>>& dp, vector<vector<vector<bool>>>& rev, int i1, int i2, int i3) {
	if (i1 == i2) {
		return "SC";
	}
	if (rev[i1][i2][i3]) {
		return "S" + restore2(dp, rev, i1 + 1, i2, i3) + "C";
	}
	int k = dp[i1][i2][i3];
	return restore2(dp, rev, i1, k, i3) + restore2(dp, rev, k + 1, i2, i3 + (k + 1 - i1));
}
void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	vector<vector<vector<int>>> dp(n, vector<vector<int>>(n, vector<int>(n, -1)));
	vector<vector<vector<bool>>> rev(n, vector<vector<bool>>(n, vector<bool>(n)));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (a[i] == b[j]) {
				dp[i][i][j] = i;
			}
		}
	}
	for (int l = 2; l <= n; ++l) {
		for (int i1 = 0, j1 = l - 1; j1 < n; ++i1, ++j1) {
			for (int i2 = 0, j2 = l - 1; j2 < n; ++i2, ++j2) {
				for (int k = i1; k < j1; ++k) {
					int l1 = k - i1 + 1, l2 = j1 - k;
					if (dp[i1][k][i2] >= 0 && dp[k + 1][j1][i2 + l1] >= 0) {
						dp[i1][j1][i2] = k;
					}
				}
				if (j1 > i1 && dp[i1 + 1][j1][i2] >= 0 && a[i1] == b[i2 + (j1 - i1)]) {
					dp[i1][j1][i2] = 1;
					rev[i1][j1][i2] = true;
				}
			}
		}
	}
	if (dp[0][n - 1][0] == -1) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		/*auto res = restore(dp, rev, 0, n - 1, 0);
		int mx = 0;
		for (int x : res) {
			cout << x << ' ';
		}
		cout << '\n';
		for (int x : res) {
			while (mx <= x) {
				cout << 'S';
				mx++;
			}
			cout << 'C';
		}
		cout << '\n';*/
		cout << restore2(dp, rev, 0, n - 1, 0);
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	int t = 1;
	for (int _ = 0; _ < t; ++_) {
		solve();
	}
	return 0;
}