#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; ++i)
#define forj(n) for(ll j = 0; j < n; ++j)
#define rep(i, n) for(ll i = 0; i < n; ++i)
#define vec vector

bool isvowel(char c) {
    return c == 'a' || c == 'e' || c == 'o' || c == 'u' || c == 'i' || c == 'y';
}

bool used[1001][1001];
bool dp[1001][1001];

bool rec(string& s, string& t, int i, int j) {
    if (used[i][j])
        return dp[i][j];
    used[i][j] = 1;
    if (isvowel(t[j - 1]))
        dp[i][j] |= rec(s, t, i, j - 1);
    if (s[i - 1] == t[j - 1])
        dp[i][j] |= rec(s, t, i - 1, j - 1);
    return dp[i][j];
}
int main() {
    ios_base::sync_with_stdio(false);
    string s, t;
    cin >> s >> t;
    int n = s.size();
    int m = t.size();
    for (int i = 0; i < n; ++i) {
        s[i] = tolower(s[i]);
    }
    for (int i = 0; i < m; ++i) {
        t[i] = tolower(t[i]);
    }
    dp[0][0] = 1;
    used[0][0] = 1;
    rec(s, t, n, m);

    if (dp[n][m])
        cout << "Same" << '\n';
    else
        cout << "Different" << '\n';
}
