#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <set>
#include <queue>

#define ll long long

using namespace std;

int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

int get_ans(const vector<int> &a, const vector<int> &b) {
    vector<pair<int, int>> c;
    for (int i = 0; i < a.size(); i++) {
        c.push_back({a[i], 1});
    }
    for (int i = 0; i < b.size(); i++) {
        c.push_back({b[i], -1});
    }
    sort(c.begin(), c.end());
    int ans = 0;
    int k = 0;
    int cnt = 0;
    for (int i = 0; i < c.size(); i++) {
        if (c[i].second == 1) {
            ans = max(ans, k - cnt);
            cnt++;
        } else {
            k++;
        }
    }
    return ans;
}

int solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    int mn = get_ans(a, b);
    reverse(a.begin(), a.end());
    reverse(b.begin(), b.end());
    for (int i = 0; i < n; i++) {
        a[i] *= -1;
        b[i] *= -1;
    }
    int mx = n - get_ans(a, b);
    cout << mx - mn + 1 << endl;
    for (int i = mn; i <= mx; i++) {
        cout << i << ' ';
    }
    return 0;
}