#include <bits/stdc++.h>

using namespace std;

int main() {
    int n;
    cin >> n;

    vector<vector<pair<int, int>>> from(n+1, vector<pair<int, int>> (n+1));
    vector<vector<int>> visited(n+1, vector<int> (n+1, -1));

    queue<pair<int, int>> q;
    q.emplace(0, 0);

    while (visited[n][0] == -1) {
        auto cur = q.front();
        q.pop();

        auto s = cur.first;
        auto p = cur.second;

        int start = 0;
        if (s == 0 && p == 0) ++start;

        for (int i = start; i < 10; i++) {
            int ss = s + i;
            int pp = ((10 % n * p) % n + i % n) % n;

            if (ss > n) continue;
            if (visited[ss][pp] != -1) continue;

            from[ss][pp] = {s, p};
            visited[ss][pp] = i;

            q.emplace(ss, pp);
        }
    }

    pair<int, int> cur = {n, 0};

    stack<int> ans;

    while (visited[cur.first][cur.second] != -1) {
        ans.push(visited[cur.first][cur.second]);
        cur = from[cur.first][cur.second];
    }

    while (!ans.empty()) {
        cout << ans.top();
        ans.pop();
    }
}
