//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;

#define rep(i, n) for (int i = 0; i < n; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

deque<ll> a, b;
vi st;
vector<char> ans;

// i первый неюз j первый неюз
bool check(int i, int j, int depth) {
    if (j >= b.size()) {
        return 1;
    }
    bool first = 0, second = 0;
    char h = 0;

    if (st.size() && st.back() == b[j]) {
        h = st.back();
        st.pop_back();
        // решить задачу с вершины
        first = check(i, j + 1, depth + 1);
    }
    if (first) {
        ans[depth] = 'C';
        return 1;
    } else {
        if (h != 0)
            st.push_back(h);
    }

    // написать задачу
    if (i >= a.size()) {
        return 0;
    }
    st.push_back(a[i]);
    second = check(i + 1, j, depth + 1);
    if (second) {
        ans[depth] = 'S';
        return 1;
    } else {
        st.pop_back();
        return 0;
    }
}

void solve() {
    ll n; cin >> n;
    a.assign(n, 0), b.assign(n, 0);
    ans.resize(2 * n);


    rep(i, n) cin >> a[i];
    rep(i, n) cin >> b[i];

    multiset<ll> g, h;
    each(i, a) g.insert(i);
    each(i, b) h.insert(i);
    if (g != h) {
        cout << "NO\n";
        exit(0);
    }

    reverse(all(ans));
    if (check(0, 0, 0)) {
        cout << "YES\n";
        each(i, ans) cout << i;
        cout << '\n';
    } else cout << "NO\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}