//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;

#define rep(i, n) for (int i = 0; i < n; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll lcm(ll a, ll b) {
    return (a / gcd(a, b) * b);
}

string itos(ll k) {
    string res = "";
    if (k == 0) return "0";
    while (k) {
        char c = '0' + k % 10;
        res = c + res;
        k /= 10;
    }
    return res;
}

deque<ll> a, b;
// i первый неюз j первый неюз
string check(int i, int j, vi&st) {
    if (j >= b.size()) {
        return "0";
    }


    vi addst = st, delst = st;
    addst.push_back(a[i]);
    string first = "", second = "";

    if (delst.size() && st.size() && st.back() == b[j]) {
        delst.pop_back();
        // решить задачу с вершины
        first = check(i, j + 1, delst);
    }
    if (first != "") {
        return 'C' + first;
    }

    // написать задачу
    if (i + 1 > a.size()) {
        return "";
    }
    second = check(i + 1, j, addst);
    if (second != "") {
        return 'S' + second;
    } else {
        return "";
    }
}

void solve() {
    ll n; cin >> n;
    a.assign(n, 0), b.assign(n, 0);

    rep(i, n) cin >> a[i];
    rep(i, n) cin >> b[i];

    vi st;
    string ans = check(0, 0, st);
    if (ans != "") cout << "YES\n" << ans.substr(0, ans.size() - 1) << '\n';
    else cout << "NO\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
