//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;

#define rep(i, n) for (int i = 0; i < n; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    ll n; cin >> n;
    vi a(n, 0), b(n, 0);
    rep(i, n) cin >> a[i];
    rep(i, n) cin >> b[i];
    vi st;
    string ans = "";
    vi used(n + 1, 0);

    int i = 0, j = 0;
    while (j < a.size() && i < a.size()) {
        ans += 'S';
        st.push_back(a[i]);
        used[a[i]]++;
        i++;

        // b[j]
        while (st.size() && st.back() == b[j]) {
            int x = n - 1, y = j + 1;
            vi cu = used;
            while (x >= i) {
                while (y < n && b[y] != a[x] && used[b[y]] > 0) {
                    cu[b[y]]--;
                    y++;
                }
                if (y < n && x < n && x >= i && a[x] == b[y]) {
                    x--;
                    y++;
                } else {
                    break;
                }
            }

            if (st.back() == b[j] && x == i - 1) {
                j++;
                ans += 'C';
                st.pop_back();
            } else {
                break;
            }
        }
    }
    if (j != n) {
        cout << "NO" << endl;
        exit(0);
    } else {
        cout << "YES" << endl;
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
