#include <iostream>
#include <vector>

using namespace std;
#define int long long



bool isAttack(int x1, int y1, int x2, int y2) {
    if ((x1 == x2) || (y1 == y2) || (abs(x1 - x2) == abs(y1 - y2))) return true;
    return  false;
}


void source() {
    int n; cin >> n;
    vector<int> x(n), y(n);



    for (int i = 0; i < n; ++i) cin >> x[i] >> y[i];
    
    int j = -1;
    for (int i = 1; i < n; ++i)  {
        if (!isAttack(x[0], y[0], x[i], y[i])) {
            j = i;
            break;
        }
    }

    if (j == -1) {
        cout << "YES\n";
        cout << x[0] << " " << y[0] << '\n';
    } else {
        vector<pair<int, int>> points = {
            {x[0], y[j]}, {x[j], y[0]}, 
            {x[0], y[j] + (x[0] - x[j])},
            {x[0], y[j] - (x[0] - x[j])},
            {x[j], y[0] + (x[0] - x[j])},  
            {x[j], y[0] + (x[0] - x[j])},
            {x[j] + (y[j] - y[0]), y[0]},
            {x[j] - (y[j] - y[0]), y[0]},
            {x[0] + (y[j] - y[0]), y[j]},
            {x[0] - (y[j] - y[0]), y[j]}
        };
        if ((x[j] + y[j] + x[0] + y[0]) % 2 == 0) {
            int k = (x[j] + y[j] - (x[0] + y[0])) / 2;
            points.push_back({x[0] + k, y[0] + k});
            points.push_back({x[j] - k, y[j] - k});
        }

        bool ans = false;
        int ansx, ansy;
        for (int i = 0; i < points.size(); ++i) {
            if (ans) break;
            int x0 = points[i].first, y0 = points[i].second;
            bool flag = true;
            for (int k = 0; k < n; ++k) {
                if (!isAttack(x0, y0, x[k], y[k])) {
                    flag = false;
                    break;
                }
            }
            if (flag) {
                ansx = x0;
                ansy = y0;
                ans = true;
                break;
            }
        }

        if (ans) {
            cout << "YES\n";
            cout << ansx << " " << ansy << '\n';
        } else {
            cout << "NO\n";
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int t; cin >> t;
    while (t--) source();


    return 0;
}