import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.PrintWriter
import java.util.StringTokenizer
import kotlin.math.max
import kotlin.math.min

fun powTenPhi(d: Long): Long {
    var p = 10L % d
    var cnt = 1L
    while (p % d != 1L) {
        p = (p * 10) % d
        cnt++
    }
    return cnt
}

fun solve() {
    val d = readLong()
    if (d == 1L) {
        out.println(239)
        return
    }
    val p = powTenPhi(d)
    var need = d
    val zeroStr = "0".repeat(p.toInt() - 1)
    while (need > 0) {
        val cur = min(9L, need)
        need -= cur
        out.print(cur)
        if (need > 0) out.print(zeroStr)
    }
}

fun main(args: Array<String>) {
    solve()
    out.close()
}

val out = PrintWriter(System.out)
val br = BufferedReader(InputStreamReader(System.`in`))
var tok = StringTokenizer("")

fun read(): String {
    while (!tok.hasMoreTokens()) {
        tok = StringTokenizer(br.readLine()!!)
    }
    return tok.nextToken()!!
}

fun readLong() = read().toLong()