#include <bits/stdc++.h>

#define int int64_t

using namespace std;

set<int> aval;
int prevK = 0;
int k;
int n = 0;

void readK() {
    prevK = k;
    cin >> k;
}

int checkIndex(int i) {
    if (aval.count(i) > 0) {
        return false;
    }
    cout << i << ' ' << i << endl;
    readK();
    if (k == n) {
        return 228;
    }
    if (prevK < k) {
        return 1;
    }
    cout << i << ' ' << i << endl;
    readK();
    return 0;
}

pair<int, int> story[10000];
size_t storyInd = 0;

bool smartAsk(int l, int r, bool hist) {
    cout << l << ' ' << r << endl;
    readK();
    if (k == n) {
        return true;
    }
    if (k >= prevK && hist) {
        story[storyInd++] = make_pair(l, r);
    }
    return false;
}

bool openIndex(int i) {
    int chek = checkIndex(i);
    if (chek == 228) return true;
    if (chek == 1) {
        aval.emplace(i);
        return false;
    }
    auto leftI = aval.upper_bound(i);
    leftI--;
    int left = max(1LL, (*leftI) + 1);
    int right = min(n, (*aval.lower_bound(i)) - 1);

    int mask = 1 << (right - left + 1);
    for (int m = 1; m <= mask; m++) {
        for (int l = left; l < right; l++) {
            if (((1 << l) & m) > 0) continue;
            for (int r = i; r <= right; r++) {
                if (((1 << r) & m) > 0) continue;
                if (smartAsk(l, r, true)) {
                    return true;
                }
                story[storyInd++] = make_pair(l, r);
            }
        }
        int ch = checkIndex(i);
        if (ch == 228) {
            return true;
        }
        if (ch == 1) {
            aval.emplace(i);
            return false;
        }
        while (storyInd-- > 0) {
            if (smartAsk(story[storyInd].first, story[storyInd].second, false)) {
                return true;
            }
        }
    }
    return false;
}

bool recurCheck(int l, int r) {
    if (r - l < 1) return false;
    if (l <= 0) return false;
    if (l > n) return false;
    int mid = (l + r) >> 1;
    if (openIndex(mid)) {
        return true;
    }
    if (recurCheck(l, mid)) {
        return true;
    }
    return recurCheck(mid + 1, r);
}

void solve() {
    cin >> n >> k;
    if (k == n) {
        return;
    }
    prevK = k;
    aval.emplace(n + 1);
    aval.emplace(-1);
    recurCheck(1, n + 1);
}

signed main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt-- > 0) {
        solve();
    }
    return 0;
}
