#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;


#define vi vector<int>
#define vl vector<ll>
#define all(v) v.begin(), v.end()

using namespace std;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

int rand(int l, int r) {
    return uniform_int_distribution(l, r)(gen);
}

struct Queen {
    int x, y;
    Queen(): x(0), y(0) {}
};

struct Intersection {
    int type;
    int d;
    int d2;

    Intersection(): type(6) {}
    Intersection(int t, int d): type(t), d(d) {}
    Intersection(int t, int d1, int d2): type(t), d(d1), d2(d2) {}
    // type 1: x = d
    // type 2: y = d
    // type 3: y = x + d
    // type 4: y = -x + d
    // type 5: (x, y)
    // type 6: empty

    bool contains(int x, int y) {
        if (type == 1) {
            return d == x;
        } else if (type == 2) {
            return d == y;
        } else if (type == 3) {
            return y == x + d;
        } else if (type == 4) {
            return y == -x + d;
        } else if (type == 5) {
            return d == x && d2 == y;
        } else if (type == 6) {
            return false;
        }
    }
};

//Intersection operator+(Intersection lhs, Intersection rhs) {
//    if (lhs.type == 6) {
//        return lhs;
//    } else if (rhs.type == 6) {
//        return rhs;
//    }
//
//    if (lhs.type == 5) {
//        if (rhs.contains(lhs.d, lhs.d2)) {
//            return lhs;
//        } else {
//            return Intersection();
//        }
//    } else if (rhs.type == 5) {
//        return rhs + lhs;
//    }
//
//    if (lhs.type == 4 && rhs.type == 4) {
//        if (lhs.d == rhs.d) {
//            return lhs;
//        } else {
//            return Intersection();
//        }
//    }
//
//    if (lhs.type == 4 && rhs.type == 3) {
//        if ((lhs.d + rhs.d) % 2 == 0) {
//            return Intersection(5, (lhs.d + rhs.d) / 2, (lhs.d + rhs.d) / 2 + rhs.d);
//        } else {
//            Intersection();
//        }
//    } else if (rhs.type == 3 && lhs.type == 4) {
//        return rhs + lhs;
//    }
//
//    if (lhs.type == 4 && rhs.type == 2) {
//        return Intersection(5, lhs.d - rhs.d, rhs.d);
//    } else if (rhs.type == 4 && lhs.type == 2) {
//        return rhs + lhs;
//    }
//
//    if (lhs.type == 4 && rhs.type == 1) {
//        return Intersection(5, rhs.d, -rhs.d + lhs.d);
//    } else if (lhs.type == 1 && rhs.type == 4) {
//        return rhs + lhs;
//    }
//
//    if (lhs.type == 3 && rhs.type == 3) {
//        if (lhs.d == rhs.d) {
//            return lhs;
//        } else {
//            return Intersection();
//        }
//    }
//
//    if (lhs.type == 3 && rhs.type == 2) {
//
//    }
//}

// task E
//void solve() {
//    int n;
//    cin >> n;
//
//    vector <Queen> queens(n);
//    for (auto &q: queens) {
//        cin >> q.x >> q.y;
//    }
//
//    if (n == 1) {
//        cout << queens[0].x << ' ' << queens[0].y << '\n';
//        return;
//    }
//
//    vector <Intersection> nuggets;
//
//    auto get_nuggets = [&] (int i) {
//        auto q = queens[i];
//        return vector <Intersection> {
//            Intersection(1, q.x),
//            Intersection(2, q.y),
//            Intersection(3, q.y),
//            Intersection(4, q.y)
//        };
//    };
//
//
//}

void solve() {
    int n;
    cin >> n;
    vector <pair<int, int>> mas;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        mas.push_back({a, 1});
    }
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        mas.push_back({a, 0});
    }
    sort(mas.begin(), mas.end());
    int s = 0;
    int f = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (mas[i].second == 0) {
            s++;
        } else {
            break;
        }
    }
    for (int i = 2 * n - 1; i > -1; i--) {
        if (mas[i].second == 0) {
            f++;
        } else {
            break;
        }
    }
    cout << n + 1 - s - f << "\n";
    for (int i = 0 + s; i < n + 1 - f; i++) {
        cout << i << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
       cin.tie( nullptr);
    int tt = 1;
     //cin >> tt; // CAUTION FOR TASK E
    while (tt--) {
        solve();
    }
}
