#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;


#define vi vector<int>
#define vl vector<ll>
#define all(v) v.begin(), v.end()

using namespace std;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

int rand(int l, int r) {
    return uniform_int_distribution(l, r)(gen);
}


//void solve() {
//    ll d;
//    cin >> d;
//    ll d2 = d;
//    ll res = 0;
//    ll d1 = d;
//    while (d1 > 0) {
//        res += d1 % 10;
//        d1 /= 10;
//    }
//    ll d3 = d;
//    d3 -= res;
//    ll f = d3 / 9;
//    for (int i = 0; i < f; i++) {
//        cout << "9";
//    }
//    cout << d % 9;
//    cout << d2 << "\n";
//    cout << 9013 % 13 << "\n";
//}

set<char> vowels;

void solve() {
    vowels.insert('a');
    vowels.insert('e');
    vowels.insert('i');
    vowels.insert('o');
    vowels.insert('u');
    vowels.insert('y');

    string s, f;
    cin >> s >> f;

    auto is_vowel = [&] (char c) {
        return vowels.find(tolower(c)) != vowels.end();
    };

    int i = 0, j = 0;
    while (i < s.size() && j < f.size()) {
        if (tolower(s[i]) == tolower(f[j])) {
            i++;
            j++;
        } else if (is_vowel(f[j])) {
            j++;
        } else {
            cout << "Different\n";
            return;
        }
    }

    while (j < f.size()) {
        if (!is_vowel(f[j])) {
            cout << "Different\n";
            return;
        }

        j++;
    }

    if (i == s.size() && j == f.size()) {
        cout << "Same\n";
    } else {
        cout << "Different\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
       cin.tie(nullptr);
    int tt = 1;
     //cin >> tt;
    while (tt--) {
        solve();
    }
}
