#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <string>
#include <map>
#include <set>

using namespace std;

map <char, int> mp_str1, mp_str2;

int main()
{
	std::ios_base::sync_with_stdio(false);

	string str1, str2;
	cin >> str1 >> str2;

	sort(str1.begin(), str1.end());
	sort(str2.begin(), str2.end());

	if (str1.size() > str2.size())
	{
		cout << "Different" << endl;
		return 0;
	}
	else if (str1.size() == str2.size())
	{
		for (int i(0); i < str2.size(); i++)
		{
			if (tolower(str1[i]) != tolower(str2[i]))
			{
				cout << "Different" << endl;
				return 0;
			}
		}

		cout << "Same" << endl;
	}
	else
	{
		for (int i(0); i < str1.size(); i++)
		{
			mp_str1[tolower(str1[i])]++;
		}
		for (int i(0); i < str2.size(); i++)
		{
			/*if ((str2[i] != 'a' || str2[i] != 'A')
				&& (str2[i] != 'e' || str2[i] != 'E')
				&& (str2[i] != 'i' || str2[i] != 'I')
				&& (str2[i] != 'o' || str2[i] != 'O')
				&& (str2[i] != 'u' || str2[i] != 'U')
				&& (str2[i] != 'y' || str2[i] != 'Y'))
			{
				mp_str1[str2[i]]--;
			}*/
			mp_str2[tolower(str2[i])]++;
		}
		for (int i(0); i < str2.size(); i++)
		{
			if (mp_str1[str2[i]] != mp_str2[str2[i]] && (str2[i] != 'a' && str2[i] != 'A')
				&& (str2[i] != 'e' && str2[i] != 'E')
				&& (str2[i] != 'i' && str2[i] != 'I')
				&& (str2[i] != 'o' && str2[i] != 'O')
				&& (str2[i] != 'u' && str2[i] != 'U')
				&& (str2[i] != 'y' && str2[i] != 'Y'))
			{
				cout << "Different" << endl;
				return 0;
			}

			/*if (mp_str1[str2[i]] != 0 && (str2[i] != 'a' && str2[i] != 'A')
				&& (str2[i] != 'e' && str2[i] != 'E')
				&& (str2[i] != 'i' && str2[i] != 'I')
				&& (str2[i] != 'o' && str2[i] != 'O')
				&& (str2[i] != 'u' && str2[i] != 'U')
				&& (str2[i] != 'y' && str2[i] != 'Y'))
			{
				cout << "Different" << endl;
				return 0;
			}*/
		}

		cout << "Same" << endl;
	}
}