import kotlin.math.ln
import kotlin.math.sqrt

fun main(args: Array<String>) {
    val testCases : Long = readln().toLong()
    val value : Long = readln().toLong()


    var values = mutableListOf<Long>();

    for(i in 1 until testCases) {
        val selectedValue = readln().toLong();
        val minus = if (selectedValue < 10) -1 else 0

        values.add(microwave(selectedValue).second - minus)
    }

    for(i in values)
        println(i)
}

fun customSqrt(value : Long) : Long {
    var result = 0L;
    var value_ = value;

    while(value_ != 0L)
    {
        result += 1L;
        value_ /= 2L;

    }

    return result;
}

fun microwave(value : Long, iteractions : Long=0) : Pair<Long, Long> {
    val sqrtValue = customSqrt(value - 1);
    val currectValue = Math.pow(2.0, sqrtValue.toDouble()).toLong();
    val ostatok = value - currectValue;


    if (ostatok != 0L)
        return microwave(ostatok, iteractions + 1);
    else
        return Pair(value, iteractions + 1);
}