#include <bits/stdc++.h>

using namespace std;
//#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }

    if (n == 1) {
        cout << x[0] << " " << y[0];
        return;
    }
    int j = 0;
    for (int i = 1; i < n; ++i) {
        if (x[i] != x[0] && y[i] != y[0] && abs(x[i] - x[0]) != abs(y[i] - y[0])) {
            j = i;
            break;
        }
    }
    if (j) {
        vector<int> px{x[0], x[j], x[0] + (y[j] - y[0]), x[j], x[j] + (y[0] - y[j]), x[0], x[0] - (y[j] - y[0]), x[j],
                       x[j] - (y[0] - y[j]), x[0]};
        vector<int> py{y[j], y[0], y[j], y[0] + (x[j] - x[0]), y[0], y[j] + (x[0] - x[j]), y[j], y[0] - (x[j] - x[0]),
                       y[0], y[j] - (x[0] - x[j])};
        swap(x, y);
        vector<int> pxr{x[0], x[j], x[0] + (y[j] - y[0]), x[j], x[j] + (y[0] - y[j]), x[0], x[0] - (y[j] - y[0]), x[j],
                        x[j] - (y[0] - y[j]), x[0]};
        vector<int> pyr{y[j], y[0], y[j], y[0] + (x[j] - x[0]), y[0], y[j] + (x[0] - x[j]), y[j], y[0] - (x[j] - x[0]),
                        y[0], y[j] - (x[0] - x[j])};
        swap(x, y);
        for (int i = 0; i < pxr.size(); ++i) {
            px.push_back(pxr[i]);
            py.push_back(pyr[i]);
        }

        if (abs(x[0] - y[0]) % 2 == abs(x[j] + y[j]) % 2) {
            int xx = ((x[0] - y[0]) + (x[j] + y[j])) / 2;
            int yy = xx - (x[0] - y[0]);
            px.push_back(xx);
            py.push_back(yy);
        }
        if (abs(x[0] + y[0]) % 2 == abs(x[j] - y[j]) % 2) {
            int xx = ((x[0] + y[0]) + (x[j] - y[j])) / 2;
            int yy = (x[0] + y[0]) - xx;
            px.push_back(xx);
            py.push_back(yy);
        }
        for (int p = 0; p < px.size(); ++p) {
            int flag = 1;
            for (int i = 0; i < n; ++i) {
                if (x[i] != px[p] && y[i] != py[p] && abs(x[i] - px[p]) != abs(y[i] - py[p])) {
                    flag = 0;
                    break;
                }
            }
            if (flag) {
                cout << "YES\n";
                cout << px[p] << " " << py[p] << '\n';
                return;
            }
        }
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << x[0] << " " << y[0] << '\n';
    }
}

void solveG() {
    int p, n, m;
    cin >> n >> p >> m;
    vector<vector<vector<int>>> dp(n - p + 1, vector<vector<int>>(512, vector<int>(n + 1, 0)));
    vector<vector<vector<int>>> pr(n - p + 1, vector<vector<int>>(512, vector<int>(n + 1, 0)));
    dp[0][p][0] = 1;
    for (int i = 0; i <= n; ++i) {
        pr[0][p][i] = 1;
    }
    for (int cnt = 1; cnt <= n - p; ++cnt) {
        for (int xr = 0; xr < 512; ++xr) {
            for (int last = 1; last <= cnt; ++last) {
                dp[cnt][xr][last] = pr[cnt - last][xr ^ last][min(last, cnt - last)];
                pr[cnt][xr][last] = pr[cnt][xr][last - 1] + dp[cnt][xr][last];
                pr[cnt][xr][last] %= m;
//                cout << cnt << " " << xr << " " << last << " " << dp[cnt][xr][last] << "\n";
            }
        }
    }
    cout << pr[n - p][0][n - p];
}


signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solveG();
    }
}
