#include <bits/stdc++.h>
using namespace std;

#define int long long
#define double long double

#define all(x) x.begin(), x.end()

const int INF = 2e9 + 5;
const double eps = 1e-10;

const int mod = 1e9 + 7;
const int SZ = 1 << 10;

void solve(){

	int n;
	cin >> n;

	vector<int> a(n);
	for (int i = 0; i < n; i++){
		cin >> a[i];		
	}
	
	vector<int> b(n);
	for (int i = 0; i < n; i++){
		cin >> b[i];		
	}

	vector<int> mnp(n);
	for (int i = 0; i < n; i++){
		if (b[0] > a[i]){
			mnp[i] = -1;
			continue;
		}

		int l = 0;
		int r = n;
		while (l < r - 1){
			int mid = (l + r) >> 1;
			if (b[mid] > a[i]){
				r = mid;
			}else{
				l = mid;
			}
		} 

		mnp[i] = l;
	}

	int mna = n;
	for (int i = 0, j = 0; i < n; i++){
		while (j < n && b[j] < a[i]){
			j++;
		}
		// cout << i << ' ' << j << ' ' << n << endl;
		if (j < n){
			mna--;
		}
		j++;
	}

	int ost = INF;
	int mxa = 0;
	for (int i = n - 1; i >= 0; i++){
		ost = min(ost - 1, mnp[i]);
		if (ost < 0){
			break;
		}
		mxa++;
	}

	assert(mna <= mxa);

	cout << mxa - mna + 1 << '\n';
	for (int i = mna; i <= mxa; i++){
		cout << i << ' ';
	}

}

signed main(){

	// freopen("input.txt", "r", stdin);

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cout << fixed << setprecision(10);

	int t = 1;
	// cin >> t;

	while (t--){
		solve();
		cout << '\n';
	}

}