#include <bits/stdc++.h>
#define ll long long
#define pll pair<ll, ll>
#define ld long double
#define pld pair<ld, ld>
#define mp make_pair
#define pb push_back
#define fi first
#define se second
#define all(x) x.begin(),x.end()

using namespace std;

vector<int> cc[400001];
int am[400001];
int cl[400001];
int n;

int get_am(int h, int p = -1) {
    if (am[h] > 0) {
        return am[h];
    }
    am[h] = 1;
    for (auto i : cc[h]) {
        if (i != p) {
            am[h] += get_am(i, h);
        }
    }
    return am[h];
}

int get_centroid(int h, int p = -1) {
    for (auto i : cc[h]) {
        if (i != p && get_am(i, h) > n) {
            return get_centroid(i, h);
        }
    }
    return h;
}

bool tt[400001];
vector<int> ans;
int pp[400001];

bool dfs(int h, int p = -1) {
    if (tt[cl[h]]) return false;
    ans.pb(h);
    tt[cl[h]] = true;
    for (auto i : cc[h]) {
        if (i != p) {
            if (!dfs(i, h)) {
                return false;
            }
        }
    }
    return true;
}

void dfs_2(int h, int p = 0) {
    pp[h] = p;
    for (auto i : cc[h]) {
        if (i != p) {
            dfs_2(i, h);
        }
    }
}

vector<int> sat[400001], rsat[400001];

int sat_not(int x) {
    if (x > n * 2) {
        return x - n * 2;
    } else {
        return x + n * 2;
    }
}

void add_or(int x, int y) {
    sat[sat_not(x)].push_back(y);
    sat[sat_not(y)].push_back(x);
    rsat[y].push_back(sat_not(x));
    rsat[x].push_back(sat_not(y));
}

vector<int> cls[400001];

bool tt2[1000001];
vector<int> top_sort;

void dfs_3(int h) {
    if (!tt2[h]) {
        tt2[h] = true;
    } else {
        return;
    }
    for (auto i : sat[h]) {
        dfs_3(i);
    }
    top_sort.push_back(h);
}

int cond[400001];

void dfs_4(int h, int k) {
    if (!tt2[h]) {
        tt2[h] = true;
    } else {
        return;
    }
    cond[h] = k;
    for (auto i : rsat[h]) {
        dfs_4(i, k);
    }
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n * 2; i++) {
        cin >> cl[i];
        cls[cl[i]].pb(i);
    }
    for (int i = 1; i < 2 * n; i++) {
        int x, y;
        cin >> x >> y;
        cc[x].pb(y);
        cc[y].pb(x);
    }
    int h = get_centroid(1);
    int u = -1;
    for (auto i : cc[h]) {
        if (get_am(i) < get_am(h) && get_am(i) == n) {
            u = i;
            break;
        }
    }
    dfs_2(h);
    add_or(h, h);
    if (u != -1) {
        if (dfs(u, h)) {
            for (int i = 0; i < n; i++) {
                cout << ans[i] << " ";
            }
            cout << "\n";
            return;
        } else if (cl[u] == cl[h]) {
            cout << "-1\n";
            return;
        } else {
            add_or(u, u);
        }
    }
    for (int i = 1; i <= n; i++) {
        add_or(cls[i][0], cls[i][1]);
        add_or(sat_not(cls[i][0]), sat_not(cls[i][1]));
    }
    for (int i = 1; i <= 2 * n; i++) {
        if (pp[i] > 0) {
            add_or(sat_not(i), pp[i]);
        }
    }

    top_sort.clear();
    for (int i = 1; i <= 4 * n; i++) {
        tt2[i] = 0;
    }
    for (int i = 1; i <= 4 * n; i++) {
        if (!tt2[i]) {
            dfs_3(i);
        }
    }
    for (int i = 1; i <= 4 * n; i++) {
        tt2[i] = 0;
        cond[i] = 0;
    }
    int k = 0;
    reverse(all(top_sort));
    for (auto i : top_sort) {
        if (!tt2[i]) {
            dfs_4(i, ++k);
        }
    }
    vector<int> answer;
    for (int i = 1; i <= n * 2; i++) {
        if (cond[sat_not(i)] < cond[i]) {
            answer.push_back(i);
        }
    }
    if (answer.size() < n) {
        cout << "-1\n";
    } else {
        for (auto i : answer) {
            cout << i << " ";
        }
        cout << "\n";
    }
    
    for (int i = 1; i <= 4 * n; i++) {
        cl[i] = 0;
        cc[i].clear();
        am[i] = 0;
        cond[i] = 0;
        sat[i].clear();
        rsat[i].clear();
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
