#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

using namespace std;

#define ll long long

const int K = 5;

int get(ll n, int b) {
	int cnt = 0;
	while (n) {
		cnt += n % b == 0;
		n /= b;
	}
	return cnt;
}

int get_ans(ll n) {
	int res = 0;
	for (ll b = 2; b * b <= n; b++) {
		int val = get(n, b);
		if (val >= K)
			return -1;
		res = max(res, val);
	}
	return res;
}

// map<ll, vector<int>> mp;

void solve() {
	ll n;
	cin >> n;
	int res = 0;
	vector<int> ans;
	for (int b = 2; b <= 1e5; b++) {
		int cur = get(n, b);
		if (cur > res) {
			res = cur;
			ans = {b};
		} else if (cur == res) {
			ans.push_back(b);
		}
	}
	cout << res << " " << ans.size() << "\n";
	for (int i : ans)
		cout << i << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);


	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}

	return 0;
}