#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 2;
int x[N], y[N], n;

bool lie(int x1, int y1, int x2, int y2) {
    return x1 == x2 || y1 == y2 || abs(x1 - x2) == abs(y1 - y2);
}

bool all_lie(int xx, int yy) {
    for (int i = 0; i < n; ++i) {
        if (!lie(x[i], y[i], xx, yy))
            return false;
    }
    return true;
}

void solve() {
    cin >> n;
    int init_x = -1, init_y = -1;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
        if (i > 0) {
            x[i] -= x[0];
            y[i] -= y[0];
        } else {
            init_x = x[0];
            init_y = y[0];
        }
    }
    x[0] = y[0] = 0;
    vector<pair<int, int>> to_check;
    for (int i = 1; i < n; ++i) {
        if (!lie(x[0], y[0], x[i], y[i])) {
            to_check.emplace_back(0, y[i]);
            to_check.emplace_back(y[i], y[i]);
            to_check.emplace_back(-y[i], y[i]);

            to_check.emplace_back(x[i], 0);
            to_check.emplace_back(x[i], -x[i]);
            to_check.emplace_back(x[i], x[i]);

            to_check.emplace_back(0, x[i] + y[i]);
            to_check.emplace_back(x[i] + y[i], 0);
            if ((y[i] + x[i]) % 2 == 0) {
                to_check.emplace_back((y[i] + x[i]) / 2, (y[i] + x[i]) / 2);
            }

            to_check.emplace_back(0, -x[i] + y[i]);
            to_check.emplace_back(x[i] - y[i], 0);
            if ((x[i] - y[i]) % 2 == 0) {
                to_check.emplace_back((x[i] - y[i]) / 2, (x[i] - y[i]) / 2);
            }

            for (auto [xx, yy] : to_check) {
                if (all_lie(xx, yy)) {
                    cout << "YES\n";
                    cout << xx + init_x << " " << yy + init_y << "\n";
                    return;
                }
            }
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
    cout << init_x << " " << init_y << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T; cin >> T;
    while (T--)
        solve();
    return 0;
}