#include <bits/stdc++.h>

// #pragma GCC optimize("O3")

using namespace std;

int n;
int k;

bool bit(int mask, int i) {
	return (mask >> i) & 1;
}

int ask(int i, int j) {
	assert(1 <= i && i <= j && j <= n);
	cout << i << " " << j << endl;
	int res;
	cin >> res;
	if (res == n)
		exit(0);
	return res;
}

bool cur_open(int i) {
	int cur = ask(i, i);
	bool res = cur < k;
	ask(i, i);
	return res;
}

void solve() {
	cin >> n;
	cin >> k;
	if (k == n)
		return;
	for (int i = 1; i <= n;) {
		if (cur_open(i)) {
			i++;
			continue;
		}
		vector<int> segs;
		int j = i;
		while (j <= n && !cur_open(j)) {
			segs.push_back(j);
			j++;
		}
		// cerr << "k: " << k << "\n";
		// cerr << "segs: ";
		for (int x : segs)
			cerr << x << " ";
		cerr << "\n";
		int N = segs.size();
		bool was = false;
		for (int j = 1; j < 1 << N; j++) {
			// cerr << "j: " << j << "\n";
			int x = j ^ (j >> 1);
			int last = (j - 1) ^ ((j - 1) >> 1);
			int cnt = 0;
			for (int k = 0; k < N; k++) {
				if (bit(x ^ last, k)) {
					cnt++;
				}
			}
			assert(cnt == 1);
			for (int t = 0; t < N; t++) {
				if (bit(x ^ last, t)) {
					int cur = ask(i, segs[t]);
					// cerr << "cur: " << cur << "\n";
					if (cur > k) {
						// cerr << "break\n";
						was = true;
						k = cur;
						break;
					}
				}
			}
			if (was)
				break;
		}
		assert(was);
	}
	assert(k == n);
	assert(false);
}

int main() {
	int T = 1;
	// cin >> T;
	while (T--) {
		solve();
	}

	return 0;
}