#include <bits/stdc++.h>

using namespace std;

bool ok(char x) {
	return x == 'a' || x == 'e' || x == 'i' || x == 'o' || x == 'u' || x == 'y';
}

int main() {
	string s, t;
	cin >> s >> t;
	if (s.size() > t.size()) {
		cout << "Different\n";
		return 0;
	}
	for (char &c : s)
		c = tolower(c);
	for (char &c : t)
		c = tolower(c);

	int n = s.size();
	int m = t.size();
	vector<vector<bool>> dp(n + 1, vector<bool>(m + 1));
	dp[0][0] = true;
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= m; j++) {
			if (!dp[i][j])
				continue;
			if (i < n && j < m && s[i] == t[j]) {
				dp[i + 1][j + 1] = true;
			}
			if (j < m && ok(t[j]))
				dp[i][j + 1] = true;
		}
	}
	// for (int i = 0; i <= n; i++) {
	// 	for (int j = 0; j <= m; j++)
	// 		cerr << dp[i][j] << " ";
	// 	cerr << "\n";
	// }
	if (dp[n][m])
		cout << "Same\n";
	else
		cout << "Different\n";

	return 0;
}