#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
    for (auto& e : v)
    {
        in >> e;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
    for (auto& e : v)
    {
        out << e << " ";
    }
    return out;
}

void solve()
{
    long long n = (1LL << 60) - 1;
    cin >> n;

    int max_cnt0 = 0;
    vector<long long> ans;
    for (long long base = 2; base * base <= n && base <= 34000; base++)
    {
        long long tmp = n;
        int cur_cnt = 0;
        while (tmp > 0)
        {
            cur_cnt += tmp % base == 0;
            tmp /= base;
        }
        if (cur_cnt > max_cnt0)
        {
            ans.clear();
            max_cnt0 = cur_cnt;
        }
        if (cur_cnt == max_cnt0)
        {
            ans.push_back(base);
        }
    }

    if (max_cnt0 <= 1)
    {
        max_cnt0 = 1;
        ans.push_back(n);
    }

    cout << max_cnt0 << " " << ans.size() << "\n";
    cout << ans << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    cerr << "Ready" << endl;
    #endif

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}