#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <set>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
	for (auto& e : v)
	{
		in >> e;
	}
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
	for (auto& e : v)
	{
		out << e << " ";
	}
	return out;
}

const int INF = 1e18;

vector<string> gen(int k) {
	if (k == 1) {
		return { "0", "1" };
	}
	auto v = gen(k - 1);
	auto r = v;
	for (auto& e : r) e.push_back('0');
	reverse(v.begin(), v.end());
	for (auto& e : v) e.push_back('1'), r.push_back(e);
	return r;
}
int n;
int solve_n(int k) {
	int p = n - k + 1;
	auto r = gen(k);
	vector<int> g(r.size());
	cin >> g[0];
	bool sw = 0;
	if (g[0] == n) exit(0);
	if (g[0] > p) {
		cout << "1 " << k - 1 << endl;
		cin >> g[0];
		sw = 1;
		if (g[0] == n) exit(0);
	}
	int cnt1 = g[0] == p;
	int cnt1_pos = g[0] == p ? 0 : -1;
	for (int i = 1; i < r.size(); ++i) {
		for (int j = 0; j < k; ++j) {
			if (r[i][j] != r[i - 1][j]) {
				cout << k - j << " " << k << endl;
				break;
			}
		}
		cin >> g[i];
		if (g[i] == n) exit(0);
		if (g[i] > p || (g[i] == p && cnt1)) {
			if (!sw) {
				cout << "1 " << k - 1 << endl;
				sw = 1;
				cin >> g[i];
			}
			if (g[i] == n) exit(0);
		}
		if (g[i] >= p) {
			cnt1 = 1;
			cnt1_pos = i;
		}
	}
	assert(cnt1);
	vector<int> neq;
	for (int j = 0; j < k; ++j) {
		if (r.back()[j] != r[cnt1_pos][j]) {
			neq.push_back(k - j);
		}
	}
	for (int j = 0; j < neq.size(); ++j) {

		cout << neq[j] << " " << k << endl;
		if (j + 1 < neq.size()) {
			cin >> neq[j];
			if (neq[j] == n) exit(0);
		}
	}
	solve_n(k - 1);
}

void solve()
{
	cin >> n;
	solve_n(n);
}

signed main()
{

#ifdef LOCAL
	cerr << "Ready" << endl;
#endif
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
}