#include <bits/stdc++.h>
#define ll long long

using namespace std;


int type(ll x1, ll y1, ll x2, ll y2) {
    if (x1 == x2) {
        return 1;
    } else if (y1 == y2) {
        return 2;
    } else if (x1 - x2 == y1 - y2) {
        return 3;
    } else if (x1 - x2 == y2 - y1) {
        return 4;
    }
    return 5;
}

int check(int p, ll xl, ll yl, ll x, ll y) {
    if (p == 5) {
        return 5;
    }
    if (p == 0) {
       return type(xl, yl, x, y);
   }
   int t = type(xl, yl, x, y);
    if (t == p) {
        return t;
    } else {
        return 5;
    }
}

void common_point(list<pair<ll, ll>>& res, pair<ll, ll> p1, int t1, pair<ll, ll> p2, int t2) {
    if (t1 == t2) {
        return;
    }
    if (t1 > t2) {
        swap(t1, t2);
        swap(p1, p2);
    }
    if (t1 == 0 && t2 == 1) {
        res.push_back({p1.first, p2.second});
    } else if (t1 == 1 && t2 == 2) {
        res.push_back({p2.first + p1.second - p2.second, p1.second});
    } else if (t1 == 1 && t2 == 3) {
        res.push_back({p2.first - p1.second + p2.second, p1.second});
    } else if (t1 == 0 && t2 == 2) {
        res.push_back({p1.first, p2.second + p1.first - p2.first});
    } else if (t1 == 0 && t2 == 3) {
        res.push_back({p1.first, p2.second - p1.first + p2.first});
    } else if (t1 == 2 && t2 == 3) {
        ll r = (p2.first - p1.first + p2.second - p1.second);
        if (r % 2 == 0) {
            r = r / 2;
            res.push_back({p1.first + r, p1.second + r});
        }
    }
}

int set_common_points(list<pair<ll, ll>>& res, pair<ll, ll> p1, pair<ll, ll> p2) {
    int r = type(p1.first, p1.second, p2.first, p2.second);
    for (int i = 0; i < 4; i++) {
        if (i == r - 1) {
            continue;
        }
        for (int j = 0; j < 4; j++) {
            if (i == j || j == r - 1) {
                continue;
            }
            common_point(res, p1, i, p2, j);
        }
    }
    return r;
}

void set_common_points(list<pair<ll, ll>>& res, pair<ll, ll> p1, pair<ll, ll> p2, int t) {
    for (int i = 0; i < 4; i++) {
        if (i != t) {
            common_point(res, p1, i, p2, t);
        }
    }
}

void validate(list<pair<ll, ll>>& res, pair<ll, ll> p) {
    for (auto it = res.begin(); it != res.end();) {
        if (type(it->first, it->second, p.first, p.second) == 5) {
            it = res.erase(it);
        } else {
            it++;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    vector<pair<ll, ll>> points;
    set<pair<ll, ll>> points_s;
    points.reserve(n);
    list<pair<ll, ll>> ipoints;
    int p = 0;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        if (points.size() and x == points.back().first and y == points.back().second) continue;
        if (p == 5 && ipoints.size() == 0) {
            continue;
        }
        if (i != 0 && p != 5) {
            p = check(p, points.back().first, points.back().second, x, y);
            if (p == 5) {
                int r = set_common_points(ipoints, {x, y}, points.back());
                if (r != 5) {
                    set_common_points(ipoints, points.front(), {x, y}, r);
                }
                for (const auto& p : points) {
                    validate(ipoints, p);
                }
            }
        } else {
            validate(ipoints, {x, y});
        }
        points.push_back({x, y});
    }
    if (ipoints.size() == 0 && p == 5) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        if (p != 5) {
            cout << points.front().first << " " << points.front().second << "\n";
        } else {
            cout << ipoints.front().first << " " << ipoints.front().second << "\n";
        }
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}