//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>

#define forn(i, st, fi) for (int i = (st); i < (fi); ++i)
#define fornr(i, st, fi) for (int i = (st); i >= (fi); --i)
#define vc vector
#define vi vector<int>
#define vll vector<long long>

using namespace std;
typedef long long ll;
typedef long double ld;
constexpr int INF = 1e9;
constexpr ll ll_INF = 1e18;
constexpr ld eps = 1e-9;
const ld pi = acos(-1);

template<typename T>
ostream &operator<<(ostream &out, vc<T> vector1) {
    for (auto &&elem: vector1) {
        out << elem << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vc<T> &vector1) {
    for (auto &&elem: vector1) {
        in >> elem;
    }
    return in;
}

ll bin_pow_upper_n(const ll& a, const ll& pow, const ll& n) {
    if (pow == 0) return 1;
    if (pow == 1) return (a > n ? 0 : a);
    if (pow % 2 == 0) {
        ll res = bin_pow_upper_n(a, pow/2, n);
        return (res <= (n + res - 1) / res ? res * res : 0);
    }
    ll res2 = bin_pow_upper_n(a, pow - 1, n);
    if (res2 > (n + a - 1) / a) {
        return 0;
    }
    return a * res2;
}

void solve() {
    ll n; cin >> n;
    vi ans; int cnt_ans = 0, base = 2;
    while(base <= n) {
        if (bin_pow_upper_n(base, cnt_ans, n) == 0) {
            break;
        }
        ll copy = n;
        int cnt_z = 0;
        while (copy != 0) {
            cnt_z += (copy % base == 0);
            copy /= base;
        }
        if (cnt_z > cnt_ans) {
            ans.clear();
            cnt_ans = cnt_z;
        }
        if (cnt_z == cnt_ans) {
            ans.push_back(base);
        }
        ++base;
    }
    cout << cnt_ans << ' ' << ans.size() << '\n' << ans << (ans.empty() ? "" : "\n");
}



signed main() {
    int t = 1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    cout << fixed;
//    cout << setprecision(10);
    cin >> t;
    while (t--) {
        solve();
    }
}