//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>

#define forn(i, st, fi) for (int i = (st); i < (fi); ++i)
#define fornr(i, st, fi) for (int i = (st); i >= (fi); --i)
#define vc vector
#define vi vector<int>
#define vll vector<long long>

using namespace std;
typedef long long ll;
typedef long double ld;
constexpr int INF = 1e9;
constexpr ll ll_INF = 1e18;
constexpr ld eps = 1e-9;
const ld pi = acos(-1);
mt19937 gen;

template<typename T>
ostream &operator<<(ostream &out, vc<T> vector1) {
    for (auto &&elem: vector1) {
        out << elem << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vc<T> &vector1) {
    for (auto &&elem: vector1) {
        in >> elem;
    }
    return in;
}

int g_n;

vector<bool> ch_vis(int visible, int l, int r) {
    vector<bool> is_visible(r - l + 1, false);
    for (int i = l; i <= r; ++i) {
        cout << i << " " << i << endl;
        cout.flush();
        int v;
        cin >> v;
        if (v == g_n) exit(0);
        if (v != visible) {
            is_visible[i - l] = true;
        }
        if (v <= visible) {
            cout << i << " " << i << endl;
            cout.flush();
            cin >> v;
            if (v == g_n) exit(0);
        }
    }
    return is_visible;
}

void rec(int l, int r, int visible) {
    int n = r - l + 1;
    vector<int> p(1 << n);
    for (int i = 1; i < (1 << n); ++i) {
        p[i] = i;
    }
    shuffle(p.begin(), p.end(), gen);
    for (int i = 0; i < p.size(); ++i) {
        vector<pair<int, int>> is_a;
        for (int j = 0; j < n; ++j) {
            if (p[i] & (1 << j)) is_a.push_back({l, j + l});
        }
        int v = visible;
        for (auto [x, y]: is_a) {
            cout << x << " " << y << endl;
            cout.flush();
            cin >> v;
            if (v == g_n) exit(0);
        }
        if (v != visible) {
            vector<bool> is_visible = ch_vis(v, l, r);
            for (int k = l; k <= r; ++k) {
                int s = k;
                while (k <= r && !is_visible[k - l]) {
                    k++;
                }
                if (s == k) continue;
                rec(s, k - 1, v);
            }
            return;
        } else {
            for (auto [x, y]: is_a) {
                cout << x << " " << y << endl;
                cout.flush();
                cin >> v;
                if (v == g_n) exit(0);
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    g_n = n;
    int visible;
    cin >> visible;
    vector<bool> is_visible = ch_vis(visible, 1, n);
    for (int i = 0; i < n; ++i) {
        int s = i;
        while (i < n && !is_visible[i]) {
            i++;
        }
        if (s == i) continue;
        rec(s + 1, i, visible);
    }

}


signed main() {
    int t = 1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    gen.seed(time(0));
//    cout << fixed;
//    cout << setprecision(10);
//    cin >> t;
    while (t--) {
        solve();
    }
}