//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>

#define forn(i, st, fi) for (int i = (st); i < (fi); ++i)
#define fornr(i, st, fi) for (int i = (st); i >= (fi); --i)
#define vc vector
#define vi vector<int>
#define vll vector<long long>

using namespace std;
typedef long long ll;
typedef long double ld;
constexpr int INF = 1e9;
constexpr ll ll_INF = 1e18;
constexpr ld eps = 1e-9;
const ld pi = acos(-1);

template<typename T>
ostream &operator<<(ostream &out, vc<T> vector1) {
    for (auto &&elem: vector1) {
        out << elem << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vc<T> &vector1) {
    for (auto &&elem: vector1) {
        in >> elem;
    }
    return in;
}

void solve() {
    int n;
    cin >> n;
    vi a(n), b(n);
    cin >> a >> b;
    vi x;
    int l_ans = -INF, r_ans = -INF;
    int j = 0, cnt = 0;
    forn(i, 0, n) {
        while (j < b.size() && b[j] < a[i]) {
            j++, cnt++;
        }
        r_ans = max(r_ans, (i + 1) - cnt);
    }
    r_ans = n - r_ans, cnt = 0, j = n - 1;
    fornr(i, n - 1, 0) {
        while (j >= 0 && b[j] > a[i]) {
            j--, cnt++;
        }
        l_ans = max(l_ans, n - i - cnt);
    }
    cout << r_ans - l_ans + 1 << '\n';
    forn(k, l_ans, r_ans + 1) cout << k << ' ';
}


signed main() {
    int t = 1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    cout << fixed;
//    cout << setprecision(10);
//    cin >> t;
    while (t--) {
        solve();
    }
}