#include <iostream>
#include <vector>
#include <string>
#include <cstdint>
#include <utility>

using namespace std;


vector<vector<bool>> generate2(int x) {
    if (x == 1) {
        return {{0}, {1}};
    }
    vector<vector<bool>> y = generate2(x-1);
    vector<vector<bool>> res(y.size() * 2);
    for (int i = 0; i < y.size(); ++i) {
        res[i] = y[i];
        res[i].insert(res[i].begin(), false);
    }
    for (int i = y.size(); i < 2*y.size(); i++) {
        res[i] = y[2*y.size() - i - 1];
        res[i].insert(res[i].begin(), true);
    }
    return res;
}

vector<int> generate(int x) {
    vector<vector<bool>> v = generate2(x);
    vector<int> ans(0);
    for (int i = 0; i < v.size() - 1; ++i) {
        for (int j = 0; j < v[i].size(); j++) {
            if (v[i][j] != v[i+1][j]) {
                ans.push_back(j+1);
                break;
            }
        }
    }
    for (int j = 0; j < v[0].size(); j++) {
        if (v[0][j] != v[v.size() - 1][j]) {
            ans.push_back(j+1);
            break;
        }
    }
    return ans;
}



int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int n, k;
    cin >> n;

    int prev_i = -1;
    int prev_j = -1;
    int arr_pos = -1;
    vector<int> a(0);
    bool start = true;
    int min_pos = -1;
    int min_ans = 0;
    int min_i = 1;
    int min_j = n;
    int init_k = 11;

    int cur = n;

    while (1) {
        cin >> k;
        if (k == n) {
            return 0;
        }

        if (start == false) {
            if (k > min_ans) {
                min_ans = k;
                min_pos = arr_pos;
            }
            arr_pos += 1;
            if (arr_pos < a.size()) {
                cout << a[arr_pos] << ' ' << cur << endl;
                continue;
            }
            else {
                if (min_pos != a.size() - 1) {
                    auto v = generate2(cur)[min_pos+1];
                    for (int j = 0; j < v.size(); j++) {
                        if (v[j]) {
                            cout << j + 1 << ' ' << cur << endl;
                            cin >> k;
                        }
                    }
                }
                start = true;
                cur -= 1;
            }
        }

        if (start == true) {
            min_pos = -1;
            min_ans = 0;
            a = generate(cur);
            arr_pos = 0;
            start = false;
            cout << a[0] << ' ' << cur << endl;
        }

    }

    return 0;
}