#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>

//#define int long long
#define f first
#define s second
#define eb emplace_back
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

typedef tree<
        pair <int, int>,
        null_type,
        less <>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e9 + 7;

pair <int, int> get_diag(int x, int y){
    if (x == 0 && y == 0){
        return {-1, 1};
    }
    int y1 = abs(x) + y;
    int y2 = y - abs(x);
    if (x > 0){
        return {max(y2, y1), min(y2, y1)};
    } else {
        return {min(y2, y1), max(y2, y1)};
    }
}

void solve(){
    int n;
    cin >> n;

    int curx, cury;
    cin >> curx >> cury;

    std::optional<int> x, y, l, r;
    x = curx;
    y = cury;
    auto diag = get_diag(curx, cury);
    l = diag.first;
    r = diag.second;

    // TODO: l, r
    set <pair <int, int>> points;
    for (int i = 1; i < n; i++){
        cin >> curx >> cury;
        diag = get_diag(curx, cury);

        if (x.has_value() && x.value() != curx){
            points.insert({x.value(), cury});
            points.insert({x.value(), cury + x.value() + diag.second});
            points.insert({x.value(), cury - x.value() + diag.first});
            x.reset();
        }

        if (y.has_value() && y.value() != cury){
            points.insert({curx, y.value()});
            points.insert({y.value() - diag.first, y.value()});
            points.insert({diag.second - y.value(), y.value()});
            y.reset();
        }

        if (l.has_value() && l.value() != diag.first){
            points.insert({curx, l.value() + curx});
            points.insert({l.value() - cury, cury});
            if ((l.value() + diag.second) % 2 == 0){
                int mid = (l.value() + diag.second) / 2;
                points.insert({mid, mid});
            }
            l.reset();
        }

        if (r.has_value() && r.value() != diag.second){
            points.insert({curx, r.value() + curx});
            points.insert({cury - r.value(), cury});
            if ((r.value() + diag.first) % 2 == 0){
                int mid = (r.value() + diag.first) / 2;
                points.insert({mid, mid});
            }
            r.reset();
        }

        vector <pair <int, int>> del;
        for (auto point : points){
            if (point.first != curx && point.second != cury &&
                abs(point.first - curx) != abs(point.second - cury)){
                del.emplace_back(point);
            }
        }
        for (auto item: del){
            points.erase(item);
        }
    }

    if (points.empty()){
        cout << "NO" << '\n';
    } else {
        cout << "YES" << '\n';
        cout << points.begin()->first << ' ' << points.begin()->second << '\n';
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int ttt = 1;
    cin >> ttt;
    while (ttt--){
        solve();
    }
    return 0;
}
