#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define f first
#define s second
#define eb emplace_back
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

typedef tree<
        pair <int, int>,
        null_type,
        less <>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int dp[1500][1500];

void solve(){
    string s, f;
    cin >> s >> f;
    int n = s.size();
    int m = f.size();
    for (int i = 0; i < n; i++) {
        if (s[i] >= 'A' && s[i] <= 'Z') {
            s[i] = tolower(s[i]);
        }
    }
    for (int i = 0; i < m; i++) {
        if (f[i] >= 'A' && f[i] <= 'Z') {
            f[i] = tolower(f[i]);
        }
    }
    dp[0][0] = 1;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i + 1][j + 1] |= (dp[i][j] && s[i] == f[j]);
            dp[i][j + 1] |= (dp[i][j] && (f[j] == 'a' || f[j] == 'e' || f[j] == 'i' || f[j] == 'o' || f[j] == 'u' || f[j] == 'y'));
        }
    }
    int ans = 0;
    bool f1 = 1;
    for (int i = m; i >= 0; i--) {
        ans |= (dp[n][i] && f1);
        if (i != 0 && (f[i - 1] == 'a' || f[i - 1] == 'e' || f[i - 1] == 'i' || f[i - 1] == 'o' || f[i - 1] == 'u' || f[i - 1] == 'y'))
            continue;
        else
            f1 = 0;
    }
    if (ans) {
        cout << "Same\n";
    }
    else {
        cout << "Different\n";
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int ttt = 1;
    // cin >> ttt;
    while (ttt--){
        solve();
    }
    return 0;
}
