#include <bits/stdc++.h>

#define pb push_back
#define ll int64_t
#define int ll
#define F first
#define S second
#define pii pair<int, int>
#define graph vector<vector<int>>
#define graph_w vector<vector<pii>>

#ifndef OlegSanders
#define cerr if (0) cerr
#endif

using namespace std;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(10);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    vector<int> a(n),b(n);
    for (int i = 0;i < n;i++) cin >> a[i];
    for (int i = 0;i < n;i++) cin >> b[i];

    int m1 = 0,m2 = 0;
    int cnt = n - 1;
    for (int i = n - 1;i >= 0;i--) {
        while (cnt >= 0 && a[i] < b[cnt]) cnt--;
        if (cnt == -1) break;
        m2++;
        cnt--;
    }

    cnt = 0;
    for (int i = 0;i < n;i++) {
        while (cnt < n && a[i] > b[cnt]) cnt++;
        if (cnt == n) break;
        m1++;
        cnt++;
    }

    m1 = n - m1;

    cout << m2 - m1 + 1 << "\n";
    for (int i = m1;i <= m2;i++) cout << i << " ";
}

