#include <bits/stdc++.h>

const int N = 110;

int a[N], b[N];
bool dp[N][N];
bool par[N][N];
// false -> remove left

bool solve(int n, int minPos) {
	if (a[minPos] != b[0]) {
		return false;
	}

	memset(dp, false, sizeof(dp));
	dp[minPos][minPos] = true;
	for (int len = 1; len < n; ++len) {
		for (int l = 0; l + len - 1 < n; ++l) {
			int r = l + len - 1;
			if (!dp[l][r]) {
				continue;
			}

			if (l > 0 && a[l - 1] == b[len]) {
				dp[l - 1][r] = true;
				par[l - 1][r] = false;
			}
			if (r < n - 1 && a[r + 1] == b[len]) {
				dp[l][r + 1] = true;
				par[l][r + 1] = true;
			}
		}
	}

	return dp[0][n - 1];
}

std::vector<int> restore(int n) {
	int l = 0, r = n - 1;
	std::vector<int> ans(n);
	while (l <= r) {
		if (!par[l][r]) {
			ans[l] = r - l;
			++l;
		} else {
			ans[r] = r - l;
			--r;
		}
	}
	return ans;
}

int main(void) {
	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	for (int i = 0; i < n; ++i) {
		scanf("%d", &b[i]);
	}

	for (int minPos = 0; minPos < n; ++minPos) {
		if (solve(n, minPos)) {
			printf("YES\n");
			auto p = restore(n);
			int i = 0, j = 0;
			std::vector<int> st;
			while (i < n) {
				if (!st.empty() && st.back() == i) {
					printf("C");
					++i;
					st.pop_back();
					continue;
				}
				printf("S");
				st.push_back(p[j++]);
			}
			printf("\n");
			return 0;
		}
	}

	printf("NO\n");

	return 0;
}