#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int solve(vector<int> a, vector<int> b) {
	int n = int(a.size());
	int left = 0;
	int right = n + 1;
	while (left + 1 != right) {
		int mid = (left + right) / 2;
		bool ok = 1;
		for (int i = 0; i < mid; ++i) {
			ok &= a[i] < b[n - mid + i];
		}
		if (ok) left = mid; else right = mid;
	}
	return left;
}

void solveTest() {
	int n; cin >> n;
	vector<int> a(n);
	for (auto& x : a) cin >> x;
	vector<int> b(n);
	for (auto& x : b) cin >> x;
	int pref = solve(a, b);
	int suff = solve(b, a);
	vector<int> ans;
	for (int x = 0; x <= n; ++x) {
		if (x <= pref && n - x <= suff) {
			ans.push_back(n - x);
		}
	}
	reverse(ans.begin(), ans.end());
	cout << ans.size() << '\n';
	for (int x : ans) cout << x << ' ';
	cout << '\n';	
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	solveTest();
}