#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct Point{
	int row;
	int col;
	int diag_ll_ur;
	int diag_ul_lr;
};

struct ChessCovered
{
	int col;
	int row;
	int diag_ll_ur;
	int diag_ul_lr;
	vector<Point> covered;

};

int main() {
	/*int t;
	cin >> t;
	for (int test = 0; test < t; test++) {
		bool f_row = false;
		bool f_col = false;
		bool f_d_ll_ur = false;
		bool f_d_ul_lr = false;
		bool f_none = false;
		int n;
		cin >> n;
		ChessCovered data = { 1e9 + 1, 1e9 + 1, 1e9 + 1, 1e9 + 1, vector<Point>(0) };
		for (int i = 0; i < n; i++) {
			int x, y;
			cin >> x >> y;
			Point pt = { y, x, x - y, x + y };
			if (i == 0) {
				data.col = pt.col;
				data.row = pt.row;
				data.diag_ll_ur = pt.diag_ll_ur;
				data.diag_ul_lr = pt.diag_ul_lr;
			}
			else if (i == 1) {
				if (pt.col == data.col) {
					f_col = true;
					data.covered.push_back({data.row,});
				} else if (pt.row == data.row) {
					f_row = true;

				}
				else if (pt.diag_ll_ur == data.diag_ll_ur) {
					f_d_ll_ur = true;

				}
				else if (pt.diag_ul_lr == data.diag_ul_lr) {
					f_d_ul_lr = true;

				}
				else {
					f_none = true;
				}
			}
		}
	}*/

	long long n, P, M;
	cin >> n >> P >> M;
	if (n % 2 == 1 || n < 2 * P) {
		cout << 0;
		return 0;
	}
	long long rem = n - P;
	vector<vector<long long>> dp(rem + 1, vector<long long>(n + 1, 0));
	dp[0][0] = 1;
	for (long long max = 1; max <= rem; max++) {
		vector<vector<long long>> newDp = dp;
		for (long long sum = max; sum <= rem; sum++) {
			for (long long p = 0; p <= rem; p++) {
				newDp[sum][p] = dp[sum][p];
				for (long long k = max; k <= sum; k += max) {
					long long nextP = (k / max) % 2 == 0 ? p : (p ^ max);
					newDp[sum][p] += dp[sum - k][nextP];
					while (dp[sum][p] > M)
						dp[sum][p] -= M;
				}
			}
		}
		swap(newDp, dp);
	}
	cout << dp[rem][P];
}

/*
4
10 20 30 40
1 2 51 52
*/