#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 1010;
const int inf = 1e9 + 110;

int dist[N][N];
pair<pair<int, int>, int> from[N][N];

int main() {
#ifdef LOCAL
    freopen("in/in_S.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int d;
    cin >> d;
    for (int i = 0; i < d; i++) {
        for (int j = 0; j < d; j++) {
            dist[i][j] = inf;
        }
    }

    queue<pair<int, int>> q;
    for (int i = 1; i < 10; i++) {
        if (dist[i % d][i % d] == inf) {
            dist[i % d][i % d] = 1;
            from[i % d][i % d] = {{-1, -1}, i};
            q.push({i % d, i % d});
        }
    }

    while (!q.empty()) {
        auto [n_rem, sum_rem] = q.front();
        q.pop();

        for (int i = 0; i < 10; i++) {
            int new_n = (n_rem * 10 + i) % d;
            int new_sum = (sum_rem + i) % d;
            if (dist[new_n][new_sum] == inf) {
                dist[new_n][new_sum] = dist[n_rem][sum_rem] + 1;
                q.push({new_n, new_sum});
                from[new_n][new_sum] = {{n_rem, sum_rem}, i};
            }
        }
    }

    pair<int, int> now = {0, 0};
    vector<int> digits;
    while (now.first != -1) {
        digits.push_back(from[now.first][now.second].second);
        now = from[now.first][now.second].first;
    }

    reverse(digits.begin(), digits.end());
    for (auto d : digits) {
        cout << d;
    }
    cout << '\n';
}