#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 110;
int a[N], b[N];
bool dp[N][N][N];
int from[N][N][N];

void get_answer(int len, int l1, int l2) {
    if (len == 0) {
        return;
    }

    if (from[len][l1][l2] != 0) {
        get_answer(from[len][l1][l2], l1, l2);
        get_answer(len - from[len][l1][l2], l1 + from[len][l1][l2], l2 + from[len][l1][l2]);
    } else {
        cout << "S";
        get_answer(len - 1, l1 + 1, l2);
        cout << "C";
    }
}

int main() {
#ifdef LOCAL
    freopen("in/in_S.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (a[i] == b[j]) {
                dp[1][i][j] = true;
                from[1][i][j] = 0;
            }
        }
    }

    for (int len = 2; len <= n; len++) {
        for (int l1 = 1; l1 + len - 1 <= n; l1++) {
            for (int l2 = 1; l2 + len - 1 <= n; l2++) {
                if (a[l1] == b[l2 + len - 1] && dp[len - 1][l1 + 1][l2]) {
                    dp[len][l1][l2] = true;
                    continue;
                }

                for (int k = 1; k < len; k++) {
                    if (dp[k][l1][l2] && dp[len - k][l1 + k][l2 + k]) {
                        dp[len][l1][l2] = true;
                        from[len][l1][l2] = k;
                    }
                }
            }
        }
    }

    if (!dp[n][1][1]) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        get_answer(n, 1, 1);
        cout << '\n';
    }
}