#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

const int N = 2e5 + 10;
int a[N], b[N], first_bigger[N], suf[N], mn_suf[N], pref[N], max_pref[N];

int main() {
#ifdef LOCAL
    freopen("in/in_S.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    for (int j = 1; j <= n; j++) {
        cin >> b[j];
    }

    int ptr = 0;
    for (int i = 1; i <= n; i++) {
        while (ptr < n && b[ptr + 1] <= a[i]) {
            ptr++;
        }

        first_bigger[i] = ptr + 1;
    }

    for (int i = 1; i <= n; i++) {
        suf[i] = first_bigger[i] - 1 - i;
        pref[i] = first_bigger[i] - i;
    }

    mn_suf[n] = suf[n];
    for (int i = n - 1; i >= 1; i--) {
        mn_suf[i] = min(suf[i], mn_suf[i + 1]);
    }

    max_pref[1] = pref[1];
    for (int i = 2; i <= n; i++) {
        max_pref[i] = max(max_pref[i - 1], pref[i]);
    }

    vector<int> answer;
    for (int cnt_left = 0; cnt_left <= n; cnt_left++) {
        int pos_suf = n - cnt_left + 1;
        bool ok = true;

        if (pos_suf <= n) {
            ok &= mn_suf[pos_suf] >= 1 - pos_suf;
        }

        int pos_pref = pos_suf - 1;
        if (pos_pref >= 1) {
            ok &= max_pref[pos_pref] <= cnt_left;
        }

        if (ok) {
            answer.push_back(cnt_left);
        }
    }

    cout << answer.size() << '\n';
    for (auto x : answer) {
        cout << x << ' ';
    }
    cout << '\n';
}