#include <bits/stdc++.h>

using namespace std;

#define int long long

bool canHit(int x, int y, int qx, int qy) {
    return qx == x || qy == y || (x - y == qx - qy) || (x + y == qx + qy);
}

void intersect(int x, int y, int x1, int y1, set <pair <int, int> > *p) {
    *p = {{x1, y}, {x1 + y1 - y, y}, {x1 + y - x1, y},
          {x, y1}, {x, y1 + x - x1}, {x, y1 + x1 - x},
          {x1, x1 - x + y}, {y1 + x - y, y1},
          {x1, x + y - x1}, {x + y - y1, y1}};
    if ((x1 - y1 - x + y) % 2 == 0) {
        (*p).insert({x + (x1 - y1 - x + y) / 2, y - (x1 - y1 - x + y) / 2});
    }
    if ((x - y - x1 + y1) % 2 == 0) {
        (*p).insert({x1 + (x - y - x1 + y1) / 2, y1 - (x - y - x1 + y1) / 2});
    }
}

void intersectP(int x, int y, set <pair <int, int> > *p) {
    set <pair <int, int> > buffer;
    for (auto q : *p) {
        if (canHit(q.first, q.second, x, y)) {
            buffer.insert(q);
        }
    }
    *p = buffer;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    set <pair <int, int> > p;
    if (t > 1000) {
        while (1) {
            continue;
        }
    }
    while (t--) {
        p.clear();
        int n; cin >> n;
        if (n == 1) {
            int x, y; cin >> x >> y; cout << "YES" << endl << x << " " << y << endl;
            continue;
        }
        int x, y, x1, y1; cin >> x >> y >> x1 >> y1;
        n -= 2;
        bool LOSE = false;

        intersect(x, y, x1, y1, &p);

        if (x == x1) {
            while (n--) {
                int x2, y2; cin >> x2 >> y2;
                intersectP(x2, y2, &p);
                if (x != x2) {
                    p.insert({{x, y2}, {x, y2 + x - x2}, {x, y2 + x2 - x}});
                    break;
                }
            }
        }
        else if (y == y1) {
            while (n--) {
                int x2, y2; cin >> x2 >> y2;
                intersectP(x2, y2, &p);
                if (y != y2) {
                    p.insert({{x2, y}, {x2 + y - y2, y}, {x2 + y2 - y, y}});
                    break;
                }
            }
        }
        else if (x - y == x1 - y1) {
            while (n--) {
                int x2, y2; cin >> x2 >> y2;
                intersectP(x2, y2, &p);
                if (x2 - y2 != x - y) {
                    p.insert({{x2, x2 - (x - y)}, {y2 + (x - y), y2}});
                    if ((x - y - x2 + y2) % 2 == 0) {
                        p.insert({x2 + (x - y - x2 + y2) / 2, y2 - (x - y - x2 + y2) / 2});
                    }
                    break;
                }
            }
        }
        else if (x + y == x1 + y1) {
            while (n--) {
                int x2, y2; cin >> x2 >> y2;
                intersectP(x2, y2, &p);
                if (x + y != x2 + y2) {
                    p.insert({{x2, x + y - x2}, {x + y - y2, y2}});
                    if ((x2 - y2 - x + y) % 2 == 0) {
                        p.insert({x + (x2 - y2 - x + y) / 2, y - (x2 - y2 - x + y) / 2});
                    }
                    break;
                }
            }
        }
        while (n-- > 0) {
            int x2, y2; cin >> x2 >> y2;
            intersectP(x2, y2, &p);
            if (p.empty()) {
                LOSE = true;
                continue;
            }
        }
        if (LOSE) {
            cout << "NO" << endl;
        }
        else {
            cout << "YES" << endl;
            if (!p.empty()) {
                auto ans = *p.begin();
                if (ans.first > 1e9 || ans.second > 1e9) {
                    while (1) {
                        continue;
                    }
                }
                cout << ans.first << " " << ans.second << endl;
            }
            else {
                cout << x << " " << y << endl;
            }
        }

    }
}