#include <bits/stdc++.h>

using namespace std;

array<int, 3> with_square(array<int, 3> a, array<int, 3> b) {
    if (b[0] == 0) {
        if (a[1] == b[1] && a[2] == b[2]) {
            return a;
        }
    }
    if (b[0] == 1) {
        if (a[1] == b[1]) {
            return a;
        }
    }
    if (b[0] == 2) {
        if (a[2] == b[2]) {
            return a;
        }
    }
    if (b[0] == 3) {
        if (a[1]-b[1] == -(a[2]-b[2])) {
            return a;
        }
    }
    if (b[0] == 4) {
        if (a[1]-b[1] == (a[2]-b[2])) {
            return a;
        }
    }
    return {-1, -1, -1};
}
array<int, 3> with_vertical(array<int, 3> a, array<int, 3> b) {
    if (b[0] == 1) {
        if (a[1] == b[1]) {
            return a;
        }
    }
    if (b[0] == 2) {
        return {0, a[1], b[2]};
    }
    if (b[0] == 3) {
        return {0, a[1], b[2] + b[1] - a[1]};
    }
    if (b[0] == 4) {
        return {0, a[1], b[2] - b[1] + a[1]};
    }
    return {-1, -1, -1};
}
array<int, 3> with_horizontal(array<int, 3> a, array<int, 3> b) {
    if (b[0] == 2) {
        if (a[2] == b[2]) {
            return a;
        }
    }
    if (b[0] == 3) {
        return {0, b[1] + b[2] - a[2], a[2]};
    }
    if (b[0] == 4) {
        return {0, b[1] - b[2] + a[2], a[2]};
    }
    return {-1, -1, -1};
}
array<int, 3> with_main(array<int, 3> a, array<int, 3> b) {
    if (b[0] == 3) {
        if ((a[1]-b[1]) == -(a[2]-b[2])) {
            return a;
        }
    }
    if (b[0] == 4) {
        if (abs(a[1] + a[2]) % 2 == abs(b[1] + b[2]) % 2) {
            int diff = a[1]-b[1];
            b[1] += diff;
            b[2] -= diff;
            return {0, a[1] + a[2] - ((a[2] + b[2]) / 2), (a[2] + b[2]) / 2};
        }
    }
    return {-1, -1, -1};
}
array<int, 3> with_dop(array<int, 3> a, array<int, 3> b) {
    if (b[0] == 4) {
        if ((a[1]-b[1]) == (a[2]-b[2])) {
            return a;
        }
    }
    return {-1, -1, -1};
}

array<int, 3> sect(array<int, 3> a, array<int, 3> b) {
    if (a[0] > b[0]) {
        swap(a, b);
    }
    array<int, 3> r;
    if (a[0] == 0) {
        r = with_square(a, b);
    }
    if (a[0] == 1) {
        r =  with_vertical(a, b);
    }
    if (a[0] == 2) {
        r =  with_horizontal(a, b);
    }
    if (a[0] == 3) {
        r =  with_main(a, b);
    }
    if (a[0] == 4) {
        r =  with_dop(a, b);
    }
    return r;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> input(n);
    for (int i = 0; i < n; i ++) {
        cin >> input[i].first >> input[i].second;
    }
    vector<array<int, 3>> st;
    st.push_back({1, input[0].first, input[0].second});
    st.push_back({2, input[0].first, input[0].second});
    st.push_back({3, input[0].first, input[0].second});
    st.push_back({4, input[0].first, input[0].second});
    for (int i = 1; i < n; i ++) {
        vector<array<int, 3>> get;
        vector<array<int, 3>> new_st;
        get.push_back({1, input[i].first, input[i].second});
        get.push_back({2, input[i].first, input[i].second});
        get.push_back({3, input[i].first, input[i].second});
        get.push_back({4, input[i].first, input[i].second});
        for (auto j : st) {
            for (auto k : get) {
                array<int, 3> got = sect(j, k);
                if (got != array<int, 3>{-1, -1, -1}) {
                    new_st.push_back(got);
                }
            }
        }
        st = new_st;
    }
    if (!st.empty()) {
        cout << "YES\n";
        cout << st[0][1] << " " << st[0][2] << "\n";
    } else {
        cout << "NO\n";
    }
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i ++) {
        solve();
    }
}
