
#include <iostream>
#include <cassert>
#include <vector>

using namespace std;

int n, l;

int query(int i, int j) {
    cout << i << " " << j << endl;
    int k;
    cin >> k;
    if (k == n) {
        exit(0);
    }
    return k;
}

int state[15];

int get_bit(int m, int k) {
    return ((m >> k) & 1);
}

int main() {
    cin >> n >> l;
    if (l == n) exit(0);

    for (int i = 1; i <= n; ++i) {
        vector<int> history;

        int v = query(i, i);
        if (v == l - 1) {
            // она горела и перестала гореть
            // значит мы зря флипнули, возвращаем
            assert(query(i, i) == l);
            continue;
        }
        history.push_back(i);

        // иначе она не горела
        int num = n - i + 1;

        for (int mask = 1; mask < (1 << num); ++mask) {
            for (int j = i, b = 0; j <= n; ++j, ++b) {
                state[j] = get_bit(mask, b);
            }
            for (int h : history) {
                state[h] ^= 1;
            }
            for (int j = i; j <= n; ++j) {
                if (state[j]) {
                    l = query(i, j);
                    history.push_back(j);
                }
            }
            // Проверяем, заставили ли мы ее гореть
            if (query(i, i) == l - 1) {
                assert(query(i, i) == l);
                break;
            }
            history.push_back(i);
        }
    }

    return 0;
}
