
#include <iostream>
#include <vector>

using ll = long long;
using namespace std;

ll bits(ll a) {
    return __builtin_popcountll(a);
}

void solve() {
    ll x;
    cin >> x;
    ll res = 1e18;
    // добавили 0 -> степень двойки - 1 => (x + 1) = 2^k
    // добавили 1 -> (x + 1) = сумма двух степеней двоек

    for (ll i = 0; i <= 1000; ++i) {
        ll cur = x + i + 1;
        ll b = bits(cur);
        if (b <= i + 1) {
            res = min(res, i);
        }
    }
    cout << res << "\n";
}

void stupid() {
    int n;
    cin >> n;
    vector<int> dp(n+1, 1e9);
    dp[0] = 0;
    for (int i = 0; i <= n; ++i) {
        for (int cur = 0; i + ((1 << cur)-1) <= n; ++cur) {
            int nxt = i + ((1<<cur)-1);
            dp[nxt] = min(dp[nxt], dp[i] + 1);
        }
    }
    cout << dp[n] - 1 << "\n";
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
