
#include <iostream>
#include <string>

using namespace std;

string a, b;

const int N = 1100;
int dp[N][N];

bool isVowel(char c) {
    c = tolower(c);
    return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u' || c == 'y';
}

bool isEqual(char c, char b) {
    return tolower(c) == tolower(b);
}

int main() {
    cin >> a >> b;
    dp[0][0] = 1;

    int lenA = a.size();
    int lenB = b.size();
    for (int i = 0; i < lenA; ++i) {
        for (int j = 0; j < lenB; ++j) {
            if (dp[i][j] == 0) continue;

           // cout << i << " " << j << " " << a[i] << " " << b[j] << "\n";
            if (isEqual(a[i], b[j])) {
                dp[i+1][j+1] = 1;
            }

            if (isVowel(b[j])) {
                // Skip.
                dp[i][j+1] = 1;
            }
        }
    }

    for (int i = 0; i < lenB; ++i) {
        if (dp[lenA][i]) {
            if (isVowel(b[i])) {
                dp[lenA][i+1] = 1;
            }
        }
    }

    if (dp[lenA][lenB]) {
        cout << "Same";
    } else {
        cout << "Different";
    }
    cout << "\n";

    return 0;
}
