#include <bits/stdc++.h>

using namespace std;
#define int long long

using vi = vector<int>;
using pii = pair<int, int>;
using vpi = vector<pii>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;

const int INF = (int)1e18;


void solve() {
    int n, p, M;
    cin >> n >> p >> M;
    int k = n - p;
    vvvi dp(k + 1, vvi(2*k + 1, vi(k + 1, 0)));
    for (int i = 0; i <= k; i++) dp[0][0][i] = 1;
    for (int mx = 1; mx <= k; mx++) {
        for (int i = 0; i <= k; i++) {
            for (int j = 0; j <= 2 * k; j++) {
                int cur = 0;
                for (int cnt = 0; cnt * mx <= i; cnt++) {
                    int kek = (cnt % 2 == 0) ? 0 : mx;
                    if ((j ^ kek) >= 2 * k) continue;

                    cur += dp[i - cnt*mx][j ^ kek][mx - 1];
                }
                dp[i][j][mx] = cur;
            }
        }
    }

    // dp[5][3][5]
    cout << dp[n - p][p][n - p] << endl;
}

int N;

vector<vector<int>> g;
vector<vector<int>> gt;
vector<vector<int>> hg;

vector<int> htov;
vector<int> vtoh;

void markdfs(int v, int p) {
    for (auto& to : hg[v]) {
        if (to == p) continue;
        g[htov[v] ^ 1].push_back(htov[to] ^ 1);
        g[htov[to] ^ 1].push_back(htov[v] ^ 1);
        g[htov[to]].push_back(htov[v]);
        g[htov[v]].push_back(htov[to]);
        markdfs(to, v);
    }
}

vector<int> used1;
vector<int> ts1;
void dfs1(int v) {
    used1[v] = true;
    for (auto& to : g[v]) {
        if (used1[to]) continue;
        dfs1(to);
    }
    ts1.push_back(v);
}

vector<int> comp;
vector<vector<int>> vincomp;
void dfs2(int v, int c) {
    comp[v] = c;
    vincomp[c].push_back(v);
    used1[v] = true;
    for (auto& to : gt[v]) {
        if (used1[to]) continue;
        dfs2(to, c);
    }
}

vector<vector<int>> gcomp;
vector<bool> cused;
vector<int> ts2;

void dfs3(int v) {
    cused[v] = true;
    for (auto& to : gcomp[v]) {
        if (cused[to]) continue;
        dfs3(to);
    }
    ts2.push_back(v);
}

bool solveimp(bool tiktok) {
    g.assign(2 * N, vector<int> ());
    gt.assign(2 * N, vector<int> ());
    ts1.clear();
    ts2.clear();
    markdfs(htov[(int)tiktok], -1);
    used1.assign(2 * N , false);
    for (int i = 0; i < 2 * N; ++i) {
        if (!used1[i]) {
            dfs1(i);
        }
    }
    reverse(ts1.begin(), ts1.end());
    used1.assign(2 * N, false);
    comp.assign(2 * N, -1);
    int c = 0;
    vincomp.clear();
    for (auto& i : ts1) {
        if (!used1[i]) {
            vincomp.push_back(vector<int>());
            dfs2(i,c );
            ++c;
        }
    }

    gcomp.assign(c, vector<int>());
    for (int i = 0; i < 2 * N; ++i) {
        for (auto& to: g[i]) {
            if (comp[i] != comp[to]) {
                gcomp[i].push_back(to);
            }
        }
    }

    for (int i = 0; i < 2 * N; i += 2) {
        if (comp[i] == comp[i ^ 1]) {
            // cout << -1 << endl;
            return false;
        }
    }
    cused.assign(c, false);
    for (int i = 0; i < c; ++i) {
        if (!cused[i]) {
            dfs3(i);
        }
    }
    reverse(ts2.begin(), ts2.end());
    vector<int> ans(2 * N, -1);
    for (auto& component : ts2) {
        for (auto& v : vincomp[component]) {
            if (ans[v ^ 1] == -1) {
                ans[v] = false;
                ans[v ^ 1] = true;
            }
        }
    }
    if (tiktok) {
        cout << "SECOND\n";
    } else {
        cout << "FIRST\n";
    }
    for (int i = 0; i < 2 * N; ++i) {
        if (ans[i]) {
            cout << vtoh[i] + 1 << ' ';
        }
    }
    cout << endl;
    return true;
}

void solve2() {
    cin >> N;
    //cout << N << endl;
    vector<int> col(2 * N, -1);
    vector<int> cv(N, -1);
    htov.assign(2 * N, -1);
    vtoh.assign(2 * N, -1);
    g.assign(2 * N, vector<int>());
    for (int i = 0 ; i < 2 * N; ++i) {
        cin >> col[i];
        --col[i];
        //cout << col[i] << endl;
        if (cv[col[i]] == -1) {
            cv[col[i]] = i;
            vtoh[2 * col[i]] = i;
            htov[i] = 2 * col[i];
        } else {
            vtoh[2 * col[i] + 1] = i;
            htov[i] = 2 * col[i] + 1;
            int cur = 2 * col[i];
            g[cur].push_back(cur ^ 1);
            g[cur ^ 1].push_back(cur);
        }
    }
    hg.assign(2 * N, vector<int>());
    for (int i = 0; i < 2 * N - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        hg[a].push_back(b);
        hg[b].push_back(a);
    }
    if (!solveimp(false) && !solveimp(true)) {
        cout << -1 << endl;
    }
    // 0 is bebra!!!
    // ok




}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int nt = 1;
    //cin >> nt;
    while (nt--) {
        solve();
    }

}