#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

const int maxn = 512;
int dp[maxn][maxn][maxn] = {};

void solve() {
    int n, p, m;
    cin >> n >> p >> m;
    dp[0][0][maxn - 1] = 1;
    vector<int> suf(maxn);
    for (int sum = 0; sum < n - p; sum++) {
        for (int mask = 0; mask < maxn; mask++) {
            suf[maxn - 1] = dp[sum][mask][maxn - 1];
            for (int i = maxn - 2; i >= 0; i--) {
                suf[i] = suf[i + 1] + dp[sum][mask][i];
                if (suf[i] >= m) suf[i] -= m;
            }
            for (int k = 1; k <= n - p - sum; k++) {
                dp[sum + k][mask ^ k][k] += suf[k];
                if (dp[sum + k][mask ^ k][k] >= m) dp[sum + k][mask ^ k][k] -= m;
            }
        }
    }
    ll ans = 0;
    for (int i = 0; i < maxn; i++) {
        ans += dp[n - p][p][i];
        if (dp[n - p][p][i] >= m) dp[n - p][p][i] -= m;
    }
    cout << ans << '\n';
}

signed main() {
    solve();
}