#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

void solve() {
    string a, b;
    cin >> a >> b;
    for (auto &i: a) i = tolower(i);
    for (auto &i: b) i = tolower(i);
    if (b.size() < a.size()) {
        cout << "Different\n";
        return;
    }
    set<char> s;
    s.insert('a');
    s.insert('e');
    s.insert('i');
    s.insert('o');
    s.insert('y');
    s.insert('u');
    int i = 0;
    for (auto &c: a) {
        while (true) {
            if (b[i] == c) {
                i++;
                break;
            }
            if (i >= b.size() || !s.count(b[i])) {
                cout << "Different\n";
                return;
            }
            i++;
        }
    }
    cout << "Same\n";
}

signed main() {
    solve();
}