#include <bits/stdc++.h>

using namespace std;

bool test(int v, vector<vector<int>> g, vector<int> c) {
    int n = c.size() / 2;
    vector<int> cs(n + 1);
    for (int i = 0; i < 2 * n; i++)
        cs[c[i]] += i;

    vector<int> was(2 * n, 0), pos(2 * n, -1), ts;
    auto dfs = [&](int v, auto& req) -> void {
        was[v] = 1;
        for (int u : g[v]) {
            if (!was[u])
                req(u, req);
        }
        pos[v] = ts.size();
        ts.push_back(v);
    };
    dfs(v, dfs);

    vector<int> val(2 * n, -1);
    int cnt = 0;
    for (int i = 2 * n - 1; i > -1; i--) {
        if (val[ts[i]] == -1) {
            cnt++;
            val[ts[i]] = 1;
            queue<int> q;
            q.push(cs[c[ts[i]]] - ts[i]);
            while (q.size()) {
                int v = q.front();
                q.pop();
                if (val[v] != -1) {
                    continue;
                }
                val[v] = 0;
                for (int u : g[v]) {
                    if (pos[u] < pos[v]) {
                        q.push(u);
                    }
                }
            }
        }
    }

    if (cnt == n) {
        for (int i = 0; i < 2 * n; i++) {
            if (val[i])
                cout << i + 1 << ' ';
        }
        cout << '\n';
        return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<int>c(2 * n);
    vector<vector<int>> g(2 * n);
    for (int i = 0; i < 2 * n; i++) cin >> c[i];
    for (int i = 0; i < 2 * n - 1; i++) {
        int u, v;

        cin >> u >> v;
        u--;
        v--;

        g[v].push_back(u);
        g[u].push_back(v);
    }

    bool found = false;
    for (int i = 0; i < 2 * n; i++) {
        if (c[i] == 1 && test(i, g, c)) {
            found = true;
            break;
        }
    }
    if (!found) {
        cout << "-1\n";
    }
}


int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}