#include <bits/stdc++.h>

using namespace std;

const int N = 105;
int dp[N][N][N];

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 1; i < N; ++i) for (int j = 0; j < N; ++j) for (int k = 0; k < N; ++k) dp[i][j][k] = -1;
    for (int k = 1; k <= n; ++k) {
        for (int l = 0; l + k <= n; ++l) {
            for (int r = 0; r + k <= n; ++r) {
                if (k == 1) {
                    if (a[l] == b[r]) {
                        dp[k][l][r] = l;
                    }
                    continue;
                }
                for (int i = l; i < l + k; ++i) {
                    if (a[i] == b[r + k - 1] and ~dp[i - l][l][r] and ~dp[l + k - 1 - i][i + 1][r + i - l]) {
                        dp[k][l][r] = i;
                        break;
                    }
                }
            }
        }
    }
    if (dp[n][0][0] == -1) {
        cout << "NO";
        return 0;
    }
    cout << "YES\n";
    function<string(int, int, int)> restore = [&](int k, int l, int r) ->string {
        //cout << k << ' ' << l << ' ' << r << endl;
        if (k == 0) return "";
        assert(~dp[k][l][r]);
        if (k == 1) {
            return "SC";
        }
        int i = dp[k][l][r];
        return restore(i - l, l, r) + "S" + restore(l + k - 1 - i, i + 1, r + i - l) + "C";
    };
    cout << restore(n, 0, 0) << endl;
}
