#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

map<pair<int64_t, int64_t>, int64_t> cache;

int64_t rec(int64_t k, int64_t p, int64_t d, int64_t r, int64_t m) {
    if (cache.count({d, r}) != 0) {
        return cache[{d, r}];
    }
    int64_t b = d;
    if (k & r) b++;
    if (p & r) b--;
    if (r == 1) {
        if (b % 2 == 0) return 1;
        else return 0;
    }
    if (b < 0) return 0;
    int64_t ans = 0;
    if (d % 2 == 1) {
        cache[{d, r}] = ans;
        return ans;
    }
    for (int i = 0; i <= 2 * b; i += 2) {
        ans = (ans + rec(k, p, 2 * b - i, r / 2, m)) % m;
    }
    cache[{d, r}] = ans;
    return ans;
}

void solve() {
    int64_t n, p, m;
    cin >> n >> p >> m;
    int64_t k = n - p;
    int64_t r = 1;
    while (r <= k) {
        r *= 2;
    }
    r /= 2;
    cout << rec(k, p, 0, r, m);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
        solve();
    return 0;
}
