#include <bits/stdc++.h>

using namespace std;
#define int long long
#define x first
#define y second
#define app push_back
#define all(x) x.begin(),x.end()
struct sat {
    int m;
    vector<vector<int>> g, r;
    sat(int n) : m(n + 1), g(2 * m), r(2 * m) {}
    void add(int x, int a, int y, int b) {
        //cout << x << ' ' << a << ' ' <<y  << ' ' << b << endl;
        int u = 2 * x + a;
        int v = 2 * y + b;
        g[u].push_back(v);
        g[v ^ 1].push_back(u ^ 1);
        r[u ^ 1].push_back(v ^ 1);
        r[v].push_back(u);
    }
    vector<int> solve() {
        vector<int> used(2 * m), tout(2 * m);
        int time = 0;
        auto dfs = [&](auto dfs, int cur) {
            if (used[cur]) return;
            used[cur] = 1;
            for (int nxt : g[cur]) {
                dfs(dfs, nxt);
            }
            tout[cur] = time++;
            used[cur] = 2;
        };
        for (int i = 0; i < m; ++i) dfs(dfs, 0);
        vector<int> ind(2 * m);
        iota(all(ind), 0);
        sort(all(ind), [&](int i, int j) {return tout[i] > tout[j];});
        vector<int> scc(2 * m, -1);
        auto go = [&](auto go, int cur, int c) {
            if (scc[cur] != -1) return;
            scc[cur] = c;
            for (int nxt : r[cur]) {
                go(go, nxt, c);
            }
        };
        int c = 0;
        for (int i : ind) if (scc[i] == -1) go(go, i, c++);
        vector<int> ans(m);
        for (int i = 0; i < m; ++i) {
            if (scc[2 * i] == scc[2 * i + 1]) return {};
            ans[i] = scc[2 * i] < scc[2 * i + 1];
        }
        return ans;
    }
};
void slv() {
    int n;
    cin >> n;
    vector <int> c(2 * n + 1);
    vector <vector <int> > who(n + 1);
    for (int i = 1; i <= 2 * n; ++i) {
        cin >> c[i];
        who[c[i]].app(i);
    }
    vector <vector <int> > g(2 * n + 1);
    for (int i = 0; i < 2 * n - 1; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v); g[v].push_back(u);
    }
    auto check = [&] (int r) {
        sat t(2 * n);
        function <void(int, int)> dfs = [&] (int u, int p) {
            for (int v : g[u]) {
                if (v != p) {
                    t.add(v, 1, u, 1);
                    dfs(v,u);
                }
            }
        };
        for (int c = 1; c <= n; ++c) {
            t.add(who[c][0], 1, who[c][1], 0);
            t.add(who[c][0], 0, who[c][1], 1);
        }
        dfs(r,r);
        auto res = t.solve();
        if (res.empty()) {
            return false;
        }
        for (int i = 1; i <= 2 * n; ++i) {
            if (res[i]) {
                cout << i << ' ';
            }
        }
        cout << endl;
        return true;
    };
    for (int i = 1; i <= 2 * n; ++i) {
        if (c[i] == 1) {
            if (check(i)) {
                return;
            }
        }
    }
    cout << -1 << endl;
}
int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);

    int t;
    cin >> t;
    while(t--) slv();
    return 0;

}
