#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

#define int long long

int qp(int a, int k, int mod) {
  int res = 1;
  while (k) {
    if (k & 1) {
      res = res * a % mod;
    }
    a = a * a % mod;
    k >>= 1;
  }
  return res;
}

signed main() {
  int t;
  cin >> t;
  while (t--) {
    int x;
    cin >> x;
    int ans = 0;
    while (x) {
      int t = 1;
      while (x >= t - 1) {
        t <<= 1;
      }
      t >>= 1;
      x -= t - 1;
      ++ans;
    }
    cout << ans - 1 << '\n';
  }
  return 0;
}
/*
Shrm-el-Shikh
Sharm-el-Sheikh
*/