#include <algorithm>
#include <bitset>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <numeric>
#include <random>
#include <set>
#include <vector>

using namespace std;

#define ALL(c) c.begin(), c.end()
#define SZ(c) (int)c.size()

int main() {
  string s, t;
  cin >> s >> t;
  set<char> v = {'a', 'e', 'i', 'o', 'u', 'y'};
  for (int i = 0, j = 0; i < SZ(s); ++i) {
    while (j >= SZ(t) || s[i] != t[j]) {
      if (!v.count(t[j]) || j >= SZ(t) - 1) {
        cout << "Different\n";
        return 0;
      }
      ++j;
    }
    ++j;
  }
  cout << "Same\n";
  return 0;
}
/*
Shrm-el-Shikh
Sharm-el-Sheikh
*/