#include <bits/stdc++.h>

using namespace std;

const int inf = 2e9;

pair<int, int> get_inter(pair<int, int> f, pair<int, int> s){
    if(f.first == s.first)
        return {inf, inf};

    int x = inf, y = inf;
    int sum = inf, sub = inf;
    if (f.first == 0)
        x = f.second;
    if (s.first == 0)
        x = s.second;
    if (f.first == 1)
        y = f.second;
    if (s.first == 1)
        y = s.second;
    if (f.first == 2)
        sub = f.second;
    if (s.first == 2)
        sub = s.second;
    if (f.first == 3)
        sum = f.second;
    if (s.first == 3)
        sum = s.second;
    if (x != inf && y != inf) return {x, y};
    if (x != inf && sum != inf) return {x, sum - x};
    if (x != inf && sub != inf) return {x, x - sub};
    if(y != inf && sum != inf) return {sum - y, y};
    if (y != inf && sub != inf)  return {sub + y, y};
    if (sum != inf && sub != inf) return {(sum + sub) / 2, (sum - sub) / 2};
}

bool check(pair<int, int> point, pair<int, int> ph){
    if(point.first == ph.first)
        return 1;
    if(point.second == ph.second)
        return 1;
    if(point.first - point.second == ph.first - ph.second)
        return 1;
    if(point.first + point.second == ph.first + ph.second)
        return 1;
    return 0;
}

int main() {
    int t;
    cin >> t;

    while(t--){
        int n;
        cin >> n;
        int x[n + 1], y[n + 1];
        for(int i = 1; i <= n; i++){
            cin >> x[i] >> y[i];
        }

        pair<int, int> com_line;
        vector<pair<int, int> > com_point;
        if(x[1] == x[2])
            com_line = make_pair(0, x[1]);
        else if(y[1] == y[2])
            com_line = make_pair(1, y[1]);
        else if(x[1] - y[1] == x[2] - y[2])
            com_line = make_pair(2, x[1] - y[1]);
        else if(x[1] + y[1] == x[2] + y[2])
            com_line = make_pair(3, x[1] + y[1]);
        else
            com_line = {-1, -1};

        com_point.push_back(get_inter({0, x[1]}, {1, y[2]}));
        com_point.push_back(get_inter({0, x[1]}, {2, x[2] - y[2]}));
        com_point.push_back(get_inter({0, x[1]}, {3, x[2] + y[2]}));
        com_point.push_back(get_inter({1, y[1]}, {0, x[2]}));
        com_point.push_back(get_inter({1, y[1]}, {2, x[2] - y[2]}));
        com_point.push_back(get_inter({1, y[1]}, {3, x[2] + y[2]}));
        com_point.push_back(get_inter({2, x[1] - y[1]}, {1, y[2]}));
        com_point.push_back(get_inter({2, x[1] - y[1]}, {0, x[2]}));
        com_point.push_back(get_inter({2, x[1] - y[1]}, {3, x[2] + y[2]}));
        com_point.push_back(get_inter({3, x[1] + y[1]}, {1, y[2]}));
        com_point.push_back(get_inter({3, x[1] + y[1]}, {0, x[2]}));
        com_point.push_back(get_inter({3, x[1] + y[1]}, {2, x[2] - y[2]}));

        for(int i = 3; i <= n; i++){
            pair<int, int> ret;
            if(com_line.first != -1){
                int type = com_line.first;
                int coor = com_line.second;
                if(type == 0 && x[i] != coor)
                    type = -1;
                else if(type == 1 && y[i] != coor)
                    type = -1;
                else if(type == 2 && x[i] - y[i] != coor)
                    type = -1;
                else if(type ==3 && x[i] + y[i] != coor)
                    type = -1;
                com_line.first = type;
            }
            vector<pair<int, int> > renew;
            for(auto [a, b] : com_point){
                if(check({a, b}, {x[i], y[i]}))
                    renew.push_back({a, b});
            }
            com_point = renew;
        }

        if(com_line.first != -1){
            cout << "YES\n";
            int type = com_line.first;
            int sv = com_line.second;
            if(type == 0)
                cout << sv << " " <<"1\n";
            else if (type == 1)
                cout << "1 " << sv << "\n";
            else if(type == 2)
                cout << sv - 1 << " -1\n";
            else
                cout << sv - 1 << "1\n";
        }
        else if(!com_point.empty()){
            cout << "YES\n";
            cout << com_point[0].first << " " << com_point[0].second << "\n";
        }
        else
            cout << "NO\n";
    }
}
