#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> a(n);
    vector<int> b(n);

    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];

    set<tuple<stack<int>, string, int>> cur;

    cur.insert({{}, "", -1});
    for (int i = 0; i < n; i++) {
        set<tuple<stack<int>, string, int>> now;
        for (const auto& [st, cur_ans, lst] : cur) {
            stack<int> st2 = st;
            string now_ans = cur_ans;

            if (!st2.empty() && st2.top() == b[i]) {
                int x = st2.top();
                now_ans += 'C';
                st2.pop();

                now.insert({st2, now_ans, lst});

                now_ans.pop_back();
                st2.push(x);
            }

            for (int j = lst + 1; j < n; j++) {
                st2.push(a[j]);
                now_ans += 'S';

                if (a[j] == b[i]) {
                    now_ans += 'C';
                    int x = st2.top();
                    st2.pop();
                    now.insert({st2, now_ans, j});

                    now_ans.pop_back();
                    st2.push(x);
                }
            }
        }

        swap(cur, now);
    }


    if (cur.empty()) cout << "NO";
    else {
        auto ans = *cur.begin();

        cout << "YES\n";
        cout <<get<1>(ans);
    }
}
