#include <bits/stdc++.h>

#define endl "\n"

#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

void solve() {
    vector<int> a(4);
    cin >> a;

    vector<int> perm(4);
    iota(all(perm), 0);


    int mx = 0;

    do {
        int mn = min(a[perm[0]], a[perm[1]]);
        int mn2 = min(a[perm[2]], a[perm[3]]);

        rmax(mx, mn * mn2);
    } while (next_permutation(all(perm)));

    cout << mx << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}