#pragma GCC optimize("Ofast", "inine", "no-stack-protector")

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

#define endl "\n"

#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

void solve() {
    int n;
    std::cin >> n;
    int best = 0;
    std::vector <int> ans;
    for (int i = 2; i <= 4e4 && i <= n; ++i) {
        int p = n;
        int x = 0;
        while (p != 0) {
            int t = p % i;
            p /= i;
            if (t == 0) {
                x += 1;
            }
        }
        if (x == best) {
            ans.push_back(i);
        }
        else if (x > best) {
            ans.clear();
            ans.push_back(i);
            best = x;
        }
    }
    std::cout << best << ' ' << ans.size() << '\n';
    for (int i = 0; i < ans.size(); ++i) {
        std::cout << ans[i] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}