#pragma GCC optimize("Ofast", "inine", "no-stack-protector")

#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define endl "\n"

// #define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

int is_good(pii point, pii check) {
    if (point.X == check.X) {
        return 1;
    } else if (point.Y == check.Y) {
        return 2;
    } else if (abs(point.X - check.X) == abs(point.X - check.X)) {
        if (point.X - check.X > 0) {
            return 3;
        }

        return 4;
    }

    return 0;
}

vector<pii> coordinates;

pii calc_for_horizontal() {
    int n = coordinates.size();
    map<pii, int> cnt_of_numbers;
    int cnt_on_horizontal = 1;

    pii pt = coordinates[0];

    for (int i = 1; i < n; i++) {
        pii it = coordinates[i];

        if (it.Y == pt.Y) {
            cnt_on_horizontal++;
            continue;
        }

        cnt_of_numbers[{it.X, pt.Y}]++;
        int b = abs(pt.Y - it.Y);
        cnt_of_numbers[{it.X + b, pt.Y}]++;
        cnt_of_numbers[{it.X - b, pt.Y}]++;
    }

    if (cnt_on_horizontal == n) {
        return pt;
    }

    for (auto &it : cnt_of_numbers) {
        if (it.Y + cnt_on_horizontal == n) {
            return it.X;
        }
    }

    return {1e9, 1e9};
}

void solve() {
    int n;
    cin >> n;

    coordinates.clear();
    coordinates.resize(n);

    for (auto &it : coordinates) {
        cin >> it.X >> it.Y;
    }

    auto ans = calc_for_horizontal();

    if (ans.X != 1e9) {
        cout << "YES\n";
        cout << ans.X  << ' ' << ans.Y  << endl;
        return;
    }

    for (auto &it : coordinates) {
        swap(it.X, it.Y);
    }

    ans = calc_for_horizontal();

    if (ans.X != 1e9) {
        cout << "YES\n";
        cout << ans.Y  << ' ' << ans.X  << endl;
        return;
    }

    for (auto &it : coordinates) {
        swap(it.X, it.Y);
    }

    {
    
        auto pt = coordinates[0];
        int cnt_on_line = 1;
        map<pii, int> cnt_of_number;

        int value = pt.X - pt.Y;

        for (int i = 1; i < n; i++) {
            auto it = coordinates[i];

            if (it.X - it.Y == value) {
                cnt_on_line++;
                continue;
            }

            int value2 = it.X + it.Y;
            cnt_of_number[{it.Y + value, it.Y}]++;
            cnt_of_number[{it.X, it.X - value}]++;

            if (abs(value) % 2 != abs(value2) % 2) {
                continue;
            }

            cnt_of_number[{(value + value2) / 2, (value2 - value) / 2}];
        }

        if (cnt_on_line == n) {
            cout << "YES\n";
            cout << pt.X  << ' ' << pt.Y << endl;
            return;
        }

        for (auto &it : cnt_of_number) {
            if (it.Y + cnt_on_line == n) {
                cout << "YES\n";
                cout << it.X.X  << ' ' << it.X.Y << endl;
                return;
            }
        }
    }

    {
        auto pt = coordinates[0];
        int cnt_on_line = 1;
        map<pii, int> cnt_of_number;

        int value = pt.X + pt.Y;

        for (int i = 1; i < n; i++) {
            auto it = coordinates[i];

            if (it.X + it.Y == value) {
                cnt_on_line++;
                continue;
            }

            int value2 = it.X - it.Y;
            cnt_of_number[{value - it.Y, it.Y}]++;
            cnt_of_number[{it.X, value - it.X}]++;

            if (abs(value) % 2 != abs(value2) % 2) {
                continue;
            }

            cnt_of_number[{(value + value2) / 2, (value - value2) / 2}];
        }

        if (cnt_on_line == n) {
            cout << "YES\n";
            cout << pt.X  << ' ' << pt.Y << endl;
            return;
        }

        for (auto &it : cnt_of_number) {
            if (it.Y + cnt_on_line == n) {
                cout << "YES\n";
                cout << it.X.X  << ' ' << it.X.Y << endl;
                return;
            }
        }
    }

    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}