#pragma GCC optimize("Ofast", "inine", "no-stack-protector")

#include <bits/stdc++.h>

#define endl "\n"

// #define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define X first
#define Y second
#define ll long long
#define ull unsigned ll
#define double long double
using namespace std;

template<typename T, typename G>
bool rmax(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (a < b1) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T, typename G>
bool rmin(T &a, const G& b) {
    T b1 = static_cast<T>(b);
    if (b1 < a) {
        a = b1;
        return true;
    }

    return false;
}

template<typename T>
istream& operator>>(istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }

    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }

    return out;
}

void solve() {
    int p, n, m;
    cin >> n >> p >> m;

    int max_ost = n - p;
    vector<vector<int>> pref(max_ost + 1, vector<int> (512, 0));
    vector<vector<int>> dp(max_ost + 1, vector<int> (512, 0));

    pref[max_ost][p] = 1;

    for (int mx = 1; mx <= max_ost; ++mx) {
        for (int ost = 0; ost <= max_ost - mx; ++ost) {
            for (int xr = 0; xr < 512; ++xr) {
                int my_xr = xr;
                for (int k = 1; k * mx + ost <= max_ost; ++k) {
                    my_xr ^= mx;
                    dp[ost][xr] += pref[k * mx + ost][my_xr];
                    if (dp[ost][xr] >= m) {
                        dp[ost][xr] -= m;
                    }
                }
            }
        }

        for (int ost = 0; ost <= max_ost - mx; ++ost) {
            for (int xr = 0; xr < 512; ++xr) {
                pref[ost][xr] += dp[ost][xr];
                dp[ost][xr] = 0;

                if (pref[ost][xr] >= m) {
                    pref[ost][xr] -= m;
                }
            }
        }
    }
    cout << pref[0][0] << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}