#include <bits/stdc++.h>
#include <ext/pb_ds/detail/standard_policies.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

#pragma GCC optimize("Ofast")

#define ll long long
#define ld long double
#define F first
#define S second
#define endl '\n'
#define pb push_back

template <typename T> using ordered_set = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 1e5+7;

int n;
int target;
int cols[N];
vector<int> g[N];
set<int> ans;
set<int> path;
set<int> cur;
set<int> candidates;
set<int> used;

void dfs(int v, int p = -1) {
    cur.insert(cols[v]);
    path.insert(v);
    if (cur.size() == target) {
        ans = path;
        path.erase(v);
        cur.erase(cols[v]);
        return;
    }
    for (auto to : g[v]) {
        if (to == p) {
            continue;
        }
        if (cur.count(cols[to])) {
            candidates.insert(to);
            continue;
        }
        dfs(to, v);
        if (!ans.empty()) {
            path.erase(v);
            cur.erase(cols[v]);
            return;
        }
    }
    path.erase(v);
    cur.erase(cols[v]);
}

void solve() {
    ans.clear();
    int u, v;
    cin >> target;
    n = target*2;
    for (int i = 0; i < n; ++i)
        g[i].clear();
    for (int i = 0; i < n; ++i)
        cin >> cols[i];
    for (int i = 0; i+1 < n; ++i) {
        cin >> u >> v;
        --u, --v;
        g[u].pb(v);
        g[v].pb(u);
    }
    used.insert(0);
    dfs(0);
    while (ans.empty() && !candidates.empty()) {
        int nxt = *candidates.begin();
        candidates.erase(nxt);
        while (used.count(nxt) && !candidates.empty()) {
            nxt = *candidates.begin();
            candidates.erase(nxt);
        }
        if (used.count(nxt)) {
            break;
        }
        dfs(nxt);
        used.insert(nxt);
    }
    used.clear();
    candidates.clear();
    if (ans.size() > 0) {
        for (auto to : ans)
            cout << to+1 << ' ';
        cout << endl;
    } else {
        cout << -1 << endl;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output1.txt", "w", stdout);
#endif // LOCAL
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
