#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma target("avx,avx2,bmi2,sse4")

#define all(x) begin(x), end(x)
#define frl(i, x) for(auto& i : x)
#define rep(i, k, n) for(int i = k; i < n; i++)
#define F first
#define S second
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

bool check(int m, vector<int> &a, vector<int> &b) {
    for(int i=0; i < m; i++) {
        if(a[a.size() - m + i] <= b[i]) {
            return false;
        }
    }

    return true;
}

vector<int> ans(vector<int> a, vector<int> b) {
     int l = -1;
     int r = a.size() + 1;

     while(r-l > 1){
         int m = (r + l) / 2;

         if(check(m, a, b)) {
             l = m;
         } else {
             r = m;
         }
     }

     vector<int> ans1(a.size() + 1 , 0);
     for(int i=0; i <= l; i ++) {
         ans1[i] = 1;
     }

     return ans1;
}

bool check12(int m, vector<int> &a, vector<int> &b) {
    for(int i=0; i < a.size() - m; i++) {
        if(a[i] >= b[i + m]) {
            return false;
        }
    }

    return true;
}

vector<int> ans12(vector<int> a, vector<int> b) {
    int l = -1;
    int r = a.size() + 1;

    while(r-l > 1){
        int m = (r + l) / 2;

        if(!check12(m, a, b)) {
            l = m;
        } else {
            r = m;
        }
    }

    vector<int> ans1(a.size() + 1 , 1);
    for(int i=0; i <= l; i ++) {
        ans1[i] = 0;
    }

    return ans1;
}

void solve() {
    int n; cin >> n;
    vector<int>a(n);
    vector<int> b(n);
    for(int i=0; i < n; i++) {
        cin >> a[i];
    }

    for(int i=0; i < n; i++) {
        cin >> b[i];
    }

    vector<int> ans1 =  ans(a, b);
    vector<int> ans2 = ans12(a, b);

    // no erros
    vector<int> ans3;
    for(int i=0; i < n + 1; i++) {
        if(ans1[i] && ans2[i]) {
            ans3.push_back(i);
        }
    }

    cout << ans3.size() << "\n";
    for(auto el: ans3) {
        cout << el << " ";
    }
}

int32_t main() {
    cin.tie(0)->ios_base::sync_with_stdio(0);
    int tt = 1;
   // cin >> tt;
    while (tt--) solve();
    return 0;
}