#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<int> xs(4), ys(4);

vector<pair<int, int>> calc_inters(int inters_type, int x, int y, int new_x, int new_y) {
    switch (inters_type) {
        case 1:
            return vector{pair{x, new_y}, pair{x, new_x + new_y - x}, pair{x, x - new_x + new_y}};
        case 2:
            return vector{pair{new_x, y}, pair{new_x + new_y - y, y}, pair{new_x - new_y + y, y}};
        case 3: {
            auto bebra_x = x + y + new_x - new_y;
            auto bebra_y = x + y - new_x + new_y;
            if (bebra_x % 2 == 0 and bebra_y % 2 == 0) {
                return vector{pair{new_x, x + y - new_x}, pair{x + y - new_y, new_y}, pair{bebra_x / 2, bebra_y / 2}};
            } else {
                return vector{pair{new_x, x + y - new_x}, pair{x + y - new_y, new_y}};
            }
        }
        case 4: {
            auto bebra_x = new_x + new_y + x - y;
            auto bebra_y = new_x + new_y - x + y;
            if (bebra_x % 2 == 0 and bebra_y % 2 == 0) {
                return vector{pair{new_x, new_x + y - x}, pair{x - y + new_y, new_y}, pair{bebra_x / 2, bebra_y / 2}};
            } else {
                return vector{pair{new_x, new_x + y - x}, pair{x - y + new_y, new_y}};
            }
        }
        case 5: {
            auto bebra_x_3 = x + y + new_x - new_y;
            auto bebra_y_3 = x + y - new_x + new_y;
            auto bebra_x_4 = new_x + new_y + x - y;
            auto bebra_y_4 = new_x + new_y - x + y;
            if (bebra_x_3 % 2 == 0 and bebra_y_3 % 2 == 0 and bebra_x_4 % 2 == 0 and bebra_y_4 % 2 == 0) {
                return vector{pair{x, new_y}, pair{x, new_x + new_y - x}, pair{x, x - new_x + new_y},
                              pair{new_x, y}, pair{new_x + new_y - y, y}, pair{new_x - new_y + y, y},
                              pair{new_x, x + y - new_x}, pair{x + y - new_y, new_y},
                              pair{new_x, new_x + y - x}, pair{x - y + new_y, new_y},
                              pair{bebra_x_3 / 2, bebra_y_3 / 2}, pair{bebra_x_4 / 2, bebra_y_4 / 2}};
            } else {
                return vector{pair{x, new_y}, pair{x, new_x + new_y - x}, pair{x, x - new_x + new_y},
                              pair{new_x, y}, pair{new_x + new_y - y, y}, pair{new_x - new_y + y, y},
                              pair{new_x, x + y - new_x}, pair{x + y - new_y, new_y},
                              pair{new_x, new_x + y - x}, pair{x - y + new_y, new_y}};
            }
        }
        default:
            assert(false);
    }
}

void solve() {
    int n;
    cin >> n;

    int x, y;
    cin >> x >> y;
    xs[0] = x;
    ys[0] = y;

    int cnt = 1;
    int inters_type = 5;
    vector<pair<int, int>> inters;
    for (int i = 1; i < n; ++i) {
        int new_x, new_y;
        cin >> new_x >> new_y;
        if (cnt < 4) {
            xs[cnt] = new_x;
            ys[cnt] = new_y;
            ++cnt;
        }
        if (inters_type == 0) {
            vector<pair<int, int>> new_inters;
            new_inters.reserve(inters.size());
            for (auto &[inter_x, inter_y]: inters) {
                if (new_x == inter_x or new_y == inter_y or new_x + new_y == inter_x + inter_y or
                    new_x - new_y == inter_x - inter_y) {
                    new_inters.emplace_back(inter_x, inter_y);
                }
            }
            inters = std::move(new_inters);
        } else if (inters_type == 1) {
            if (x != new_x) {
                if (cnt <= 4) {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    for (int k = 0; k < cnt; ++k) {
                        for (int l = 0; l < cnt; ++l) {
                            bool is_ok = true;
                            for (int m = 0; m < cnt; ++m) {
                                is_ok &= (xs[k] == xs[m] or ys[l] == ys[m] or
                                    xs[k] + ys[l] == xs[m] + ys[m] or
                                    xs[k] - ys[l] == xs[m] - ys[m]);
                            }
                            if (is_ok) {
                                inters.emplace_back(xs[k], ys[l]);
                            }
                        }
                    }
                    inters_type = 0;
                } else {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    inters_type = 0;
                }
            }
        } else if (inters_type == 2) {
            if (y != new_y) {
                if (cnt <= 4) {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    for (int k = 0; k < cnt; ++k) {
                        for (int l = 0; l < cnt; ++l) {
                            bool is_ok = true;
                            for (int m = 0; m < cnt; ++m) {
                                is_ok &= (xs[k] == xs[m] or ys[l] == ys[m] or
                                          xs[k] + ys[l] == xs[m] + ys[m] or
                                          xs[k] - ys[l] == xs[m] - ys[m]);
                            }
                            if (is_ok) {
                                inters.emplace_back(xs[k], ys[l]);
                            }
                        }
                    }
                    inters_type = 0;
                } else {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    inters_type = 0;
                }
            }
        } else if (inters_type == 3) {
            if (x + y != new_x + new_y) {
                if (cnt <= 4) {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    for (int k = 0; k < cnt; ++k) {
                        for (int l = 0; l < cnt; ++l) {
                            bool is_ok = true;
                            for (int m = 0; m < cnt; ++m) {
                                is_ok &= (xs[k] == xs[m] or ys[l] == ys[m] or
                                          xs[k] + ys[l] == xs[m] + ys[m] or
                                          xs[k] - ys[l] == xs[m] - ys[m]);
                            }
                            if (is_ok) {
                                inters.emplace_back(xs[k], ys[l]);
                            }
                        }
                    }
                    inters_type = 0;
                } else {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    inters_type = 0;
                }
            }
        } else if (inters_type == 4) {
            if (x - y != new_x - new_y) {
                if (cnt <= 4) {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    for (int k = 0; k < cnt; ++k) {
                        for (int l = 0; l < cnt; ++l) {
                            bool is_ok = true;
                            for (int m = 0; m < cnt; ++m) {
                                is_ok &= (xs[k] == xs[m] or ys[l] == ys[m] or
                                          xs[k] + ys[l] == xs[m] + ys[m] or
                                          xs[k] - ys[l] == xs[m] - ys[m]);
                            }
                            if (is_ok) {
                                inters.emplace_back(xs[k], ys[l]);
                            }
                        }
                    }
                    inters_type = 0;
                } else {
                    inters = calc_inters(inters_type, x, y, new_x, new_y);
                    inters_type = 0;
                }
            }
        } else if (inters_type == 5) {
            if (x == new_x) {
                inters_type = 1;
            } else if (y == new_y) {
                inters_type = 2;
            } else if (x + y == new_x + new_y) {
                inters_type = 3;
            } else if (x - y == new_x - new_y) {
                inters_type = 4;
            } else {
                inters = calc_inters(inters_type, x, y, new_x, new_y);
                inters_type = 0;
            }
        } else {
            assert(false);
        }
//        cout << inters_type << endl;
//        for (auto &[x_, y_]: inters) {
//            cout << x_ << ' ' << y_ << endl;
//        }
//        cout << endl;
    }

//    cout << inters_type << endl;
//    for (auto &[x_, y_]: inters) {
//        cout << x_ << ' ' << y_ << endl;
//    }
//    cout << endl;

    if (inters_type == 0 and not inters.empty()) {
        cout << "YES\n";
        cout << inters[0].first << ' ' << inters[0].second << endl;
    } else if (inters_type == 0 and inters.empty()) {
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << x << ' ' << y << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    cin >> t;
    while (t-- > 0) {
        solve();
    }
}
