#include <bits/stdc++.h>
using namespace std;
#define int long long

enum State {UNKNOWN, ACTIVE, INACTIVE};

void solve() {
    int n;
    cin >> n;

    int k;
    cin >> k;
    if (k == n) {
        return;
    }

    vector<vector<State>> states(n, vector<State>(n, UNKNOWN));
    vector<vector<int>> swapped(n, vector<int>(n, false));
    for (int i = n - 1; i >= 0; --i) {
        for (int mask = 0; mask < (1 << (i + 1)); ++mask) {
            if (((mask >> i) & 1) == 0) {
                continue;
            }
            cout << "mask: " << mask << endl;
            for (int mask_i = 0; mask_i <= i; ++mask_i) {
                if (((mask >> mask_i) & 1) == 0) {
                    continue;
                }
                cout << mask_i << " " << i << endl;
                swapped[mask_i][i] ^= true;
                int new_k;
                cin >> new_k;
                if (new_k == n) {
                    return;
                }
                if (k < new_k) {
                    assert(states[mask_i][i] == UNKNOWN or states[mask_i][i] == ACTIVE);
                    states[mask_i][i] = ACTIVE; // TODO
                }
                if (k > new_k) {
                    assert(states[mask_i][i] == UNKNOWN or states[mask_i][i] == ACTIVE);
                    states[mask_i][i] = ACTIVE;
                }
                k = new_k;
            }
        }
        for (int l = 0; l < i; ++l) {
            if (states[l][i] == UNKNOWN) {
                cout << "states[" + to_string(l) + "][" + to_string(i) + "] == UNKNOWN" << endl;
                assert(false);
            }
            if (states[l][i] == INACTIVE) {
                assert(k < n);
                cout << l << " " << i << endl;
                int new_k;
                cin >> new_k;
                assert(k < new_k);
                k = new_k;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
    solve();
}
