#include <bits/stdc++.h>
using namespace std;
#define int long long

array<uint64_t, 64> precount {};

void calc_precount() {
    precount[0] = 1;
    for (int i = 1; i < precount.size(); ++i) {
        precount[i] = precount[i - 1] * 2 + 1;
    }
}

void solve() {
    uint64_t n;
    cin >> n;

    int counter = 0;
    for (int i = 63; i >= 0; --i) {
        while (n >= precount[i]) {
            n -= precount[i];
            ++counter;
        }
    }
    cout << counter - 1 << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    calc_precount();
    int t = 1;
    cin >> t;
    while (t --> 0) {
        solve();
    }
}
