#include <bits/stdc++.h>
using namespace std;
#define int long long

void solve() {
    static constexpr string_view vowels = "aeiouy";
    string s, f;
    cin >> s >> f;

    auto to_lower = [](char c) -> char {
        return 'A' <= c and c <= 'Z' ? c - 'A' + 'a' : c;
    };

    int j = 0;
    for (int i = 0; i < s.size(); ++i) {
        while (j < f.size() and to_lower(s[i]) != to_lower(f[j]) and vowels.find(to_lower(f[j])) != string_view::npos) {
            ++j;
        }
        if (j == f.size() or to_lower(s[i]) != to_lower(f[j])) {
            cout << "Different\n";
            return;
        }
        ++j;
    }
    cout << "Same\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 0;
#ifdef LOCAL
    cin >> t;
#endif
    while (t --> 0) {
        solve();
    }
}
