#include <iostream>
#include <bits/stdc++.h>
#include "stack"
using namespace std;
typedef long long ll;

void config_io(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _deb
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}



vector<ll> s, c;
vector<vector<pair<ll, char>>> g;
vector<ll> parent;
ll index = 0;

void tree(ll cp, ll sp, stack<ll> table, ll n){
    int i = index;
    g.push_back({});
    if(sp < n) {
        index++;
        table.push(s[sp]);
        g[i].push_back({index, 'S'});
        tree(cp, sp+1, table, n);
        table.pop();
    }
    if(cp < n && !table.empty()){
        if(table.top() == c[cp]){
            table.pop();
            index++;
            g[i].push_back({index, 'C'});
            tree(cp+1, sp, table, n);
        }
    }
}


int main() {
    config_io();

    ll n;
    std::cin >> n;
    s.resize(n);
    c.resize(n);


    ll tmp;

    for (ll i = 0; i < n; ++i){
        cin >> tmp;
        s[i] = tmp;
    }

    for (ll i = 0; i < n; ++i){
        cin >> tmp;
        c[i] = tmp;
    }

    vector<pair<ll, char>> graph;
    tree(0, 0, {}, n);
    list<pair<ll, string>> q, new_v;
    q = {{0, ""}};
    ll depth = 0;
    pair<ll, string> last;

    while (!q.empty()){
        new_v.clear();
        for(auto x: q){
            last = x;
            for(auto v: g[x.first]){
                new_v.push_back({v.first, x.second + v.second});
            }
        }
        swap(q, new_v);
        depth++;
    }

    if(depth != 2*n+1){
        cout << "NO";
    }
    else{
        cout << "YES\n";
        cout << last.second;
    }
}