#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
#include<stack>
#include<set>
using namespace std;
//#define int long long

void solve() {
	int n;
	cin >> n;
	vector<int> a(2 * n);
	vector<vector<int>> pos(n);
	for (int i = 0; i < 2 * n; ++i) {
		cin >> a[i];
		a[i]--;
		pos[a[i]].push_back(i);
	}
	vector<vector<int>> g(2 * n);
	vector<int> d(2 * n);
	for (int i = 1; i < 2 * n; ++i) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		d[u]++, d[v]++;
		g[u].push_back(v), g[v].push_back(u);
	}
	set<int> q;
	for (int i = 0; i < 2 * n; ++i) {
		if (d[i] == 1) {
			q.insert(i);
		}
	}
	vector<bool> used(n);
	set<int> res;
	for (int i = 0; i < 2 * n; ++i) {
		res.insert(i);
	}
	for (int i = 0; i < n; ++i) {
		if (q.empty()) {
			cout << "-1\n";
			return;
		}
		int x = *q.begin();
		q.erase(x);
		used[a[x]] = true;
		res.erase(x);
		for (int y : g[x]) {
			d[y]--;
			if (d[y] == 1) {
				int c = a[y];
				if (!used[c]) {
					q.insert(y);
				}
			}
		}
	}
	for (int x : res) {
		cout << x + 1 << ' ';
	}
	cout << '\n';
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		solve();
	}
	return 0;
}