#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
#include <set>
using namespace std;
#define int long long

const int N = 120;

//1 y - horizontal
//2 x - vertical
//3 x-y - diag right up
//4 x+y - diag right down
//5 x y - point

set<vector<int>> intersect(vector<int> a, vector<int> b) {
	if (a[0] > b[0]) {
		return intersect(b, a);
	}
	set<vector<int>> res;
	if (a[0] == b[0]) {
		if (a[1] == b[1] && a[2] == b[2]) {
			res.insert(a);
		}
		return res;
	}
	if (b[0] == 5) {
		if (a[0] == 1) {
			if (b[2] == a[1]) {
				res.insert(b);
			}
		}
		if (a[0] == 2) {
			if (b[1] == a[1]) {
				res.insert(b);
			}
		}
		if (a[0] == 3) {
			if (b[1] - b[2] == a[1]) {
				res.insert(b);
			}
		}
		if (a[0] == 4) {
			if (b[1] + b[2] == a[1]) {
				res.insert(b);
			}
		}
		return res;
	}
	if (a[0] == 1) {
		if (b[0] == 2) {
			res.insert({ 5, b[1], a[1] });
		}
		if (b[0] == 3) {
			res.insert({ 5, a[1] + b[1], a[1] });
		}
		if (b[0] == 4) {
			res.insert({ 5, b[1] - a[1], a[1] });
		}
		return res;
	}
	if (a[0] == 2 && b[0] == 3) {
		res.insert({ 5, a[1], a[1] - b[1] });
	}
	if (a[0] == 2 && b[0] == 4) {
		res.insert({ 5, a[1], b[1] - a[1] });
	}
	if (a[0] == 3 && b[0] == 4) {
		if ((a[1] + b[1]) % 2 == 0) {
			int x = (a[1] + b[1]) / 2;
			int y = b[1] - x;
			res.insert({ 5, x, y });
		}
	}
	return res;
}

set<vector<int>> lines(int x, int y) {
	set<vector<int>> res;
	res.insert({ 1, y, 0 });
	res.insert({ 2, x, 0 });
	res.insert({ 3, x - y, 0 });
	res.insert({ 4, x + y, 0 });
	return res;
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n;
		cin >> n;
		int x, y;
		cin >> x >> y;
		set<vector<int>> objects = lines(x, y);
		for (int i = 1; i < n; ++i) {
			cin >> x >> y;
			auto lines1 = lines(x, y);
			set<vector<int>> objects1;
			for (auto line : lines1) {
				for (auto obj : objects) {
					for (auto new_obj : intersect(obj, line)) {
						objects1.insert(new_obj);
					}
				}
			}
			objects = objects1;
		}
		if (objects.empty()) {
			cout << "NO\n";
		}
		else {
			cout << "YES\n";
			auto res = *objects.begin();
			if (res[0] == 5) {
				cout << res[1] << ' ' << res[2] << '\n';
			}
			if (res[0] == 1) {
				cout << 0 << ' ' << res[1] << '\n';
			}
			if (res[0] >= 2 && res[0] <= 4) {
				cout << res[1] << ' ' << 0 << '\n';
			}
		}
	}
	return 0;
}