#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
#include<stack>
using namespace std;
#define int long long

int curr_r = 0;

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	vector<vector<int>> dp(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		if (a[i] == b[0]) {
			dp[i][i] = 1;
		}
	}
	for (int l = 2; l <= n; ++l) {
		for (int i = 0, j = l - 1; j < n; ++i, ++j) {
			if (dp[i][j - 1] > 0 && a[j] == b[l - 1]) {
				dp[i][j] = 1;
			}
			if (dp[i + 1][j] > 0 && a[i] == b[l - 1]) {
				dp[i][j] = 2;
			}
		}
	}
	if (dp[0][n - 1] == 0) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		int l = 0, r = n - 1;
		vector<int> res;
		for (int i = 0; i < n; ++i) {
			if (dp[l][r] == 1) {
				res.push_back(r);
				r--;
			}
			else {
				res.push_back(l);
				l++;
			}
		}
		int mx = 0;
		reverse(res.begin(), res.end());
		for (int x : res) {
			while (mx <= x) {
				cout << 'S';
				mx++;
			}
			cout << 'C';
		}
		cout << '\n';
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	int t = 1;
	for (int _ = 0; _ < t; ++_) {
		solve();
	}
	return 0;
}