#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include <cstdint>
#include<cmath>
#include<set>
using namespace std;
#define int long long

vector<vector<int>> gray(int n) {
	if (n == 1) {
		return { {0}, {1} };
	}
	vector<vector<int>> g1 = gray(n - 1), g2 = gray(n - 1);
	reverse(g2.begin(), g2.end());
	for (int i = 0; i < g1.size(); ++i) {
		g1[i].push_back(0);
		g2[i].push_back(1);
	}
	for (auto v : g2) {
		g1.push_back(v);
	}
	return g1;
}

int N;
int last_value;
int get() {
	int x;
	cin >> x;
	last_value = x;
	if (x == N) {
		exit(0);
	}
	return x;
}
int ask(int l, int r) {
	cout << l << ' ' << r << endl;
	return get();
}

int32_t main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n;
	cin >> n;
	N = n;
	get();
	while (n) {
		vector<vector<int>> t = gray(n);
		vector<pair<int, int>>asks(0);
		for (int i = 1; i < t.size(); ++i) {
			for (int q = 0; q < t[i].size(); ++q) {
				if (t[i][q] != t[i - 1][q]) {
					asks.push_back({ q + 1, n });
				}
			}
		}
		int best_val = last_value;
		int cnt = 0;//how many asks were made
		for (int i = 0; i < asks.size(); ++i) {
			int v = ask(asks[i].first, asks[i].second);
			if (v > best_val) {
				best_val = v;
				cnt = i + 1;
			}
		}
		vector<int>total(n);
		for (int i = cnt; i < asks.size(); ++i) {
			total[asks[i].first - 1] ^= 1;
		}
		for (int i = 0; i < total.size(); ++i) {
			if (total[i]) {
				ask(i + 1, n);
			}
		}
		--n;
	}
	return 0;
}