#include <bits/stdc++.h>
#define int long long

using namespace std;

int n_from_input;
vector<vector<int>> paths;

void precalc(int n) {
    paths = vector<vector<int>>(n + 1);
    paths[1] = {0, 1};
    for (int i = 2; i <= n; ++i) {
        paths[i].push_back(paths[i - 1][0]);
        int bit = (1 << (i - 1));
//        cout << "bit = " << bit << endl;
        for (int j = 1; j < (1 << (i - 1)); ++j) {
            if (j % 2 == 1) {
//                cout << "prev = " << paths[i - 1][j - 1] << endl;
                paths[i].push_back(bit + paths[i - 1][j - 1]);
                paths[i].push_back(bit + paths[i - 1][j]);
                paths[i].push_back(paths[i - 1][j]);
            } else {
                paths[i].push_back(paths[i - 1][j]);
            }
        }
    }
}

int bit(int mask, int i) {
    return ((mask >> i) & 1);
}

int find_where_diff(int mask1, int mask2, int n) {
    for (int i = 0; i < n; ++i) {
        if (bit(mask1, i) ^ bit(mask2, i)) {
            return i;
        }
    }
}

int ask(int l, int r) {
    cout << l << " " << r << endl;
    int k;
    cin >> k;
    if (k == n_from_input) {
        exit(0);
    }
    return k;
}

void rec(int l, int r, int k) {  // [l, r], k is amount outside of rec bounds
    vector<pair<int, int>> segs;
    for (int i = l; i <= r; ++i) {
        segs.push_back({l, i});
    }
    int n = segs.size();
    vector<pair<int, int>> next_segs;
    int prev_mask = 0;
    int our_k = -1;
    vector<int> bits;
//    int prev_mask == 0;
    for (const auto& mask: paths[n]) {
        if (mask == 0) {
            continue;
        }
        bits.push_back(find_where_diff(mask, prev_mask, n));
        prev_mask = mask;
    }
    bits.push_back(find_where_diff(paths[n].back(), paths[n].front(), n));
    for (const auto& bit : bits) {
        int new_k = ask(segs[bit].first, segs[bit].second);
        assert(new_k >= k);
        if (new_k - k > 0) {
            int last_l = l;
            for (int t = l; t <= r; ++t) {
                int check_k = ask(t, t);
                assert(new_k >= check_k);
                int revert_k = ask(t, t);
                assert(new_k == revert_k);
                if (new_k - check_k == 1) {
                    if (last_l <= t - 1) {
                        next_segs.push_back({last_l, t - 1});
                    }
                    last_l = t + 1;
                }
            }
            if (last_l <= r) {
                next_segs.push_back({last_l, r});
            }
            our_k = new_k;
            break;
        }
    }
    for (const auto& seg : next_segs) {
        rec(seg.first, seg.second, our_k);  // TODO: find out which k
    }
}

void solve() {
    int n;
    cin >> n;
    n_from_input = n;
    precalc(n);
//    for (int x = 0; x < paths[n].size(); ++x) {
////        cout << paths[n][x];
//        int y = paths[n][x];
//        for (int bit = 0; bit < n; ++bit) {
//            cout << (((1 << bit) & y) >> bit);
//        }
//        cout << "\n";
//    }
//    cout.flush();
    int k;
    cin >> k;
    if (k > 0) {
        int new_k = ask(1, n);
        assert(new_k == 0);
    }
    rec(1, n, 0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
