#include <bits/stdc++.h>
#define int long long

using namespace std;

struct Event {
    int x;
    int type;

    bool operator<(const Event& other) const {
        return x < other.x;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (auto& x : a) {
        cin >> x;
    }
    for (auto& x : b) {
        cin >> x;
    }
    vector<Event> events;
    for (const auto& x : a) {
        events.push_back({x, -1});
    }
    for (const auto& x : b) {
        events.push_back({x, 1});
    }
    sort(events.begin(), events.end());
    int max_pref = 0;
    int current_sum = 0;
    for (const auto& [x, type] : events) {
        current_sum += type;
        max_pref = max(max_pref, current_sum);
    }
    reverse(events.begin(), events.end());
    current_sum = 0;
    int max_suff = 0;
    for (const auto& [x, type] : events) {
        current_sum += type;
        max_suff = max(max_suff, current_sum);
    }
    cout << (n - max_suff) - (max_pref - 1) << "\n";
    for (int i = max_pref; i <= n - max_suff; ++i) {
        cout << i << " ";
    }
    cout << "\n";
    return 0;
}
