#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; ++i)
#define forj(n) for(ll j = 0; j < n; ++j)
#define rep(i, n) for(ll i = 0; i < n; ++i)
#define vec vector
#define pii pair<int, int>
#define ld long double

bool check(int x, int y, pii v[], int n) {
    fori(n) {
        if(x == v[i].first || y == v[i].second || abs(x - v[i].first) == abs(y - v[i].second))continue;
        re 0;
    }
    re 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        pii q[n];
        for (pii &i : q) {
            cin >> i.first >> i.second;
        }
        int x1, y1, x2, y2;
        bool w1 = 0, w2 = 0;
        fori(n) {
            if(!w1) {
                x1 = q[i].first;
                y1 = q[i].second;
                w1 = 1;
            } else if(!w2 && x1 != q[i].first && y1 != q[i].second && abs(x1 - q[i].first) != abs(y1 - q[i].second)) {
                x2 = q[i].first;
                y2 = q[i].second;
                w2 = 1;
            }
        }
        if(!w2) {
            cout << "YES\n";
            cout << x1 << " " << y1 << "\n";
            continue;
        }
        int k = min(x2 - x1, abs(y2 - y1));
        vector<pair<ld, ld>> dots(6);
        dots[0] = {x2 - k, y2 + (y2 > y1 ? -k : k)};
        dots[1] = {x1 + (dots[0].first - x1) * 0.5, y1 + (y2 > y1 ? 1 : -1) * (dots[0].first - x1) * 0.5};
        dots[2] = {x2 + 2 * (dots[1].first - x2), y2};
        dots[3] = {dots[0].first + 2 * (dots[1].first - dots[0].first), dots[0].second + 2 * (dots[1].second - dots[0].second)};
        dots[4] = {x1, y2};
        dots[5] = {dots[3].first + 2 * (dots[4].first - dots[3].first), dots[3].second + 2 * (dots[4].second - dots[3].second)};
        ld mid_x = (x1 + x2) * 0.5, mid_y = (y1 + y2) * 0.5;
        for (int i = 0; i < 6; i++) {
            dots.push_back({mid_x + (mid_x - dots[i].first), mid_y  + (mid_y - dots[i].second)});
        }
        bool ok = false;
        for (auto &dot : dots) {
            int x = dot.first;
            int y = dot.second;
            if (x != dot.first || y != dot.second) {
                continue;
            }
            if (check(x, y, q, n)) {
                ok = true;
                cout << "YES\n" << x << ' ' << y << '\n';
                break;
            }
        }
        if (!ok) {
            cout << "NO\n";
        }
    }

    return 0;
}