import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Main {
    static Set<Character> vowels = new HashSet<>() {{
        add('a');
        add('e');
        add('i');
        add('o');
        add('u');
        add('y');
    }};

    private static boolean isVowel(char x) {
        return vowels.contains(x);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        char[] shortName = sc.next().toLowerCase().toCharArray(), fullName = sc.next().toLowerCase().toCharArray();
        int i = 0, j = 0, n = shortName.length, m = fullName.length;
        while (i < n && j < m) {
            if (shortName[i] == fullName[j]) {
                i++; j++;
                continue;
            }
            if (isVowel(fullName[j])) {
                j++;
            } else {
                break;
            }
        }
        while (j < m && isVowel(fullName[j])) {
            j++;
        }
        if (i == n && j == m) {
            System.out.println("Same");
        } else {
            System.out.println("Different");
        }
    }
}