#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <set>
#include <queue>

#define ll long long

using namespace std;

int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

int solve() {
    int n, p, m;
    cin >> n >> p >> m;
    unsigned int ans[n+1][512];
    for (int i = 0; i < 512; i++) {
        for (int ii = 0; ii <= n - p; ii++)
            ans[ii][i] = 0;
    }
    ans[0][p] = 1;
    for (int j = 1; j <= n - p; j++) {
        for (int i = 0; i + j <= n - p; i++) {
            for (int k = 0; k < 512; k++) {
                int t = k ^ j;
                ans[i+j][t] += ans[i][k];
                ans[i+j][t] %= m;
            }
        }
    }
//    for (int i = 0; i <= n-p; i++) {
//        for (int j = 0; j < 8; j++) {
//            cout << ans[i][j] << " ";
//        }
//        cout << endl;
//    }
    cout << ans[n - p][0];
    return 0;
}