#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <set>
#include <queue>
#include <cassert>

#define ll long long

using namespace std;

int solve();

const int N = 11;
vector<int> a;
int pr_ans = -1, cur_ans = -1;
int sz, init;



void generate(int n, int k) {
    if (n + 1 == k) {
        return;
    }
    if (k == 1) {
        a.push_back(0);
        a.push_back(1);
    } else {
        vector<int> b = a;
        reverse(b.begin(), b.end());
        for (int i = 0; i < a.size(); i++) {
            a[i] *= 2;
        }
        for (int i = 0; i < b.size(); i++) {
            a.push_back(b[i] * 2 + 1);
        }
    }
    generate(n, k + 1);
}

map<pair<int, int>, unsigned > otrs;
pair<int, int> find_empty(int n, int m);
void init2() {
    for (int i = 1; i <= sz; i++) {
        for (int j = i; j <= sz; j++) {
            otrs[{i, j}] = (unsigned)rand() % 2;
            cout << i << " " << j << " " << otrs[{i, j}] << "\n";
        }
    }
}


bool res = false;
int trs = 0;

signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    generate(N, 0);
    sz = 3;
    for (int i = 0; i < 10; i++) {
        res = false;
        trs = 0;
        init2();

        solve();

        if (trs > 2450) {
            return 0;
        }
    }

    return 0;
}




int get_q(int a, int b) {

    vector<int> fl(sz + 1, true);
    otrs[{a, b}] = (otrs[{a, b}] + 1) % 2;
    for (int i = 1; i <= sz; i++) {
        for (int j = i; j <= sz; j++) {
            if (otrs[{i, j}] == 1) {
                for (int k = i; k <= j; k++)
                    fl[k] = false;
            }
        }
    }
    int c = 0;
    for (int i = 1; i <= sz; i++) {
        if (fl[i] == true)
            c++;
    }

    return c;
}


void query(int a, int b) {
    if (res)
        return;
    trs++;
    pr_ans = cur_ans;
//    cout << a << ' ' << b << endl;
    int ans = get_q(a, b);

//    cin >> ans;
//    if (ans == sz) {
//        exit(0);
//    }
    cur_ans = ans;
    if (cur_ans == sz)
        res = true;
}

int get_log(int n) {
    int x = 0;
    while (n > 0) {
        n /= 2;
        x++;
    }
    return x - 1;
}

vector<int> get_turns(int k) {
    vector<int> fitted, ans;
    for (int i = 0; i < (1 << k); i++) {
        fitted.push_back(a[i] >> (N - k));
    }
    for (int i = 1; i < fitted.size(); i++) {
        ans.push_back(get_log(fitted[i] ^ fitted[i - 1]));
    }
    return ans;
}

pair<int, int> find_empty(int n, int m) {
    for (int pq = n; pq <= m; pq++) {
        query(pq, pq);
        if (cur_ans == pr_ans + 1) {
            return {pq, 1};
        }
        if (cur_ans == pr_ans - 1) {
            query(pq, pq);
            return {pq, 0};
        }
    }
    //assert(false);
    // VERIFY: not here
}

void clearify(int n, int m, int num_zero_cells) {
    if (m < n) {
        return;
    }
    if (n == m) {
        if (num_zero_cells == 1) {
            return;
        }
        query(n, m);
        return;
    }
    if (num_zero_cells > 0) {
        auto ind = find_empty(n, m);
        clearify(n, ind.first - 1, 0);
        clearify(ind.first + 1, m, num_zero_cells - 1 + ind.second);
        return;
    }
    vector<int> turns = get_turns(m - n + 1);
    for (int turn : turns) {
        assert(n + turn <= m);
        query(n, n + turn);
        if (cur_ans > pr_ans) {
            int t = cur_ans - pr_ans;
            auto ind = find_empty(n, m);
            clearify(n, ind.first - 1, 0);
            clearify(ind.first + 1, m, t - 1 + ind.second);
        }
    }
}

int solve() {
//    cin >> sz >> init;
    init = get_q(1, sz);
    cur_ans = init;
    clearify(1, sz, init);
    return 0;
}