#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <set>
#include <queue>

#define ll long long

using namespace std;

int solve();

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

int solve() {
    string s, t;
    cin >> s >> t;
    for (int i = 0; i < s.size(); i++) {
        if (s[i] >= 'A' && s[i] <= 'Z') {
            s[i] -= 'A';
            s[i] += 'a';
        }
    }
    for (int i = 0; i < t.size(); i++) {
        if (t[i] >= 'A' && t[i] <= 'Z') {
            t[i] -= 'A';
            t[i] += 'a';
        }
    }
    set<char> vowels = {'a', 'e', 'i', 'o', 'u', 'y'};
    int ind = 0;
    for (int i = 0 ; i < s.size(); i++) {
        if (ind == t.size()) {
            cout << "Different" << endl;
            return 0;
        }
        while (ind < t.size() && s[i] != t[ind]) {
           if (vowels.find(t[ind]) != vowels.end()) {
               ind++;
           } else {
               cout << "Different" << endl;
               return 0;
           }
        }
        if (ind == t.size()) {
            cout << "Different" << endl;
            return 0;
        }
        ind++;
    }
    while (ind < t.size()) {
        if (vowels.find(t[ind]) != vowels.end()) {
            ind++;
        } else {
            cout << "Different" << endl;
            return 0;
        }
    }
    cout << "Same" << endl;
    return 0;
}