#include <bits/stdc++.h>

using namespace std;

int main() {
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--) {
        int n; cin >> n;

        vector<int> colors(2 * n + 1), visited(n + 1, 2);
        visited[0] = 0;

        vector<set<int>> g(2 * n + 1);

        int removed = 0;

        for (int i = 1; i <= 2 * n; i++) cin >> colors[i];

        for (int i = 1; i <= 2 * n - 1; i++) {
            int a, b; cin >> a >> b;

            g[a].emplace(b);
            g[b].emplace(a);
        }

        if (n == 1) {
            cout << 1 << '\n';
            continue;
        }

        queue<int> q;

        for (int i = 1; i <= 2 * n; i++) {
            if (g[i].size() == 1) q.push(i);
        }

        while (!q.empty()) {
            int leaf = q.front();
            q.pop();
            int color = colors[leaf];

            if (visited[color] == 1) continue;

            removed++;
            visited[color]--;

            for (auto elem: g[leaf]) {
                g[elem].erase(leaf);
                if (g[elem].size() == 1) {
                    q.push(elem);
                }
            }

            g[leaf].clear();
        }

        if (removed != n) {
            cout << -1 << '\n';
            continue;
        }

        for (int i = 1; i <= 2 * n; i++) {
            if (!g[i].empty()) cout << i << ' ';
        }

        cout << '\n';
    }
}
