//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>
#define int long long

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;

#define rep(i, n) for (int i = 0; i < n; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll lcm(ll a, ll b) {
    return (a / gcd(a, b) * b);
}

string itos(ll k) {
    string res = "";
    if (k == 0) return "0";
    while (k) {
        char c = '0' + k % 10;
        res = c + res;
        k /= 10;
    }
    return res;
}

void solve() {
    ll n; cin >> n;
    deque<ll> a(n), b(n);
    rep(i, n) cin >> a[i];
    rep(i, n) cin >> b[i];
    string ans = "";
    vi st;
    while (a.size() || b.size()) {
        if (b.size() && st.size() && st.back() == b.front()) {
            ans += "C";
            st.pop_back();
            b.pop_front();
        } else if (a.size()) {
            st.push_back(a.front());
            a.pop_front();
            ans += "S";
        } else {
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n" << ans << '\n';

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
