#include <bits/stdc++.h>

#define int long long
#define pb push_back

using namespace std;

struct point {
    int x, y;

    point(int a, int b) {
        x = a;
        y = b;
    }
    point() {
        x = 0;
        y = 0;
    }
};

vector<point> get(point a, point b) {
    if (a.x > b.x) swap(a, b);
    vector<point> inter;
    int bb = b.y - b.x;
    inter.pb(point(a.x, a.x + bb));
    inter.pb(point(a.y - bb, a.y));
    bb = b.y + b.x;
    inter.pb(point(-a.y + bb, a.y));
    inter.pb(point(a.x, -a.x + bb));
    bb = a.y - a.x;
    inter.pb(point(b.x, b.x + bb));
    inter.pb(point(b.y - bb, b.y));
    bb = a.y + a.x;
    inter.pb(point(b.x, -b.x + bb));
    inter.pb(point(-b.y + bb, b.y));
    inter.pb(point(a.x, b.y));
    inter.pb(point(b.x, a.y));
    int b1 = a.y - a.x;
    int b2 = b.y + b.x;
    if ((b2 - b1) % 2 == 0) {
        int tx = (b2 - b1) / 2;
        int ty = a.x + b1;
        inter.pb(point(tx, ty));
    }
    swap(a, b);
    b1 = a.y - a.x;
    b2 = b.y + b.x;
    if ((b2 - b1) % 2 == 0) {
        int tx = (b2 - b1) / 2;
        int ty = a.x + b1;
        inter.pb(point(tx, ty));
    }

    return inter;
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int tt;
    cin >> tt;
    while (tt--) {
        int n;
        cin >> n;
        vector<point> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i].x >> a[i].y;
        }
        int ind = -1;
        for (int i = 1; i < n; i++) {
            if (a[i].x != a[0].x && a[i].y != a[0].y && abs(a[i].x - a[0].x) != abs(a[i].y - a[0].y)) {
                ind = i;
            }
        }
        if (ind == -1) {
            cout << "YES\n";
            cout << a[0].x << " " << a[0].y << "\n";
            continue;
        }
        vector<point> vsec = get(a[0], a[ind]);
//        for (auto el : vsec) {
//            cout << el.x << " " << el.y << "\n";
//        }
        int sz = vsec.size();
        vector<bool> ans(sz, true);
        for (int i = 0; i < n; i++) {
            vector<bool> curr(sz);
            for (int j = 0; j < sz; j++) {
                point el = vsec[j];
                if (el.x == a[i].x || el.y == a[i].y || abs(el.y - a[i].y) == abs(el.x - a[i].x)) {
                    curr[j] = true;
                }
            }
            for (int j = 0; j < sz; j++) {
                ans[j] = ans[j] && curr[j];
            }
        }
        bool f = false;
        for (int i = 0; i < sz; i++) {
            if (ans[i]) {
                cout << "YES\n";
                cout << vsec[i].x << " " << vsec[i].y << "\n";
                f = true;
                break;
            }
        }
        if (!f) {
            cout << "NO\n";
        }
    }
}
