#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()

using namespace std;
int n;
int k;
int ask(int a, int b) {
    int ret;
    if (a > b)
        swap(a, b);
    cout << a << " " << b << endl;
    cin >> ret;
    if (ret == n) {
        exit(0);
    }
    return ret;
}


vector<vector<int>> gen(int n) {
    if (n == 2) {
        vector<int> a = {0, 0};
        vector<int> b = {1, 0};
        vector<int> c = {1, 1};
        vector<int> d = {0, 1};
        return {a, b, c, d};
    }
    auto r = gen(n - 1);
    vector<vector<int>> res;
    for (auto &v : r) {
        vector<int> tmp;
        tmp.pb(0);
        for (int &el : v) tmp.pb(el);
        res.pb(tmp);
    }
    reverse(all(r));
    for (auto &v : r) {
        vector<int> tmp;
        tmp.pb(1);
        for (int &el : v) tmp.pb(el);
        res.pb(tmp);
    }
    return res;
}

vector<int> func(int n) {
    if (n == 1) {
        return {0, 1};
    }
    auto v = gen(n);
    vector<int> res;
    for (auto &r : v) {
        int x = 0;
        for (int i = 0; i < n; i++) {
            x += (1 << i) * r[n - i - 1];
        }
        res.pb(x);
    }
    return res;
}

signed main() {
//    cin.tie(0);
//    ios_base::sync_with_stdio(false);
    cin >> n;
    cin >> k;
    if (k == n) {
        return 0;
    }
    set<pair<int, int>> st;
    for (int cell = 1; cell <= n; cell++) {
        int prevk = k;
        k = ask(cell, cell);
        // opened this
        if (k > prevk) {
            for (int i = 1; i <= n; i++) {
                st.insert({i, cell});
                st.insert({cell, i});
            }
            continue;
        } else if (k < prevk) {
            //closed it
            k = ask(cell, cell);
            for (int i = 1; i <= n; i++) {
                st.insert({i, cell});
                st.insert({cell, i});
            }
            continue;
        }
        k = ask(cell, cell);
        vector<int> gray = func(n);
        int sz = (int) gray.size();
        for (int i = 1; i < sz; i++) {
            int prev = gray[i - 1];
            int curr = gray[i];
            int toswap = -1;
            for (int bit = 0; bit < n; bit++) {
                if (((1ll << bit) & prev) != ((1ll << bit) & curr)) {
                    toswap = bit;
                    break;
                }
            }
            toswap += 1;
            prevk = k;
            if (!st.count({cell, toswap})) {
                k = ask(cell, toswap);
                if (k < prevk) {
                    // closed something
                    k = ask(cell, toswap);
                    st.insert({cell, toswap});
                } else if (k > prevk) {
                    // opened something
                    st.insert({cell, toswap});
                    st.insert({toswap, cell});
                    int kek = k;
                    k = ask(cell, cell);
                    if (k < kek) {
                        // opened it
                        k = ask(cell, cell);
                        for (int j = 1; j <= n; j++) {
                            st.insert({j, cell});
                            st.insert({cell, j});
                        }
                        break;
                    } else {
                        // opened smth else
                        k = ask(cell, cell);
                        st.insert({cell, cell});
                    }
                }
            }
        }
    }
}
