#include <bits/stdc++.h>
#define int int64_t

using namespace std;

void solve() {
    string s, t;
    cin >> s >> t;
    const vector<char> vowels{'a', 'e', 'i', 'o', 'u', 'y'};
    vector<int> is_vowel(26, -1);
    for (int i = 0; i < (int) vowels.size(); i++) {
        is_vowel[vowels[i] - 'a'] = i;
    }
    int vowels_cnt = (int) vowels.size();
    int max_mask = (1 << vowels_cnt);
    for (int mask = 0; mask < max_mask; mask++) {
        string new_s, new_t;
        for (int i = 0; i < (int) s.size(); i++) {
            const int c = s[i] - 'a';
            if (is_vowel[c] != -1 && (mask & (1 << is_vowel[c]))) {
                continue;
            }
            new_s.push_back(s[i]);
        }
        for (int i = 0; i < (int) t.size(); i++) {
            const int c = t[i] - 'a';
            if (is_vowel[c] != -1 && (mask & (1 << is_vowel[c]))) {
                continue;
            }
            new_t.push_back(t[i]);
        }
        if (new_s == new_t) {
            cout << "Same";
            return;
        }
    }
    cout << "Different";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt --> 0) {
        solve();
    }
    return 0;
}
