#include <bits/stdc++.h>
#define int int64_t

using namespace std;

void make_lowercase(string &s) {
    for (int i = 0; i < (int) s.size(); i++) {
        if (s[i] >= 'A' && s[i] <= 'Z') {
            s[i] -= 'A' - 'a';
        }
    }
}

void solve() {
    string short_name, full_name;
    cin >> short_name >> full_name;
    make_lowercase(short_name), make_lowercase(full_name);
    const vector<char> vowels{'a', 'e', 'i', 'o', 'u', 'y'};
    vector<bool> is_vowel(26, -1);
    for (int i = 0; i < (int) vowels.size(); i++) {
        is_vowel[vowels[i] - 'a'] = true;
    }
    int current_index = 0;
    for (int i = 0; i < (int) full_name.size() && current_index < (int) short_name.size(); i++) {
        if (full_name[i] == short_name[current_index]) {
            current_index++;
            continue;
        }
        if (full_name[i] == '-' || !is_vowel[full_name[i] - 'a']) {
            cout << "Different";
            return;
        }
    }
    cout << "Same";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt --> 0) {
        solve();
    }
    return 0;
}
