#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;


#define vi vector<int>
#define vl vector<ll>
#define all(v) v.begin(), v.end()

using namespace std;

/*
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

int rand(int l, int r) {
    return uniform_int_distribution(l, r)(gen);
}

struct Queen {
    int x, y;
    Queen(): x(0), y(0) {}
};

struct Intersection {
    int type;
    int d;
    int d2;

    Intersection(): type(6), d(-1), d2(-1) {}
    Intersection(int t, int d): type(t), d(d), d2(-1) {}
    Intersection(int t, int d1, int d2): type(t), d(d1), d2(d2) {}
    // type 1: x = d
    // type 2: y = d
    // type 3: y = x + d
    // type 4: y = -x + d
    // type 5: (x, y)
    // type 6: empty

    bool contains(int x, int y) {
        if (type == 1) {
            return d == x;
        } else if (type == 2) {
            return d == y;
        } else if (type == 3) {
            return y == x + d;
        } else if (type == 4) {
            return y == -x + d;
        } else if (type == 5) {
            return d == x && d2 == y;
        } else if (type == 6) {
            return false;
        }

        return false;
    }

    pair <int, int> get_point() {
        if (type == 1) {
            return {d, 0};
        } else if (type == 2) {
            return {0, d};
        } else if (type == 3) {
            return {-d, 0};
        } else if (type == 4) {
            return {d, 0};
        } else if (type == 5) {
            return {d, d2};
        }
    }
};

Intersection operator+(Intersection lhs, Intersection rhs) {
    if (lhs.type == 6) {
        return lhs;
    } else if (rhs.type == 6) {
        return rhs;
    }

    if (lhs.type == 5) {
        if (rhs.contains(lhs.d, lhs.d2)) {
            return lhs;
        } else {
            return Intersection();
        }
    } else if (rhs.type == 5) {
        return rhs + lhs;
    }

    if (lhs.type == 4 && rhs.type == 4) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    if (lhs.type == 4 && rhs.type == 3) {
        if ((lhs.d - rhs.d) % 2 == 0) {
            return Intersection(5, (lhs.d - rhs.d) / 2, (lhs.d - rhs.d) / 2 + rhs.d);
        } else {
            return Intersection();
        }
    } else if (lhs.type == 3 && rhs.type == 4) {
        return rhs + lhs;
    }

    if (lhs.type == 4 && rhs.type == 2) {
        return Intersection(5, lhs.d - rhs.d, rhs.d);
    } else if (rhs.type == 4 && lhs.type == 2) {
        return rhs + lhs;
    }

    if (lhs.type == 4 && rhs.type == 1) {
        return Intersection(5, rhs.d, -rhs.d + lhs.d);
    } else if (lhs.type == 1 && rhs.type == 4) {
        return rhs + lhs;
    }

    if (lhs.type == 3 && rhs.type == 3) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    if (lhs.type == 3 && rhs.type == 2) {
        return Intersection(5, rhs.d - lhs.d, rhs.d);
    } else if (rhs.type == 3 && lhs.type == 2) {
        return Intersection();
    }

    if (lhs.type == 3 && rhs.type == 1) {
        return Intersection(5, rhs.d, lhs.d + rhs.d);
    } else if (rhs.type == 3 && lhs.type == 1) {
        return Intersection();
    }

    if (lhs.type == 2 && rhs.type == 2) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    if (lhs.type == 2 && rhs.type == 1) {
        return Intersection(5, rhs.d, lhs.d);
    } else if (rhs.type == 2 && lhs.type == 1) {
        return rhs + lhs;
    }

    if (lhs.type == 1 && rhs.type == 1) {
        if (lhs.d == rhs.d) {
            return lhs;
        } else {
            return Intersection();
        }
    }

    cerr << "unhandled " << lhs.type << ' ' << rhs.type << '\n';
    return Intersection();
}


//// task E
//void solve() {
//    int n;
//    cin >> n;
//
//    vector <Queen> queens(n);
//    for (auto &q: queens) {
//        cin >> q.x >> q.y;
//    }
//
//    if (n == 1) {
//        cout << queens[0].x << ' ' << queens[0].y << '\n';
//        return;
//    }
//
//    auto get_nuggets = [&] (int i) {
//        auto q = queens[i];
//        return vector <Intersection> {
//            Intersection(1, q.x),
//            Intersection(2, q.y),
//            Intersection(3, q.y - q.x),
//            Intersection(4, q.y + q.x)
//        };
//    };
//
//    vector <Intersection> nuggets;
//    for (auto x: get_nuggets(0)) {
//        nuggets.push_back(x);
//    }
//
//    for (int i = 1; i < n; i++) {
//        set <pair <int, pair <int, int>>> seen;
//        vector <Intersection> new_nuggets;
//        for (auto x: get_nuggets(i)) {
//            for (auto y: nuggets) {
//                auto z = x + y;
//                if (z.type != 6) {
//                    if (seen.find({z.type, {z.d, z.d2}}) != seen.end()) {
//                        continue;
//                    }
//
//                    seen.insert({z.type, {z.d, z.d2}});
////                    cout << x.type << ' ' << x.d << ' ' << x.d2 << " + ";
////                    cout << y.type << ' ' << y.d << ' ' << y.d2 << " = ";
////                    cout << z.type << ' ' << z.d << ' ' << z.d2 << "\n";
//
//                    new_nuggets.push_back(z);
//                }
//            }
//        }
//
//        nuggets = new_nuggets;
////        cout << nuggets.size() << '\n';
//
//    }
//
//    if (nuggets.empty()) {
//        cout << "NO\n";
//    } else {
//        auto [x, y] = nuggets.front().get_point();
//        cout << "YES\n";
//        cout << x << ' ' << y << '\n';
//    }
//}
 */
int n, p, m;
int arr[512][500][500], f[512][500][500];

void calc(int x, int y, int z) {
    if (!f[x][y][z]) {
        f[x][y][z] = 1;
        for (int g = 1; g <= z; g++) {
            if (y < g) {
                break;
            }
            calc(x ^ g, y - g, g);
            arr[x][y][z] += arr[x ^ g][y - g][g];
            arr[x][y][z] %= m;
        }
    }
}

void solve() {
    cin >> n >> p >> m;
    n -= p;
    for (int i = 1; i <= n; i++) {
        f[0][0][i] = 1;
        arr[0][0][i] = 1;
    }
    calc(p, n, n);
    cout << arr[p][n][n] << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
       cin.tie( nullptr);
    int tt = 1;
//     cin >> tt; // CAUTION FOR TASK E
    while (tt--) {
        solve();
    }
}


