#include <bits/stdc++.h>

typedef long double ld;
typedef long long ll;


#define vi vector<int>
#define vl vector<ll>
#define all(v) v.begin(), v.end()

using namespace std;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

int rand(int l, int r) {
    return uniform_int_distribution(l, r)(gen);
}


//void solve() {
//    ll d;
//    cin >> d;
//    ll d2 = d;
//    ll res = 0;
//    ll d1 = d;
//    while (d1 > 0) {
//        res += d1 % 10;
//        d1 /= 10;
//    }
//    ll d3 = d;
//    d3 -= res;
//    ll f = d3 / 9;
//    for (int i = 0; i < f; i++) {
//        cout << "9";
//    }
//    cout << d % 9;
//    cout << d2 << "\n";
//    cout << 9013 % 13 << "\n";
//}

ll bitCnt(ll x) {
    ll cnt=  0;
    while( x) {
        cnt += x % 2;
        x /= 2;
    }
    return cnt;
}


void solve() {
    ll x; cin >> x;
    ll ans = 100;
    for (ll t = 1; t < 100; ++t) {
        ll y = x + t;
        if (bitCnt(y) <= t) {
            ans = min(ans, t);
        }

    }
    cout << ans - 1;
    cout << '\n';
}

struct Queen {
    int x, y;
    Queen(): x(0), y(0) {}
};

struct Intersection {
    int type;
    int d;
    int d2;

    Intersection(): type(6) {}
    Intersection(int t, int d): type(t), d(d) {}
    Intersection(int t, int d1, int d2): type(t), d(d1), d2(d2) {}
    // type 1: x = d
    // type 2: y = d
    // type 3: y = x + d
    // type 4: y = -x + d
    // type 5: (x, y)
    // type 6: empty

    bool contains(int x, int y) {
        if (type == 1) {
            return d == x;
        } else if (type == 2) {
            return d == y;
        } else if (type == 3) {
            return y == x + d;
        } else if (type == 4) {
            return y == -x + d;
        } else if (type == 5) {
            return d == x && d2 == y;
        } else if (type == 6) {
            return false;
        }
    }
};

//Intersection operator+(Intersection lhs, Intersection rhs) {
//    if (lhs.type == 6) {
//        return lhs;
//    } else if (rhs.type == 6) {
//        return rhs;
//    }
//
//    if (lhs.type == 5) {
//        if (rhs.contains(lhs.d, lhs.d2)) {
//            return lhs;
//        } else {
//            return Intersection();
//        }
//    } else if (rhs.type == 5) {
//        return rhs + lhs;
//    }
//
//    if (lhs.type == 4) {
//        if (rhs.type == 4 && rhs.d == lhs.d) {
//            return
//        }
//    } else if (rhs.type == 4) {
//        return rhs + lhs;
//    }
//}

// task E
//void solve() {
//    int n;
//    cin >> n;
//
//    vector <Queen> queens(n);
//    for (auto &q: queens) {
//        cin >> q.x >> q.y;
//    }
//
//    if (n == 1) {
//        cout << queens[0].x << ' ' << queens[0].y << '\n';
//        return;
//    }
//
//    vector <Intersection> nuggets;
//
//    auto get_nuggets = [&] (int i) {
//        auto q = queens[i];
//        return vector <Intersection> {
//            Intersection(1, q.x),
//            Intersection(2, q.y),
//            Intersection(3, q.y),
//            Intersection(4, q.y)
//        };
//    };
//
//
//}

signed main() {
    ios_base::sync_with_stdio(false);
       cin.tie( nullptr);
    int tt = 1;
     cin >> tt; // CAUTION FOR TASK E
    while (tt--) {
        solve();
    }
}
