#include <iostream>
#include <vector>
#include <cassert>
#include <set>
#include <utility>
#include <map>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <cmath>
#include <queue>
#include <string>
#include <deque>
#include <fstream>
#include <sstream>

#define int long long
#define PAR pair<int, int>
#define ld long double
#define VI vector<int>
#define VB vector<bool>
#define VC vector<char>
#define VP vector<PAR>
#define VII vector<VI>
#define sstream stringstream
#define cont continue
#define foriab(i,a,b) for(int i=(a);i<(b);++i)
#define foris(i,s) fori(i,s.sz())
#define fori(i,n) foriab(i,0,n)
#define endl '\n'
#define ret return
#define VVI vector<VI>
#define VS vector<string>
#define x first
#define y second
#define sz size
#define pb push_back
#define pp pop_back
#define pf push_front
#define ppf pop_front
#define wall(X) X.begin(),X.end()

using namespace std;

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i)
		in >> v[i];
	return in;
}

template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	for (const T& val : v)
		out << val << ' ';
	return out << '\n';
}

template<class T>
ostream& operator<<(ostream& out, const set<T>& v) {
	for (const T& val : v)
		out << val << ' ';
	return out << '\n';
}

template<class T>
istream& operator>>(istream& in, deque<T>& v) {
	for (int i = 0; i < v.size(); ++i)
		in >> v[i];
	return in;
}

template<class T>
ostream& operator<<(ostream& out, const deque<T>& v) {
	for (const T& val : v)
		out << val << ' ';
	return out << '\n';
}

template<class A, class B>
istream& operator>>(istream& in, pair<A, B>& p) {
	return in >> p.first >> p.second;
}

template<class A, class B>
ostream& operator<<(ostream& out, const pair<A, B>& p) {
	return out << p.first << ' ' << p.second << '\n';
}

template<class A, class B>
bool rmin(A& a, const B& b) {
	A t = b;
	if (a > t) {
		a = move(t);
		return true;
	}
	return false;
}

template<class A, class B>
bool rmax(A& a, const B& b) {
	A t = b;
	if (a < t) {
		a = move(t);
		return true;
	}
	return false;
}


struct pnt {
	int x, y;
	pnt(int xs, int ys)
	{
		x = xs;
		y = ys;
	}
};



pnt merge1(pnt a, pnt b)
{
	ret a;
}

bool is_at(pnt a, pnt b)
{
	if (a.x == b.x) return 1;
	if (a.y == b.y) return 1;
	if (abs(a.x - b.x) == abs(a.y - b.y)) return 1;
	return 0;
}

signed main(){

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	
	int t;
	cin >> t;
	while (t--)
	{
		bool bfl = 0;
		int n;
		cin >> n;
		int x, y;
		vector<pnt> v;
		for (int i = 0; i < n; i++)
		{
			cin >> x >> y;
			v.push_back(pnt(x, y));
		}

		bool fl = 1;
		vector<pnt> cur = {v[0]};
		x = v[0].x;

		for (int i = 1; i < n; i++) {
			if (fl)
			{
				if (v[i].x == x) {
					continue;
				}
				fl = 0;
				cur = {};
				cur.push_back(pnt(x, v[i].y));
				cur.push_back(pnt(x, v[i].y + x - v[i].x));
				cur.push_back(pnt(x, v[i].y - x + v[i].x));
			}
			else {
				vector<pnt> ncur = {};
				for (auto p : cur)
				{
					if (is_at(p, v[i]))
						ncur.push_back(p);
				}
				cur = ncur;
			}
		}

		if (fl || cur.size() != 0) {
			cout << "YES" << "\n";
			for (auto p : cur)
			{
				if (abs(p.x) <= 1e9 && abs(p.y) <= 1e9) {
					cout << p.x << ' ' << p.y << "\n";
					break;
				}
			}
		
			continue;
		}


		//y

		fl = 1;
		cur = {v[0]};
		y = v[0].y;

		for (int i = 1; i < n; i++) {
			if (fl)
			{
				if (v[i].y == y) {
					continue;
				}
				fl = 0;
				cur = {};
				cur.push_back(pnt(v[i].x, y));
				cur.push_back(pnt(v[i].y- y + v[i].x, y));
				cur.push_back(pnt(-v[i].y + y + v[i].x, y));
			}
			else {
				vector<pnt> ncur = {};
				for (auto p : cur)
				{
					if (is_at(p, v[i]))
						ncur.push_back(p);
				}
				cur = ncur;
			}
		}

		if (fl || cur.size() != 0) {
			cout << "YES" << "\n";
			for (auto p : cur)
			{
				if (abs(p.x) <= 1e9 && abs(p.y) <= 1e9) {
					cout << p.x << ' ' << p.y << "\n";
					break;
				}
			}
			continue;
		}


		//

		fl = 1;
		cur = {};
		y = v[0].y;
		x = v[0].x;

		for (int i = 1; i < n; i++) {
			if (fl)
			{
				if (x - v[i].x == y - v[i].y) {
					continue;
				}
				fl = 0;
				cur = {};
				cur.push_back(pnt(x + y - v[i].y, v[i].y));
				cur.push_back(pnt(v[i].x, x + y - v[i].x));
				if ((x + y + v[i].x - v[i].y) % 2 == 0)
				{
					int a = x + y;
					int b = v[i].x - v[i].y;
					cur.push_back(pnt((a + b) /2, (a - b) / 2));
				}
			}
			else {
				vector<pnt> ncur = {};
				for (auto p : cur)
				{
					if (is_at(p, v[i]))
						ncur.push_back(p);
				}
				cur = ncur;
			}
		}

		if (fl || cur.size() != 0) {
			cout << "YES" << "\n";
			for (auto p : cur)
			{
				if (abs(p.x) <= 1e9 && abs(p.y) <= 1e9) {
					cout << p.x << ' ' << p.y << "\n";
					break;
				}
			}
			continue;
		}

		fl = 1;
		cur = {};
		y = v[0].y;
		x = v[0].x;

		for (int i = 1; i < n; i++) {
			if (fl)
			{
				if (x - v[i].x == v[i].y - y) {
					continue;
				}
				fl = 0;
				cur = {};
				cur.push_back(pnt(x - y + v[i].y, v[i].y));
				cur.push_back(pnt(v[i].x, x - y + v[i].x));
				if ((x + y + v[i].x - v[i].y) % 2 == 0)
				{
					int b= x - y;
					int a = v[i].x + v[i].y;
					cur.push_back(pnt((a + b) / 2, (a - b) / 2));
				}
			}
			else {
				vector<pnt> ncur = {};
				for (auto p : cur)
				{
					if (is_at(p, v[i]))
						ncur.push_back(p);
				}
				cur = ncur;
			}
		}

		if (fl || cur.size() != 0) {
			cout << "YES" << "\n";
			for (auto p : cur)
			{
				if (abs(p.x) <= 1e9 && abs(p.y) <= 1e9) {
					cout << p.x << ' ' << p.y << "\n";
					break;
				}
			}
			continue;
		}
		cout << "NO\n";
	}
	

	
}
