#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <string>
#include <map>
#include <set>

using namespace std;

map <char, int> mp;

int main()
{
	std::ios_base::sync_with_stdio(false);

	string str1, str2;
	cin >> str1 >> str2;

	sort(str1.begin(), str1.end());
	sort(str2.begin(), str2.end());

	if (str1.size() == str2.size())
	{
		for (int i(0); i < str1.size(); i++)
		{
			if (str1[i] != str2[i])
			{
				cout << "Different";
				return 0;
			}
		}
	}

	for (int i(0); i < str1.size(); i++) mp[tolower(str1[i])]++;
	for (int i(0); i < str2.size(); i++) mp[tolower(str2[i])]--;

	for (auto it : mp)
	{
		if (it.second < 0 &&
			tolower(it.first) != 'a' &&
			tolower(it.first) != 'e' &&
			tolower(it.first) != 'i' &&
			tolower(it.first) != 'o' &&
			tolower(it.first) != 'u' &&
			tolower(it.first) != 'y') 
		{
			cout << "Different";
			return 0;
		}
	}
	cout << "Same";
}