#include <bits/stdc++.h>

using namespace std;
//#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> x(n);
    vector<int> y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i];
    }

    if (n == 1) {
        cout << x[0] << " " << y[0];
        return;
    }
    int j = 0;
    for (int i = 1; i < n; ++i) {
        if (x[i] != x[0] && y[i] != y[0] && abs(x[i] - x[0]) != abs(y[i] - y[0])) {
            j = i;
            break;
        }
    }
    if (j) {
        vector<int> px{x[0], x[j], x[0] + (y[j] - y[0]), x[j], x[j] + (y[0] - y[j]), x[0], x[0] - (y[j] - y[0]), x[j],
                       x[j] - (y[0] - y[j]), x[0]};
        vector<int> py{y[j], y[0], y[j], y[0] + (x[j] - x[0]), y[0], y[j] + (x[0] - x[j]), y[j], y[0] - (x[j] - x[0]),
                       y[0], y[j] - (x[0] - x[j])};
        if (abs(x[0] - y[0]) % 2 == abs(x[j] + y[j]) % 2) {
            int xx = ((x[0] - y[0]) + (x[j] + y[j])) / 2;
            int yy = xx - (x[0] - y[0]);
            px.push_back(xx);
            py.push_back(yy);
        }
        if (abs(x[0] + y[0]) % 2 == abs(x[j] - y[j]) % 2) {
            int xx = ((x[0] + y[0]) + (x[j] - y[j])) / 2;
            int yy = (x[0] + y[0]) - xx;
            px.push_back(xx);
            py.push_back(yy);
        }
        for (int p = 0; p < px.size(); ++p) {
            int flag = 1;
            for (int i = 0; i < n; ++i) {
                if (x[i] != px[p] && y[i] != py[p] && abs(x[i] - px[p]) != abs(y[i] - py[p])) {
                    flag = 0;
                    break;
                }
            }
            if (flag) {
                cout << "YES\n";
                cout << px[p] << " " << py[p] << '\n';
                return;
            }
        }
        cout << "NO\n";
    } else {
        cout << "YES\n";
        cout << x[0] << " " << y[0] << '\n';
    }
}

void solveJ() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (auto &i: a) cin >> i;
    for (auto &i: b) cin >> i;

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += a[i] > b[i];
    }


    int l = 0;
    int r = cnt;
    while (r - l > 1) {
        int m = (r + l) / 2;
        int flag = 0;
        for (int i = n - m; i < n; ++i) {
            if (b[i - (n - m)] >= a[i]) {
                flag = 1;
                break;
            }
        }
        for (int i = 0; i < n - m; ++i) {
            if (b[i + m] <= a[i]) {
                flag = 1;
                break;
            }
        }
        if (flag) {
            l = m;
        } else{
            r = m;
        }
    }

    int rr = r;

    l = r;
    r = n+1;

    while (r - l > 1) {
        int m = (r + l) / 2;
        int flag = 0;
        for (int i = n - m; i < n; ++i) {
            if (b[i - (n - m)] >= a[i]) {
                flag = 1;
                break;
            }
        }
        for (int i = 0; i < n - m; ++i) {
            if (b[i + m] <= a[i]) {
                flag = 1;
                break;
            }
        }
        if (flag) {
            r = m;
        } else{
            l = m;
        }
    }

    cout << r - rr << '\n';
    for (int i = rr; i < r; ++i){
        cout << i << " ";
    }
}


signed main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solveJ();
    }
}
