#include <bits/stdc++.h>
using namespace std;
  
// #define int long long
#define double long double
  
#define all(x) x.begin(), x.end()
 
template<typename T1, typename T2>
ostream& operator << (ostream& out, const pair<T1, T2>& p){
    out << p.first << ' ' << p.second;
    return out;
}
  
const int INF = 2e9 + 5;
const double eps = 1e-10;
  
// const int mod = 1e9 + 7;
const int SZ = 1 << 18;

int n, k;

int query(int l, int r){
	cout << l << ' ' << r << endl;
	int ans;
	cin >> ans;
	k = ans;
	if (k == n){
		exit(0);
	}
	return k;
}

vector<vector<int>> gen_gr(int sz){
	if (sz == 1){
		return {{0}, {1}};
	}

	auto fi = gen_gr(sz - 1);
	auto se = fi;
	reverse(all(se));

	for (auto& e : fi){
		e.insert(e.begin(), 0);
	}
	for (auto& e : se){
		e.insert(e.begin(), 1);
	}

	fi.insert(fi.end(), all(se));
	return fi;
}

void go(int l, vector<int> from, vector<int> to){
	for (int i = 0; i < from.size(); i++){
		if (from[i] != to[i]){
			query(l, l + i);
		}
	}
}

void solve(){

	cin >> n >> k;
	if (k == n){
		query(1, 1);
		query(1, 1);
	}
	for (int i = 1; i <= n; i++){
		auto gr = gen_gr(n - i + 1);
		// for (auto e : gr){
		// 	for (int g : e){
		// 		cout << g << ' ';
		// 	}
		// 	cout << '\n';
		// }
		// return;
		int mx = k;
		auto zn = gr.front();

		for (int j = 1; j < gr.size(); j++){
			go(i, gr[j - 1], gr[j]);
			if (k > mx){
				mx = k;
				zn = gr[j];
			}
		}

		go (i, gr.back(), zn);
	}
 
}
  
signed main(){
  
    // freopen("input.txt", "r", stdin);
  
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
  
    cout << fixed << setprecision(10);
  
    int t = 1;
    // cin >> t;
  
    while (t--){
        solve();
        cout << '\n';
    }
  
}