#include <bits/stdc++.h>

using namespace std;

const int N = 105;
bool dp[N][N][N];
int who[N][N][N];

string rec(int len, int i, int j) {
    if (len == 0) return "";
    int k = who[len][i][j];
    string left = rec(k - i, i, j);
    string right = rec(len - (k - i) - 1, k + 1, j + k - i);
    return left + "S" + right + "C";
}

void solve() {
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (a[i] == b[j]) {
                dp[1][i][j] = true;
                who[1][i][j] = i;
            }
        }
    }
    for (int len = 2; len <= n; ++len) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = i; k < i + len; ++k) {
                    if (a[k] == b[j + len - 1]) {
                        if ((k - i == 0 || dp[k - i][i][j]) && (len - (k - i) - 1 == 0 || dp[len - (k - i) - 1][k + 1][j + k - i])) {
                            dp[len][i][j] = true;
                            who[len][i][j] = k;
                        }
                    }
                }
            }
        }
    }
    if (dp[n][0][0]) {
        cout << "YES\n";
        string ans = rec(n, 0, 0);
        cout << ans << "\n";
    } else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
    return 0;
}
