#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

int mod;

void add(int &a, int b) {
	a += b;
	if (a >= mod)
		a -= mod;
}

void solve() {
	int n, p;
	cin >> n >> p >> mod;
	int S = n - p;
	vector<vector<vector<int>>> dp(S + 1, vector<vector<int>>(2 * n + 1, vector<int>(S + 1)));
	dp[0][p][0] = 1;
	for (int sum = 0; sum <= S; sum++) {
		for (int x = 0; x <= 2 * n; x++) {
			for (int last = 0; last <= S; last++) {
				if (!dp[sum][x][last])
					continue;
				int cur = dp[sum][x][last];
				if (sum + last <= S)
					add(dp[sum + last][x ^ last][last], cur);
				if (last < S)
					add(dp[sum][x][last + 1], cur);
			}
		}
	}
	cout << dp[S][0][S] << "\n";
}

int main() {
	int T = 1;
	// cin >> T;
	while (T--) {
		solve();
	}

	return 0;
}