#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e5 + 10;

bool check(const pair<ll, ll> &q, const pair<ll, ll> p) {
    return q.first == p.first || q.second == p.second || abs(q.second - q.first) == abs(p.second - p.first);
}

const ll INF = 1e9;

bool check_border(const pair<ll, ll> &p) {
    return -INF <= p.first && p.first <= INF && -INF <= p.second && p.second <= INF;
}

int main() {
    int t;
    cin >> t;
    vector<pair<ll, ll>> q(MAX_N);
    vector<pair<ll, ll>> points(100);
    vector<bool> flags(100, true);
    for (int tt = 0; tt < t; ++tt) {
        int n;
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> q[i].first >> q[i].second;
        }
        bool flag = true;
        int idx = 0;
        for (int i = 0; i < n; ++i) {
            if (!check(q[0], q[i])) {
                flag = false;
                idx = i;
                break;
            }
        }
        if (flag) {
            cout << "YES\n";
            cout << q[0].first << ' ' << q[0].second << endl;
            continue;
        }
        int cnt = 0;
        points[0] = make_pair(q[0].first, q[idx].second);
        points[1] = make_pair(q[idx].first, q[0].second);
        cnt += 2;
        ll dx = abs(q[0].first - q[idx].first), dy = abs(q[0].second - q[idx].second);
        ll x = q[0].first, y = q[idx].second + dx;
        points[2] = make_pair(x, y);
        y -= 2 * dx;
        points[3] = make_pair(x, y);
        x = q[idx].first;
        y = q[0].second + dx;
        points[4] = make_pair(x, y);
        y -= 2 * dx;
        points[5] = make_pair(x, y);
        cnt += 4;
        y = q[0].second;
        x = q[idx].first + dy;
        points[6] = make_pair(x, y);
        x -= 2 * dy;
        points[7] = make_pair(x, y);
        y = q[idx].second;
        x = q[0].first + dy;
        points[8] = make_pair(x, y);
        x -= 2 * dy;
        points[9] = make_pair(x, y);
        cnt += 4;
        ll d = (dx + dy) / 2, t = abs(dx - dy) / 2;
        for (auto dx0 : {-d, d, -t, t}) {
            for (auto dy0 : {-t, t, -d, d}) {
                for (auto x0 : {q[0].first, q[idx].first}) {
                    for (auto y0 : {q[0].second, q[idx].second}) {
                        points[cnt] = make_pair(x0 + dx0, y0 + dy0);
                        cnt++;
                    }
                }
            }
        }
        for (int i = 0; i < cnt; ++i) {
            flags[i] = check_border(points[i]) && check(q[0], points[i]);
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < cnt; ++j) {
                if (!check(q[i], points[j])) {
                    flags[j] = false;
                }
            }
        }
        bool outed = false;
        for (int i = 0; i < cnt; ++i) {
            if (flags[i]) {
                outed = true;
                cout << "YES\n";
                cout << points[i].first << ' ' << points[i].second << '\n';
                break;
            }
        }
        if (!outed) {
            cout << "NO" << endl;
        }
    }
    return 0;
}
