#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAX_N = 128;

bool dp[MAX_N][MAX_N][MAX_N];
int pr[MAX_N][MAX_N][MAX_N];

void get_ans(int len, int bega, int begb, deque<char> &d) {
    if (len == 0) {
        return;
    }
    if (pr[len][bega][begb] == 0) {
        get_ans(len - 1, bega + 1, begb, d);
        d.push_front('S');
        d.push_back('C');
        return;
    }
    int sublen = pr[len][bega][begb];
    deque<char> tmp;
    get_ans(sublen, bega, begb, d);
    get_ans(len - sublen, bega + sublen, begb + sublen, tmp);
    for (auto ch : tmp) {
        d.push_back(ch);
    }
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int bega = 0; bega <= n; ++bega) {
        for (int begb = 0; begb <= n; ++begb) {
            dp[0][bega][begb] = true;
        }
    }
    for (int len = 1; len <= n; ++len) {
        for (int bega = 0; bega + len <= n; ++bega) {
            for (int begb = 0; begb + len <= n; ++begb) {
                if (a[bega] == b[begb + len - 1]) {
                    dp[len][bega][begb] |= dp[len - 1][bega + 1][begb];
                    if (dp[len - 1][bega + 1][begb]) {
                        pr[len][bega][begb] = 0;
                    }
                }
                for (int sublen = 1; sublen < len; ++sublen) {
                    dp[len][bega][begb] |= (dp[sublen][bega][begb] & dp[len - sublen][bega + sublen][begb + sublen]);
                    if (dp[sublen][bega][begb] & dp[len - sublen][bega + sublen][begb + sublen]) {
                        pr[len][bega][begb] = sublen;
                        break;
                    }
                }
            }
        }
    }
    if (!dp[n][0][0]) {
        cout << "NO\n";
        return 0;
    }
    cout << "YES\n";
    deque<char> d;
    get_ans(n, 0, 0, d);
    for (auto ch : d) {
        cout << ch;
    }
    return 0;
}
