#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include <set>

using namespace std;

#define int long long

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
	for (auto& e : v)
	{
		in >> e;
	}
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
	for (auto& e : v)
	{
		out << e << " ";
	}
	return out;
}

const int INF = 1e18;
set<pair<int, int>> seg;
int cc;
int n;
int last_res;
int ask(int l, int r) {
	assert(++cc < 2500);
	cout << l << " " << r << endl;
	int k;
	cin >> k;
	return k;
	//cout << l << " " << r << "\n";
	if (seg.count({ l, r })) {
		seg.erase({ l, r });
	}
	else {
		seg.insert({ l, r });
	}
	int c = 0;
	for (int i = 1; i <= n; ++i) {
		bool f = 1;
		for (auto& e : seg) if (e.first <= i && i <= e.second) {
			f = 0;
			break;
		}
		c += f;
	}
	return c;
}

vector<string> gen(int k) {
	if (k == 1) {
		return { "0", "1" };
	}
	auto v = gen(k - 1);
	auto r = v;
	for (auto& e : r) e.push_back('0');
	reverse(v.begin(), v.end());
	for (auto& e : v) e.push_back('1'), r.push_back(e);
	return r;
}

void solve_n(int k) {
	int p = n - k + 1;
	auto r = gen(k);
	bool sw = 0;
	vector<int> g(r.size());
	g[0] = last_res;
	if (g[0] == n) return;
	if (g[0] > p) {
		g[0] = ask(1, k - 1);
		sw = 1;
		if (g[0] == n) return;
	}
	int cnt1 = g[0] == p;
	int cnt1_pos = g[0] == p ? 0 : -1;
	for (int i = 1; i < r.size(); ++i) {
		for (int j = 0; j < k; ++j) {
			if (r[i][j] != r[i - 1][j]) {
				g[i] = ask(k - j, k);
				break;
			}
		}
		if (g[i] == n) return;
		bool flip = 0;
		if (g[i] > p || (g[i] == p && cnt1)) {
			flip = 1;
			if (!sw) {
				g[i] = ask(1, k - 1);
				sw = 1;
			}
			if (g[i] == n) return;
		}
		if (g[i] >= p) {
			cnt1 = 1;
			cnt1_pos = i;
		}
	}
	assert(cnt1);
	vector<int> neq;
	for (int j = 0; j < k; ++j) {
		if (r.back()[j] != r[cnt1_pos][j]) {
			neq.push_back(k - j);
		}
	}
	for (int j = 0; j < neq.size(); ++j) {
		last_res = ask(neq[j], k);
	}
	solve_n(k - 1);
}

void solve()
{
	cin >> n;
	cin >> last_res;
	/*
	while (1) {
		cc = 0;
		n = 5;
		seg.clear();
		for (int i = 1; i <= n; ++i) {
			for (int j = i; j <= n; ++j) {
				if (rand() & 1) seg.insert({ i, j });
			}
		}
		cout << "!";
		auto ss = seg;
		last_res = ask(-1, -1);
		solve_n(n);
	}*/
	solve_n(n);
}

signed main()
{
	/*ios_base::sync_with_stdio(false);
	cin.tie(0);*/

#ifdef LOCAL
	cerr << "Ready" << endl;
#endif
	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}
}
