#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<int> > vvi;

#define forn(i, n) for (int (i) = 0; (i) != (n); (i)++)

template<typename T>
istream& operator>>(istream& in, vector<T>& v)
{
    for (auto& e : v)
    {
        in >> e;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
    for (auto& e : v)
    {
        out << e << " ";
    }
    return out;
}

void solve()
{
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    vector<pair<int, int> > x;
    cin >> a >> b;
    forn(i, n) x.push_back({a[i], 1});
    forn(i, n) x.push_back({b[i], 2});
    sort(x.begin(), x.end());

    int maxLeft = 0;
    int cnt = 0;
    for (int i = 0; i < 2 * n; i++)
    {
        if (x[i].second == 2)
        {
            cnt++;
        }
        else
        {
            if (cnt) maxLeft++, cnt--;
        }
    }

    int maxRight = 0;
    cnt = 0;
    for (int i = 2 * n - 1; i >= 0; i--)
    {
        if (x[i].second == 2)
        {
            cnt++;
        }
        else
        {
            if (cnt) maxRight++, cnt--;
        }
    }

    cout << maxLeft - (n - maxRight) + 1 << "\n";
    for (int i = n - maxRight; i <= maxLeft; i++) cout << i << " ";
    cout << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    cerr << "Ready" << endl;
    #endif

    int t = 1;
    while (t--)
    {
        solve();
    }
}