#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef vector<ll> vi;
ll n;

vector<ll> grey(vector<ll> acc) {
    for (int i = 0; i < n; ++i) {
        vector<ll> rev = acc;
        reverse(rev.begin(), rev.end());
        for (auto &j: rev) {
            j += (1 << i);
        }
        acc.insert(acc.end(), rev.begin(), rev.end());
    }
    return acc;
}

ll get() {
    ll k;
    cin >> k;
    if (k == n) {
        exit(0);
    }
    return k;
}

void send(ll a, ll b) {
    cout << a << ' ' << b << endl;
}

ll get_bit(ll x, ll k) {
    return (x >> k) & 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n;
    vi gr = grey({0});
    /*for (auto i: gr) {
        cout << i << endl;
    }*/
    ll k, mem;
    mem = get();
    for (ll i = 1; i <= n; i++) {
        send(i, i);
        mem = get();
        send(i, i);
        k = get();
        if (k == mem + 1) {
            continue;
        }
        if (k == mem - 1) {
            send(i, i);
            k = get();
            assert(k == mem);
            continue;
        }
        for (int j = 1; j < gr.size(); ++j) {
            ll pos = -1;
            for (ll q = 0; q < n; q++) {
                if (get_bit(gr[j], q) ^ get_bit(gr[j-1], q)) {
                    pos = q;
                    break;
                }
            }
            assert(pos != -1);
            send(i, pos + i);
            k = get();
            if (k == mem + 1) {
                break;
            }
        }
    }
    return 0;
}

