//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>

#define forn(i, st, fi) for (int i = (st); i < (fi); ++i)
#define fornr(i, st, fi) for (int i = (st); i >= (fi); --i)
#define vc vector
#define vi vector<int>
#define vll vector<long long>

using namespace std;
typedef long long ll;
typedef long double ld;
constexpr int INF = 1e9;
constexpr ll ll_INF = 1e18;
constexpr ld eps = 1e-9;
const ld pi = acos(-1);

template<typename T>
ostream &operator<<(ostream &out, vc<T> vector1) {
    for (auto &&elem: vector1) {
        out << elem << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vc<T> &vector1) {
    for (auto &&elem: vector1) {
        in >> elem;
    }
    return in;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> queens(n);
    for (int i = 0; i < n; ++i) {
        cin >> queens[i].first >> queens[i].second;
    }
    // 0 ox, 1 oy, 2 main diag, 3 not main diag
    for (int p = 0; p < 4; ++p) {
        bool is_napr = true;
        vector<pair<int, int>> points;
        for (int i = 1; i < n; ++i) {
            if (p == 0 && queens[0].second == queens[i].second) continue;
            if (p == 1 && queens[0].first == queens[i].first) continue;
            if (p == 2 && (queens[0].first - queens[0].second) == (queens[i].first - queens[i].second)) continue;
            if (p == 3 && (queens[0].first + queens[0].second) == (queens[i].first + queens[i].second)) continue;
            if (is_napr) {
                is_napr = false;
                for (int q = 0; q < 4; q++) {
                    if (p == 0 && q == 1) {
                        points.emplace_back(queens[i].first, queens[0].second);
                    }
                    if (p == 0 && q == 2) {
                        points.emplace_back(queens[i].first - queens[i].second + queens[0].second, queens[0].second);
                    }
                    if (p == 0 && q == 3) {
                        points.emplace_back(queens[i].first + queens[i].second - queens[0].second, queens[0].second);
                    }

                    if (p == 1 && q == 0) {
                        points.emplace_back(queens[0].first, queens[i].second);
                    }
                    if (p == 1 && q == 2) {
                        points.emplace_back(queens[0].first, -queens[i].first + queens[i].second + queens[0].first);
                    }
                    if (p == 1 && q == 3) {
                        points.emplace_back(queens[0].first, queens[i].first + queens[i].second - queens[0].first);
                    }

                    if (p == 2 && q == 0) {
                        points.emplace_back(queens[0].first - queens[0].second + queens[i].second, queens[i].second);
                    }
                    if (p == 2 && q == 1) {
                        points.emplace_back(queens[i].first, -queens[0].first + queens[0].second + queens[i].first);
                    }
                    if (p == 2 && q == 3) {
                        if ((queens[i].first + queens[i].second - queens[0].first + queens[0].second) % 2 == 0) {
                            points.emplace_back(queens[0].first - queens[0].second +
                                                (queens[i].first + queens[i].second - queens[0].first +
                                                 queens[0].second) / 2,
                                                (queens[i].first + queens[i].second - queens[0].first +
                                                 queens[0].second) / 2);
                        }
                    }

                    if (p == 3 && q == 0) {
                        points.emplace_back(queens[0].first + queens[0].second - queens[i].second, queens[i].second);
                    }
                    if (p == 3 && q == 1) {
                        points.emplace_back(queens[i].first, queens[0].first + queens[0].second - queens[i].first);
                    }
                    if (p == 3 && q == 2) {
                        if ((queens[0].first + queens[0].second - queens[i].first + queens[i].second) % 2 == 0) {
                            points.emplace_back(queens[i].first - queens[i].second +
                                                (queens[0].first + queens[0].second - queens[i].first +
                                                 queens[i].second) / 2,
                                                (queens[0].first + queens[0].second - queens[i].first +
                                                 queens[i].second) / 2);
                        }
                    }
                }
            } else {
                vector<pair<int, int>> tmp;
                for (auto [x, y]: points) {
                    if (x == queens[i].first || y == queens[i].second ||
                        abs(x - queens[i].first) == abs(y - queens[i].second)) {
                        tmp.emplace_back(x, y);
                    }
                }
                points = tmp;
                if (tmp.empty()) break;
            }

        }
        if (is_napr) {
            cout << "YES\n" << queens[0].first << " " << queens[0].second << "\n";
            return;
        }
        if (!points.empty()) {
            cout << "YES\n" << points[0].first << " " << points[0].second << "\n";
            return;
        }
    }
    cout << "NO\n";
}


signed main() {
    int t = 1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    cout << fixed;
//    cout << setprecision(10);
    cin >> t;
    while (t--) {
        solve();
    }
}