//
// Created by qf on 05.11.2023.
//
#include <bits/stdc++.h>

#define forn(i, st, fi) for (int i = (st); i < (fi); ++i)
#define fornr(i, st, fi) for (int i = (st); i >= (fi); --i)
#define vc vector
#define vi vector<int>
#define vll vector<long long>

using namespace std;
typedef long long ll;
typedef long double ld;
constexpr int INF = 1e9;
constexpr ll ll_INF = 1e18;
constexpr ld eps = 1e-9;
const ld pi = acos(-1);

template<typename T>
ostream &operator<<(ostream &out, vc<T> vector1) {
    for (auto &&elem: vector1) {
        out << elem << " ";
    }
    return out;
}

template<typename T>
istream &operator>>(istream &in, vc<T> &vector1) {
    for (auto &&elem: vector1) {
        in >> elem;
    }
    return in;
}

void solve() {
    int n, p, m;
    cin >> n >> p >> m;
    vc<vi> dp(n, vi(n, 0));
    forn(i, 0, n) dp[i][i] = 1;
    forn(i, 0, n) {
        forn(j, 0, n) {
            for(int k = 1; k < (i + 1) / 2; k++) {
                dp[i][j] = (dp[i][j] + dp[i - k][j ^ k]) % m;
            }
        }
    }
    cout << dp[n - p][p];
}


signed main() {
    int t = 1;
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
//    cout << fixed;
//    cout << setprecision(10);
//    cin >> t;
    while (t--) {
        solve();
    }
}