#include <iostream>
#include <vector>
#include <string>
#include <cstdint>
#include <utility>

using namespace std;



int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }

    int cur_pos = 0;
    vector<int> r(n);
    for (int i = 0; i < n; ++i) {
        while ((cur_pos < n) && (a[i] > b[cur_pos])) {
            cur_pos += 1;
        }
        r[i] = cur_pos;
    }

    int cur_max = n;
    int left = 0;
    while (left < cur_max && left < n) {
        cur_max = min(cur_max, n-r[left]+left);
        if (left >= cur_max) {
            break;
        }
        left++;
    }

    if (left >= cur_max) {
        left -= 1;
    }


    cur_max = n;
    int right = n-1;
    while ((right >= n-cur_max) && (right >= 0)) {
        cur_max = min(cur_max, r[right]+n-1-right);
        //cout << cur_max << endl;
        if (right < n-cur_max) {
            break;
        }
        right--;
    }
    if (right < n - cur_max) {
        right += 1;
    }
//    for (int i = 0; i < n; ++i) {
//        cout << r[i] << ' ';
//    }
//    cout << endl;
    //cout << left << ' ' << right << endl;

    left = n - 1 - left;
    right = n - right;

    //cout << left << ' ' << right << endl;

    if (left > right) {
        cout << 0 << endl;
        cout << endl;
    }
    else {
        cout << right - left + 1 << '\n';
        for (int i = left; i <= right; ++i) {
            cout << i << ' ';
        }
        cout << '\n';
    }

    return 0;
}