#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define vi vector<int>
#define vl vector<ll>
#define vvi vector<vi>
#define vvl vector<vl>
#define fi first
#define se second

// g++ -O2 -std=c++17 -Wall, --stack=67108864 .cpp
int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n; cin >> n;
	vi a(n), b(n);
	for(auto &x : a) cin >> x;
	for(auto &x : b) cin >> x;


	vector <int> left(n, 0);
	vector <int> right(n, 0);
	int curr_b = 0;
	for(int i = 0; i < n; i++){
		while(curr_b < n && b[curr_b] < a[i])
			curr_b++;

		left[i] = curr_b;
		right[i] = n - curr_b;
	}

	vector<int> can_left(n+1, 0), can_right(n+1, 0);
	can_left[0] = 1;

	int INF = 2 * int(1e9);

	// считаем can_left
	int curr_min = INF;
	for(int i = 1; i <= n; i++){
		curr_min = min(curr_min - 1, right[i-1] - 1);
		if(curr_min >= 0)
			can_left[i] = 1;
		else
			can_left[i] = 0;
	}

	// считаем can_right
	can_right[0] = 1;
	curr_min = INF;
	for(int i = 1; i <= n; i++){
		curr_min = min(curr_min - 1, left[n-i] - 1);
		if(curr_min >= 0)
			can_right[i] = 1;
		else
			can_right[i] = 0;
	}

	// for(auto x : left)
	// 	cout << x << ' ';
	// cout << '\n';

	// for(auto x : right)
	// 	cout << x << ' ';
	// cout << '\n';

	// for(auto x : can_left)
	// 	cout << x << ' ';
	// cout << '\n';

	// for(auto x : can_right)
	// 	cout << x << ' ';
	// cout << '\n';

	vector <int> ans;
	for(int i = 0; i <= n; i++){
		if(can_left[i] && can_right[n-i])
			ans.push_back(i);
	}

	int ans_len = ans.size();
	cout << ans_len << '\n';
	for(int i = ans_len - 1; i >= 0; i--)
		cout << n - ans[i] << ' ';
	cout << '\n';

	return 0;
}