#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define f first
#define s second
#define eb emplace_back
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

typedef tree<
        pair <int, int>,
        null_type,
        less <>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int dp[1500][1500];

int d;
vector <vector <int>> state;
vector <vector <pair <int, pair <int, int>>>> pr;

void bfs(){
    queue <pair <int, int>> q;
    for (int i = 1; i < 10; i++){
        state[i % d][i % d] = 1;
        pr[i % d][i % d] = {i, {-1, -1}};
        q.push({i % d, i % d});
    }

    while (!q.empty()){
        auto cur = q.front();
        q.pop();

        for (int i = 0; i < 10; i++){
            pair <int, int> new_pair = {(cur.first + i) % d, (cur.second * 10 + i) % d};
            if (state[new_pair.first][new_pair.second] == 0){
                q.push(new_pair);
                state[new_pair.first][new_pair.second] = 1;
                pr[new_pair.first][new_pair.second] = {i, cur};
            }
        }
    }

}

void solve(){
    cin >> d;
    state.assign(d, vector <int> (d));
    pr.assign(d, vector <pair <int, pair <int, int>>> (d, {-1, {-1, -1}}));

    bfs();

    pair <int, pair <int, int>> cur = pr[0][0];
    vector <int> ans;
    while (cur.second != make_pair(-1LL, -1LL)) {
        ans.emplace_back(cur.first);
        cur = pr[cur.second.first][cur.second.second];
    };
    ans.emplace_back(cur.first);

    reverse(ans.begin(), ans.end());

    for (auto i: ans){
        cout << i;
    }
    cout << '\n';
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int ttt = 1;
    // cin >> ttt;
    while (ttt--){
        solve();
    }

    return 0;
}
