#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define f first
#define s second
#define eb emplace_back
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

typedef tree<
        pair <int, int>,
        null_type,
        less <>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());


void solve(){
    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> b(n);
    vector <vector <int>> next(n + 1, vector <int> (n + 1));

    for (int i = 0; i < n; i++){
        cin >> a[i];
    }

    for (int i = 0; i < n; i++){
        cin >> b[i];
    }

    for (int i = (int)n - 1; i >= 0; i--){
        for (int j = 0; j < n; j++){
            next[i] = next[i + 1];
        }

        next[i][a[i]] = 1;
    }

    string ans = "";
    stack <int> st;
    int id = 0;
    for (int i = 0; i < n; i++){
        if (id == n){
            break;
        }

        ans += 'S';
        st.push(a[i]);

        while (id != n && !st.empty() && st.top() == b[id]){
            st.pop();
            ans += 'C';
            if (next[i + 1][b[id]] == 0){
                id++;
            }
        }
    }

    if (st.empty()){
        cout << "YES" << '\n';
        cout << ans << '\n';
    } else {
        cout << "NO" << '\n';
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int ttt = 1;
//    cin >> ttt;
    while (ttt--){
        solve();
    }

    return 0;
}
