#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>

//#define int long long
#define f first
#define s second
#define eb emplace_back
#define pb push_back

using namespace __gnu_pbds;
using namespace std;

typedef tree<
        pair <int, int>,
        null_type,
        less <>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int INF = 1e9 + 7;

vector <int> hamilton(int n) {
    vector <int> a = {0, 1};
    for (int i = 2; i <= n; i++) {
        vector <int> b = a;
        for (int j = (int)a.size() - 1; j >= 0; j--) {
            b.push_back((1 << (i - 1)) + a[j]);
        }
        a = b;
    }
    return a;
}

void solve(){
    int n;
    cin >> n;
    int cur;
    cin >> cur;
    for (int i = 0; i < n; i++){
        vector <int> a = hamilton(n - i - 1);
        vector<int> pos;
        for (int j = 1; j < (int)a.size(); j++) {
            pos.push_back(__lg(a[j] ^ a[j - 1]) + 1);
        }
        bool f1 = 0;
        for (auto it : pos) {
            cout << i + 1 << ' ' << i + 1 << endl;
            int newCur;
            cin >> newCur;
            if (newCur == n) {
                return;
            }
            if (abs(newCur - cur) == 1) {
				cur = newCur;
                break;
            }
            cout << i + 1 << ' ' << i + 1 + it << endl;
            cin >> cur;
            if (cur == n) {
                return;
            }
        }
        cout << i + 1 << ' ' << i + 1 << endl;
        int nc;
        cin >> nc;
        if (nc > cur) {
            cur = nc;
            }
        else {
            cout << i + 1 << ' ' << i + 1 << endl;
            cin >> cur;
        }
        if (cur == n)
            return;
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);


    int ttt = 1;
    // cin >> ttt;
    while (ttt--){
        solve();
    }
    return 0;
}