#include <bits/stdc++.h>

#define pb push_back
#define ll int64_t
#define int ll
#define F first
#define S second
#define pii pair<int, int>
#define graph vector<vector<int>>
#define graph_w vector<vector<pii>>

#ifndef OlegSanders
#define cerr if (0) cerr
#endif

using namespace std;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

unordered_map<int,int> d1,rd1,d2,rd2;


bool fun(string &s, string &t) {
    int j = 0;
    for (int i = 0; i < t.size() && j < s.size(); i++) {
        if (t[i] == s[j])j++;
    }
    return s.size() == j;
}

bool pass (pii &a,pii &b) {
    bool st = false;
    if ((a.F + a.S) % 2 == (b.F + b.S) % 2) {
        if ((a.F + a.S) % 2 == 0)
            st |= d1[a.F + a.S] == d1[b.F + b.S] || rd1[a.F - a.S] == rd1[b.F - b.S];
        else
            st |= d2[a.F + a.S] == d2[a.F + a.S] || rd2[a.F - a.S] == rd2[b.F - b.S];
    }
    return st || a.F == b.F || a.S == b.S;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(10);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        bool permit = true;
        int n;
        cin >> n;

        vector<pii> a(n);
        for (int i = 0;i < n;i++) cin >> a[i].first >> a[i].second;

        int x1 = a[0].F;
        int y1 = a[0].S;

        vector<pii> arr;
        for (int i = 1;i < n;i++) {
            int x = a[i].F;
            int y = a[i].S;
            if (abs(x - x1) == abs(y - y1) || x == x1 || y == y1) continue;
            //cout << x << " " << y << endl;
            pii t;
            if ((x1 - y1 + x + y) % 2 == 0) {
                t.F = (x1 - y1 + x + y) / 2;
                t.S = (y1 - x1 + x + y) / 2;
                arr.push_back(t);
                t.F = (x1 + y1 + x - y) / 2;
                t.S = (x1 + y1 + y - x) / 2;
                arr.push_back(t);
            }
            t.F = x1;
            t.S = x1 - x + y;
            arr.push_back(t);
            t.F = x1;
            t.S = x - x1 + y;
            arr.push_back(t);
            t.F = x - y1 + y;
            t.S = y1;
            arr.push_back(t);
            t.F = x + y1 - y;
            t.S = y1;
            arr.push_back(t);
            t.F = x;
            t.S = x - x1 + y1;
            arr.push_back(t);
            t.F = x;
            t.S = x1 - x + y1;
            arr.push_back(t);
            t.F = x1 - y + y1;
            t.S = y;
            arr.push_back(t);
            t.F = x1 + y - y1;
            t.S = y;
            arr.push_back(t);
            t.F = x1;
            t.S = y;
            arr.push_back(t);
            t.F = x;
            t.S = y1;
            arr.push_back(t);
            for (auto it : arr) {
                //cout << "( " << it.F << " " << it.S << " ) ";
                for (int j = 0; j < n; j++) {
                    if (!(abs(a[j].F - it.F) == abs(a[j].S - it.S) || a[j].F == it.F || a[j].S == it.S)) {
                        break;
                    }
                    if (j == n - 1) {
                        if (permit) {
                            cout << "YES" << endl << it.F << " " << it.S << endl;
                        }
                        permit = false;
                    }
                }
            }
            //cout << endl;
            if (permit) {
                cout << "NO" << endl;
            }
            permit = false;
            break;
        }
        if (permit) {
            cout << "YES" << endl << x1 << " " << y1 << endl;
        }
        permit = false;
    }
}
