#include <bits/stdc++.h>

#define pb push_back
#define ll int64_t
#define int ll
#define F first
#define S second
#define pii pair<int, int>
#define graph vector<vector<int>>
#define graph_w vector<vector<pii>>

#ifndef OlegSanders
#define cerr if (0) cerr
#endif

using namespace std;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

unordered_map<int,int> d1,rd1,d2,rd2;


bool fun(string &s, string &t) {
    int j = 0;
    for (int i = 0; i < t.size() && j < s.size(); i++) {
        if (t[i] == s[j])j++;
    }
    return s.size() == j;
}

bool pass (pii &a,pii &b) {
    bool st = false;
    if ((a.F + a.S) % 2 == (b.F + b.S) % 2) {
        if ((a.F + a.S) % 2 == 0)
            st |= d1[a.F + a.S] == d1[b.F + b.S] || rd1[a.F - a.S] == rd1[b.F - b.S];
        else
            st |= d2[a.F + a.S] == d2[a.F + a.S] || rd2[a.F - a.S] == rd2[b.F - b.S];
    }
    return st || a.F == b.F || a.S == b.S;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(10);
#ifdef OlegSanders
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;

    vector<vector<vector<int>>> a(11);
    // a[size][dig][pos]
    vector<vector<int>> b(11);

    for (int i = 1;i <= 10;i++) {
        a[i].resize(i);
        for (int j = 0;j < i;j++) a[i][j].resize(1 << i);

        for (int j = 0;j < i - 1;j++) {
            for (int k = 0;k < (1 << (i - 1));k++) a[i][j][k] = a[i - 1][j][k];
            for (int k = 0;k < (1 << (i - 1));k++) a[i][j][k + (1 << (i - 1))] = a[i - 1][j][(1 << (i - 1)) - 1 - k];
        }

        for (int k = 0;k < (1 << (i - 1));k++) a[i].back()[k] = 0;
        for (int k = 0;k < (1 << (i - 1));k++) a[i].back()[k + (1 << (i - 1))] = 1;
    }

    for (int i = 1;i <= 10;i++) {
        for (int k = 0;k < (1 << i);k++) {
            int s = 0;
            for (int j = 0;j < i;j++) if (a[i][j][k]) s += (1 << j);
            b[i].push_back(s);
        }
    }

    int c;
    cin >> c;
    int t;
    int ans = c;
    if (c == n) return 0;
    for (int i = n;i > 0;i--) {
        t = 0;
        for (int j = 1;j < b[i].size();j++) {
            for (int k = 0;k < i;k++) {
                if ((b[i][j - 1] & (1 << k)) != (b[i][j] & (1 << k))) {
                    cout << k + 1 << " " << i << endl;
                    cin >> c;
                    if (c == n) return 0;
                    if (c > ans) {
                        ans = c;
                        t = b[i][j];
                    }
                    break;
                }
            }
        }

        if (t != b[i].back()) {
            for (int k = 0;k < i;k++) {
                if ((b[i].back() & (1 << k)) != (b[i][t] & (1 << k))) {
                    cout << k + 1 << " " << i << endl;
                    cin >> c;
                    if (c == n) return 0;
                }
            }
        }
    }
}
