#include <bits/stdc++.h>

#define pb push_back
#define ll int64_t
#define int ll
#define F first
#define S second
#define pii pair<int, int>
#define graph vector<vector<int>>
#define graph_w vector<vector<pii>>

#ifndef OlegSanders
#define cerr if (0) cerr
#endif

using namespace std;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(10);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string s, t;
    cin >> s >> t;
    int n = s.size();
    int m = t.size();
    for (int i = 0; i < n; i++) {
        s[i] = tolower(s[i]);
    }
    for (int i = 0; i < m; i++) {
        t[i] = tolower(t[i]);
    }
    string a = "";
    string b = "";
    set<char> glas{'a', 'o', 'i', 'e', 'y', 'u'};
    for (int i = 0; i < s.size(); i++) {
        if (glas.find(s[i]) == glas.end()) {
            a += s[i];
        }
    }
    for (int i = 0; i < t.size(); i++) {
        if (glas.find(t[i]) == glas.end()) {
            b += t[i];
        }
    }

    vector<vector<int>> dp(n,vector<int>(m));
//    cout << a << endl << b << endl;
    vector<int> mos;
    mos.resize(10, -1);
    dp[0][0] = s[0] == t[0];
    for (int i = 1;i < n;i++) dp[i][0] = dp[i - 1][0] + s[i] == t[0];
    for (int i = 1;i < m;i++) dp[0][i] = dp[0][i - 1] + s[0] == t[i];
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < m; j++) {
            if (s[i] == t[j]) dp[i][j] = max(dp[i][j],dp[i - 1][j - 1] + 1);
            dp[i][j] = max(dp[i][j],max(dp[i - 1][j],dp[i][j - 1]));
        }
    }

    int ans = 0;
    for (int i = 0;i < n;i++) {
        for (int j = 0;j < m;j++) ans = max(ans,dp[i][j]);
    }
    if (s.size() != ans || a.size() != b.size()) cout << "Different";
    else cout << "Same";
    //    vector<string> gla{""};
//    vector<string> glb{""};
//    for (int i = 0; i < s.size(); i++) {
//        if (glas.find(s[i]) != glas.end()) {
//            gla.back() += s[i];
//        } else {
//            gla.pb("");
//        }
//    }
//    for (int i = 0; i < t.size(); i++) {
//        if (glas.find(t[i]) != glas.end()) {
//            glb.back() += t[i];
//        } else {
//            glb.pb("");
//        }
//    }
    cout << endl;
}
