#include <bits/stdc++.h>

#define pb push_back
#define ll int64_t
#define int ll
#define F first
#define S second
#define pii pair<int, int>
#define graph vector<vector<int>>
#define graph_w vector<vector<pii>>

#ifndef OlegSanders
#define cerr if (0) cerr
#endif

using namespace std;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

bool fun(string &s, string &t) {
    int j = 0;
    for (int i = 0; i < t.size() && j < s.size(); i++) {
        if (t[i] == s[j])j++;
    }
    return s.size() == j;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(10);
#ifdef OlegSanders
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string s, t;
    cin >> s >> t;
    int n = s.size();
    int m = t.size();
    for (int i = 0; i < n; i++) {
        s[i] = tolower(s[i]);
    }
    for (int i = 0; i < m; i++) {
        t[i] = tolower(t[i]);
    }
    string a = "";
    string b = "";
    set<char> glas{'a', 'o', 'i', 'e', 'y', 'u'};
    set<int> st;
    for (int i = 0; i < s.size(); i++) {
        if (glas.find(s[i]) == glas.end()) {
            a += s[i];
        } else {
            st.insert(a.size());
        }
    }
    for (int i = 0; i < t.size(); i++) {
        if (glas.find(t[i]) == glas.end()) {
            b += t[i];
        } else {
            st.insert(b.size());
        }
    }

    int sz = 0;
    st.insert((n + m));
    auto k1 = st.begin();

    vector<string> gas{""};
    vector<string> gat{""};

    for (int i = 0; i < s.size(); i++) {
        if (glas.find(s[i]) == glas.end()) {
            sz++;
        } else {
            if (sz <= (*k1)) {
                gas.back() += s[i];
            } else {
                k1++;
                i--;
                gas.pb("");
                continue;
            }
        }
    }
    sz = 0;
    k1 = st.begin();
    for (int i = 0; i < t.size(); i++) {
        if (glas.find(t[i]) == glas.end()) {
            sz++;
        } else {
            if (sz <= (*k1)) {
                gat.back() += t[i];
            } else {
                k1++;
                i--;
                gat.pb("");
                continue;
            }
        }
    }

//    for (auto to:st) {
//        cout << to << endl;
//    }

//    for (auto to:gas) {
//        cout << "\"" << to << "\"" << ' ';
//    }cout << endl;
//
//    for (auto to:gat) {
//        cout << "\"" << to << "\"" << ' ';
//    }cout << endl;

    if (a != b) {
        cout << "Different" << endl;
        return 0;
    }

    int ans = 1;

    if (gas.size() != gat.size()) {
        gat.resize(max(gat.size(),gas.size()),"");
        gas.resize(max(gat.size(),gas.size()),"");
    }

    for (int i = 0; i < gas.size(); i++) {
        ans &= fun(gas[i], gat[i]);
    }

    if (ans) {
        cout << "Same";
    }
    else {
        cout << "Different" << endl;
        return 0;
    }

    cout << endl;
}
