#include <bits/stdc++.h>

const int N = 110;

int a[N], b[N];
bool dp[N][N][N]; // len, l, i
int par[N][N][N];
// false -> remove left

bool solve(int n) {
	memset(dp, false, sizeof(dp));
	memset(par, -1, sizeof(par));

	for (int l = 0; l < n; ++l) {
		for (int i = 0; i < n; ++i) {
			if (a[l] == b[i]) {
				dp[1][l][i] = true;
			}
		}
	}

	for (int len = 2; len <= n; ++len) {
		for (int l = 0; l + len - 1 < n; ++l) {
			for (int i = 0; i + len - 1 < n; ++i) {
				int r = l + len - 1;
				int j = i + len - 1;

				for (int maxPosition = l; maxPosition <= r; ++maxPosition) {
					if (a[maxPosition] != b[j]) {
						continue;
					}

					// x = maxPosition
					// p_x = j
					int lenL = maxPosition - l;
					int lenR = len - lenL - 1;
					bool ok = true;
					ok &= (maxPosition == l || dp[lenL][l][i]);
					ok &= (maxPosition == r || dp[lenR][maxPosition + 1][i + maxPosition - l]);

					if (ok) {
						dp[len][l][i] = true;
						par[len][l][i] = maxPosition;
						break;
					}
				}
			}
		}
	}

	return dp[n][0][0];
}

std::vector<int> p;

void restore(int n, int l, int i) {
	//std::cout << n << ' ' << l << ' ' << i << std::endl;
	int curP = par[n][l][i];
	assert(curP != -1 || n == 1);
	if (n == 1) {
		curP = l;
	}
	p[curP] = i + n - 1;

	if (curP != l) {
		restore(curP - l, l, i);
	}
	if (curP != l + n - 1) {
		restore(n - (curP - l) - 1, curP + 1, i + curP - l);
	}
}

int main(void) {
	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	for (int i = 0; i < n; ++i) {
		scanf("%d", &b[i]);
	}

	if (solve(n)) {
		printf("YES\n");
		p.resize(n);
		restore(n, 0, 0);
		int i = 0, j = 0;
		std::vector<int> st;
		while (i < n) {
			if (!st.empty() && st.back() == i) {
				printf("C");
				++i;
				st.pop_back();
				continue;
			}
			printf("S");
			st.push_back(p[j++]);
		}
		printf("\n");
		return 0;
	}

	printf("NO\n");

	return 0;
}