#include <bits/stdc++.h>

std::vector<int> gray(int n) {
	std::vector<int> ans(1 << n);
	for (int i = 0; i < (1 << n); ++i) {
		ans[i] = i ^ (i / 2);
	}
	return ans;
}

int main(void) {
	int n;
	std::cin >> n;

	int oldX;
	std::cin >> oldX;
	if (oldX == n) {
		return 0;
	}

	for (int i = 0; i < n; ++i) {
		auto masks = gray(n - i);
		int ptr = 0;
		while (true) {
			if (oldX == i) {
				int prev = ptr;
				int nxt = (ptr + 1) % masks.size();
				int diff = masks[nxt] ^ masks[prev];
				ptr = nxt;
				assert(diff != 0);
				assert(__builtin_popcount(diff) == 1);
				int bitId = __builtin_ctz(diff);
				
				int from = i;
				int to = from + bitId;
				std::cout << from + 1 << ' ' << to + 1 << std::endl;
				
				int x;
				std::cin >> x;
				if (x == n) {
					return 0;
				}
				
				oldX = x;
				continue;
			}

			std::cout << i + 2 << ' ' << n << std::endl;
			int x;
			std::cin >> x;
			if (x == n) {
				return 0;
			}

			if (x == oldX) {
				break;
			}
			if (x > oldX) {
				oldX = x;
				break;
			}

			// x < oldX
			if (x == i) {
				oldX = x;
				continue;
			} else {
				oldX = x;
				break;
			}
		}
	}

	assert(false);

	return 0;
}