#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct Point{
	int row;
	int col;
	int diag_ll_ur;
	int diag_ul_lr;
};

struct ChessCovered
{
	int col;
	int row;
	int diag_ll_ur;
	int diag_ul_lr;
	vector<Point> covered;

};

int main() {
	//#ifdef _DEBUG
	//	freopen("input.txt", "r",);
	//#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	vector<int> a(n), b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	string s;
	int j = 0;
	vector<int> stack;
	for (int i = 0; i < n; i++) {
		if (!stack.empty() && stack.back() == b[i]) {
			stack.pop_back();
			s += 'C';
		}
		else if (j < n) {
			stack.push_back(a[j++]);
			s += 'S';
			i--;
		}
		else {
			cout << "NO";
			return 0;
		}
	}
	cout << "YES" << endl << s;


	//int t;
	//cin >> t;
	//for (int test = 0; test < t; test++) {
	//	int n;
	//	cin >> n;
	//	ChessCovered data = { 1e9 + 1, 1e9 + 1, 1e9 + 1, 1e9 + 1, vector<Point>(0) };
	//	for (int i = 0; i < n; i++) {
	//		int x, y;
	//		cin >> x >> y;
	//		Point pt = { x, y, x - y, x + y };
	//		if (i == 0) {
	//			data.col = pt.col;
	//			data.row = pt.row;
	//			data.diag_ll_ur = pt.diag_ll_ur;
	//			data.diag_ul_lr = pt.diag_ul_lr;
	//		}
	//		else if (i == 1) {
	//			if (pt.col == data.col) {
	//				data.row = 
	//			} else if (pt.row == data.row) {

	//			}
	//			else if (pt.diag_ll_ur == data.diag_ll_ur) {

	//			}
	//			else if (pt.diag_ul_lr == data.diag_ul_lr) {

	//			}
	//			else {

	//			}
	//		}
	//	}
	//}

	//int n, P, M;
	//cin >> n >> P >> M;
	//if (n % 2 == 1 || n < 2 * P) {
	//	cout << 0;
	//	return 0;
	//}
	//int rem = n - P;
	//vector<vector<int>> dp(rem + 1, vector<int>(n + 1, 0));
	//dp[0][0] = 1;
	//for (int max = 1; max * 2 <= rem; max++) {
	//	vector<vector<int>> newDp(rem + 1, vector<int>(n + 1, 0));
	//	for (int sum = max; sum <= rem; sum++) {
	//		for (int p = 0; p <= rem; p++) {
	//			newDp[sum][p] = dp[sum][p];
	//			for (int k = max; k <= sum; k += max) {
	//				int nextP = (k / max) % 2 == 0 ? p : (p ^ max);
	//				newDp[sum][p] += dp[sum - k][nextP];
	//				while (dp[sum][p] > M)
	//					dp[sum][p] -= M;
	//			}
	//		}
	//	}
	//	swap(newDp, dp);
	//}
	//cout << dp[rem][P];
}

/*
4
10 20 30 40
1 2 51 52
*/