#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>

using namespace std;

bool check_l(int mid, int n, vector<int>& tL) {
	for (int i = n - mid; i < n; i++)
		if (tL[i] < i - (n - mid) + 1)
			return false;
	return true;
}

bool check_r(int mid, int n, vector<int>& tR) {
	for (int i = 0; i < mid; i++)
		if (tR[i] < mid - i)
			return false;
	return true;
}

int main() {
	//#ifdef _DEBUG
	//	freopen("input.txt", "r",);
	//#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> a(n);
	vector<int> b(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];

	vector<int> tL(n);
	int l = 0;
	for (int i = 0; i < n; i++) {
		while (l < n && b[l] < a[i])
			l++;
		tL[i] = l;
	}

	vector<int> tR(n);
	int r = n - 1;
	for (int i = n - 1; i >= 0; i--) {
		while (r >= 0 && b[r] > a[i])
			r--;
		tR[i] = n - r - 1;
	}

	l = 0, r = n + 1;
	while (l + 1 < r) {
		int mid = (l + r) / 2;
		if (check_l(mid, n, tL))
			l = mid;
		else 
			r = mid;
	}
	int L = l;
	l = 0, r = n + 1;
	while (l + 1 < r) {
		int mid = (l + r) / 2;
		if (check_r(mid, n, tR))
			l = mid;
		else
			r = mid;
	}
	int R = l;
	cout << L - (n - R) + 1 << endl;
	for (int i = n - R; i <= L; i++)
		cout << i << ' ';
}

/*
4
10 20 30 40
1 2 51 52
*/