#include <iostream>
#include <vector>

using namespace std;
using ll = long long;
vector<vector<vector<int>>> din;
int m;

int d(int x, int r, int mi) {
    if (r == 0 && x == 0) {
        return 1;
    }
    if (r<mi){
        return 0;
    }
    if (r < x) {
        return 0;
    }
    if (din[x][r][mi] != -1) {
        return din[x][r][mi];
    }
    ll ans = 0;
    for(int i = mi;i<r+1;i++){
        ans += d(x ^ i, r - i, i);
        ans%=m;
    }
    din[x][r][mi] = ans % m;
    return ans % m;
}

int main() {
    int n, p;
    cin >> n >> p >> m;
    for (int i = 0; i < 512; i++) {
        vector<vector<int>> a;
        for (int j = 0; j < n - p + 1; j++) {
            vector<int> b;
            for (int k = 0; k < n - p + 1; k++) {
                b.push_back(0);
            }
            a.push_back(b);
        }
        din.push_back(a);
    }

    for(int i = 0; i<=n- p;i++){//n
        for (int j=0;j<=i;++j){//x
            for (int k = 0;k<=i;++k){//min
                ll ans = 0;
                if(j==i)ans=1;
                if (i == 0 && j == 0) {
                    din[j][i][k]=1;
                    continue;
                }
                for (int r = k; r<=(i)/2;++r){
                   ans+=din[j^r][i-r][r];
                   ans%=m;
                }
                din[j][i][k] = ans;
            }
        }
    }
    int q = n - p;
    cout<<din[p][q][1];
}
