#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>


using namespace std;
using doubl = long double;


int main()
{
    int n,m;
    cin >> n >> m;
    vector<pair<doubl,int>>v(n*m);
    vector<int>w(n*m);
    for(int i=0;i<n*m;i++)
    {
        v[i].second=i;
    }
    for(int i=0;i<m;i++)
    {
        v[i].first=200000000*i+99500000;
    }
    for(int i=0;i<n;i++)
    {
        v[i*m].first=200000000*i+400000000*m;
    }
    for(int i=1;i<n;i++)
    {
        for(int j=1;j<m;j++)
        {
            char type;
            cin >> type;
            if(type=='2')
            {
                doubl x=v[i*m+j-1].first;
                doubl y=v[i*m-m+j-1].first;
                doubl z=v[i*m-m+j].first;
                if(y>x && y>z)
                {
                    v[i*m+j].first=(x+z)/2;
                }
                else {
                    if (y < x && y < z) {
                        v[i * m + j].first = (x + z) / 2;
                    }
                    else
                    {
                        v[i * m + j].first=max(x,z)+2;
                    }
                }
                if(j<m-1)
                {
                    if(v[i*m-m+j+1].first==v[i*m+j].first)
                    {
                        v[i*m+j].first=(v[i*m+j].first+max(x,z))/2;
                    }
                }
            }
            if(type=='1')
            {
                doubl x=v[i*m+j-1].first;
                doubl z=v[i*m-m+j-1].first;
                doubl y=v[i*m-m+j].first;
                if(y>x && y>z)
                {
                    v[i*m+j].first=(x+z)/2;
                }
                else {
                    if (y < x && y < z) {
                        v[i * m + j].first = (x + z) / 2;
                    }
                    else
                    {
                        v[i * m + j].first=max(x,z)+2;
                    }
                }
                if(j<m-1)
                {
                    if(v[i*m-m+j+1].first==v[i*m+j].first)
                    {
                        v[i*m+j].first=(v[i*m+j].first+max(x,z))/2;
                    }
                }
            }
            if(type=='3')
            {
                doubl y=v[i*m+j-1].first;
                doubl x=v[i*m-m+j-1].first;
                doubl z=v[i*m-m+j].first;
                if(y>x && y>z)
                {
                    v[i*m+j].first=(x+z)/2;
                }
                else {
                    if (y < x && y < z) {
                        v[i * m + j].first = (x + z) / 2;
                    }
                    else
                    {
                        v[i * m + j].first=max(x,z)+2;
                    }
                }
                if(j<m-1)
                {
                    if(v[i*m-m+j+1].first==v[i*m+j].first)
                    {
                        v[i*m+j].first=(v[i*m+j].first+max(x,z))/2;
                    }
                }
            }
        }
    }
    sort(v.begin(),v.end());
    for(int i=0;i<n*m;i++)
    {
        w[v[i].second]=i+1;
    }
    for(int i=0;i<n*m;i++)
    {
        cout << w[i] << " ";
        if(i%m==(m-1))
            cout << endl;
    }
}